\  
\ :
\ 1. .
\ 2.    .
\ 3.   
       

ONLY FORTH DEFINITIONS

\ S" search-wordlist.f" INCLUDED    \  
S" high-level-search-wordlist.f" INCLUDED   \  
                                            \  ,  
                                            \     5 
' CLASS-SEARCH-WORDLIST ' SEARCH-WORDLIST JMP

HERE 
ONLY FORTH DEFINITIONS
: +ORDER ( wid -- ) >R GET-ORDER 1+ R> SWAP SET-ORDER ;

: WITH ALSO ' EXECUTE ; IMMEDIATE
: ENDWITH PREVIOUS ; IMMEDIATE
: ?EXECUTE ?DUP IF EXECUTE THEN ;
    
VOCABULARY SUPERCLASS
ALSO SUPERCLASS DEFINITIONS
CONTEXT @ ,     \ wid 
0 ,             \  
0 ,             \ 
0 ,             \ 

0
1 CELLS -- CLASS-WID       \ wid         
1 CELLS -- CLASS-SIZE      \   
1 CELLS -- CLASS-CONSTR    \        
1 CELLS -- CLASS-DESTR     \         
CONSTANT /CLASS

USER-VALUE this             \   

: WID>CLASS ( wid -- class-area)  CELL+ @ NAME> >BODY CELL+ ;
\    
: CURR ( -- class-area) CURRENT @ WID>CLASS ;  

: xt-item-ext R> @ + ;  \     

: FIELD
    CREATE ['] xt-item-ext COMPILE, 
    CURR CLASS-SIZE @ DUP , + CURR CLASS-SIZE !
    DOES>  CFL + @ this + ;

1 CELLS NEGATE FIELD SELF
1 CELLS        FIELD PARENT

: (<SUPER) ( wid -- )        \ 
    DUP CURRENT @ CLASS!
    WID>CLASS CLASS-SIZE   CURR CLASS-SIZE 3 CELLS CMOVE
;

: <SUPER ' >BODY @ (<SUPER) ;

: ;CLASS PREVIOUS SET-CURRENT ;
: xt-exit-ext R> TO this ;
: xt-enter-ext R> this >R ['] xt-exit-ext >R >R TO this ;
: xt-enter-int R> CFL + >R ;

: M:
    WARNING @ WARNING 0!
    :
    POSTPONE xt-enter-int
    POSTPONE xt-enter-ext
    WARNING !
;

M: CONSTR PARENT @ CLASS-CONSTR @ ?EXECUTE ;
M: DESTR  PARENT @ CLASS-DESTR @ ?EXECUTE ;
: CONSTR: M: LATEST NAME> CURR CLASS-CONSTR ! ; IMMEDIATE
: DESTR:  M: LATEST NAME> CURR CLASS-DESTR ! ; IMMEDIATE
M: >PARENT PARENT @ @ +ORDER ;    \   
M: SIZE PARENT @ CLASS-SIZE @ ;    \   ( parent)

: INHERIT
    ?COMP
    SMUDGE
    LATEST DUP C@ 1+ PAD SWAP CMOVE
    SMUDGE     
    PAD FIND
    IF COMPILE, THEN
; IMMEDIATE

ALSO FORTH DEFINITIONS
: ->
    ' CFL + 
    STATE @
    IF
        COMPILE, 
    ELSE
        EXECUTE
    THEN
; IMMEDIATE

PREVIOUS DEFINITIONS

: (NEW) ( wid -- address-of-instance )
    WID>CLASS >R
    R@ CLASS-SIZE @ CELL+ ALLOCATE THROW
    R> OVER !
    CELL+ >R R@ => CONSTR R>
;    
    
PREVIOUS DEFINITIONS

: CLASS:
    GET-CURRENT
    VOCABULARY
    ALSO LATEST NAME> EXECUTE DEFINITIONS
    CONTEXT @ , 0 , 0 , 0 , 
    WITH SUPERCLASS
        [ CONTEXT @ ] LITERAL (<SUPER)
    ENDWITH
;

: SEE-> POSTPONE WITH POSTPONE => POSTPONE ENDWITH ; IMMEDIATE

: INSTANCE
    WITH SUPERCLASS
      POSTPONE WITH
      CREATE IMMEDIATE
      CONTEXT @ WID>CLASS ,  
      HERE DUP DUP => SIZE DUP ALLOT ERASE
      => CONSTR
      POSTPONE ENDWITH
      DOES>
          DUP @ @ +ORDER
          CELL+ POSTPONE LITERAL
          POSTPONE ->
          PREVIOUS
    ENDWITH
;

: NEW
    WITH SUPERCLASS
        POSTPONE WITH
        CONTEXT @ POSTPONE LITERAL
        ['] (NEW) STATE @ IF COMPILE, ELSE EXECUTE THEN
    ENDWITH
; IMMEDIATE

: DELETE ( address-of-instance -- )
    WITH SUPERCLASS
        >R R@ => DESTR 
        R@ IMAGE-BASE <
        R@ IMAGE-BASE IMAGE-SIZE + > OR
        IF
            R@ => PARENT FREE THROW
        THEN
        RDROP
    ENDWITH 
;


HERE SWAP - .( Size of class implementation is ) . CR