REQUIRE DEBUG? ~nn/lib/qdebug.f
REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE StartAppAsUserWait ~nn/lib/process.f
REQUIRE WIN-VER ~nn/lib/winver.f
REQUIRE ENV ~nn/lib/env.f
REQUIRE GLOBAL ~nn/lib/globalloc.f

\ : H. BASE @ >R HEX U. R> BASE ! ;

 UseDLL advapi32.dll

WINAPI: SetSecurityInfo advapi32.dll

0x37F CONSTANT WINSTA_ALL_ACCESS  
0x1FF CONSTANT DESKTOP_ALL_ACCESS 

0x8 CONSTANT INHERIT_ONLY
0x2 CONSTANT AclSizeInformation

1 CONSTANT TokenUser
2 CONSTANT TokenGroups

0 \ typedef struct _ACL_SIZE_INFORMATION { 
1 CELLS -- .AceCount \  DWORD   AceCount; 
1 CELLS -- .AclBytesInUse \  DWORD   AclBytesInUse; 
1 CELLS -- .AclBytesFree  \  DWORD   AclBytesFree; 
CONSTANT /ACL_SIZE_INFORMATION \ } ACL_SIZE_INFORMATION; 

0 \ typedef struct _ACE_HEADER { 
1 -- .AceType \   BYTE AceType; 
1 -- .AceFlags \   BYTE AceFlags; 
2 -- .AceSize \   WORD AceSize; 
\ } ACE_HEADER; 
DROP
0 \ typedef struct _SID_AND_ATTRIBUTES { 
1 CELLS -- .Sid        \  PSID  Sid; 
1 CELLS -- .Attributes \  DWORD Attributes; 
\ } SID_AND_ATTRIBUTES, *PSID_AND_ATTRIBUTES; 
CONSTANT /SID_AND_ATTRIBUTES



DEBUG?
[IF]

: (?ERR) ( ? a u -- )
    ROT ERR >R R@ IF ." ERROR # " R@ . TYPE CR ELSE 2DROP THEN R> THROW
;

: (?ERR2) ( ? a u -- )
    ROT >R R@ IF ." ERROR # " R@ . TYPE CR ELSE 2DROP THEN R> THROW ;

: ?ERR:
    1 PARSE
    POSTPONE SLITERAL
    POSTPONE (?ERR)
; IMMEDIATE
: ?ERR2:
    1 PARSE
    POSTPONE SLITERAL
    POSTPONE (?ERR2)
; IMMEDIATE
[ELSE]
: ?ERR:
    POSTPONE ERR
    POSTPONE THROW
    1 PARSE 2DROP
; IMMEDIATE
: ?ERR2:
    POSTPONE THROW
    1 PARSE 2DROP
; IMMEDIATE

[THEN]

: GetUserObjectDacl { h cbExtra \ cb si psd bPresent bDefaulted pdaclOld pdaclNew info pace -- *ACL }

\ ACL* GetUserObjectDacl( HANDLE h, DWORD cbExtra )
\ {
\    // At least one person complained about GetSecurityInfo failing with
\    // E_INVALIDARG, so I changed the code to use the older API
\    // and this seemed to fix the problem.
\    // But the GetSecurityInfo version was soooo much cleaner :-)
\    DWORD cb = 0;
\ CR ." 1:" .S
    0 TO cb
\    SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
    DACL_SECURITY_INFORMATION TO si
\    GetUserObjectSecurity( h, &si, 0, cb, &cb );
    AT cb cb 0 AT si h GetUserObjectSecurity DROP
    
\    if ( ERROR_INSUFFICIENT_BUFFER != GetLastError() )
\        Err( "GetUserObjectSecurity" );
    GetLastError ERROR_INSUFFICIENT_BUFFER <> 
        IF 
            0 ?ERR: GetUserObjectSecurity
        THEN

\    HANDLE hProcessHeap = GetProcessHeap();

\    void* psd = HeapAlloc( hProcessHeap, 0, cb );
\    if ( !psd )
\        Err( "HeapAlloc", E_OUTOFMEMORY );
    cb ALLOCATE THROW TO psd

\    si = DACL_SECURITY_INFORMATION;
    DACL_SECURITY_INFORMATION TO si
\    if ( !GetUserObjectSecurity( h, &si, psd, cb, &cb ) )
\        Err( "GetUserObjectSecurity" );
    AT cb cb psd AT si h GetUserObjectSecurity ?ERR: GetUserObjectSecurity 

\    BOOL bPresent, bDefaulted;
\    ACL* pdaclOld;
\    if ( !GetSecurityDescriptorDacl( psd, &bPresent, &pdaclOld, &bDefaulted ) )
\        Err( "GetSecurityDescriptorDac" );
    AT bDefaulted AT pdaclOld AT bPresent psd GetSecurityDescriptorDacl
        ?ERR: GetSecurityDescriptorDac

\    // get the size of the existing DACL
\    ACL_SIZE_INFORMATION info;
    /ACL_SIZE_INFORMATION ALLOCATE THROW TO info
\    if ( !GetAclInformation( pdaclOld, &info, sizeof info, AclSizeInformation ) )
\        Err( "GetAclInformation" );

    AclSizeInformation /ACL_SIZE_INFORMATION info pdaclOld GetAclInformation ?ERR: GetAclInformation1
\    // allocate enough memory for the existing DACL
\    // plus whatever extra space the caller requires
\    cb = info.AclBytesInUse + cbExtra;
\    ACL* pdaclNew = reinterpret_cast<ACL*>( HeapAlloc( hProcessHeap, 0, cb ) );
\    if ( !pdaclNew )
\        Err( "HeapAlloc" );

    info .AclBytesInUse @ cbExtra + TO cb
    cb ALLOCATE THROW TO pdaclNew


\    if ( !InitializeAcl( pdaclNew, cb, ACL_REVISION ) )
\        Err( "InitializeAc" );
    ACL_REVISION cb pdaclNew InitializeAcl ?ERR: InitializeAc
\    // copy over all the old aces to the new DACL
\    for ( DWORD i = 0; i < info.AceCount; ++i ){

    info .AceCount @ 0 
    ?DO
\        ACE_HEADER* pace = 0;
        0 TO pace
\        if ( !GetAce( pdaclOld, i, reinterpret_cast<void**>(&pace) ) )
\            Err( "GetAce" );
        AT pace I pdaclOld GetAce ?ERR: GetAce

\        if ( !AddAce( pdaclNew, ACL_REVISION, MAXDWORD, pace, pace->AceSize ) )
\            Err( "AddAce" );
        pace .AceSize W@ pace MAXDWORD ACL_REVISION pdaclNew AddAce ?ERR: AddAce
\    }
    LOOP
\    HeapFree( hProcessHeap, 0, psd );
    psd FREE THROW
    info FREE THROW
\    return pdaclNew;
    pdaclNew
\ }

;


: CalcAceSizeFromSid ( psid -- size )
\ DWORD CalcAceSizeFromSid( void* psid ){
\    return sizeof( ACCESS_ALLOWED_ACE ) - sizeof( DWORD ) + GetLengthSid( psid );
    8 SWAP GetLengthSid +
\ }
;
: AddAccessAllowedAceEx4 {  pSid AccessMask AceFlags dwAceRevision pAcl \ info pace -- ? }
\ // this is such a simple function, it's bizarre that we had to wait 'till W2K to get it
\ BOOL AddAccessAllowedAceEx4( PACL pAcl, DWORD dwAceRevision, DWORD AceFlags, DWORD AccessMask, PSID pSid ){
\    if ( !AddAccessAllowedAce( pAcl, dwAceRevision, AccessMask, pSid ) )
\        return FALSE;
    pSid AccessMask dwAceRevision pAcl AddAccessAllowedAce
\    DBG( DUP ERR ?DUP IF ." AddAccessAllowedAce=" . CR ELSE ." AddAccessAllowedAce ok" . CR THEN )
    0= IF FALSE EXIT THEN
\    ACL_SIZE_INFORMATION info;
    /ACL_SIZE_INFORMATION ALLOCATE THROW TO info
\    if ( !GetAclInformation( pAcl, &info, sizeof info, AclSizeInformation ) )
\        return FALSE;
    AclSizeInformation /ACL_SIZE_INFORMATION info pAcl GetAclInformation 0= IF FALSE EXIT THEN
\    ACE_HEADER* pace = 0;
    0 TO pace
\    if ( !GetAce( pAcl, info.AceCount - 1, reinterpret_cast<void**>(&pace) ) )
\        return FALSE;
    AT pace info .AceCount @ 1- pAcl GetAce 0= IF FALSE EXIT THEN
\    pace->AceFlags = static_cast<BYTE>(AceFlags);
    AceFlags pace .AceFlags C!
\    return TRUE;
    info FREE THROW
    TRUE
\ }
;
    
\ //BOOL AddAccessAllowedAceEx( PACL pAcl, DWORD dwAceRevision, DWORD AceFlags, DWORD AccessMask, PSID pSid );

: DeleteMatchingAces { psid pdacl \ pAce info -- }
\ void DeleteMatchingAces( ACL* pdacl, void* psid ){
\    ACL_SIZE_INFORMATION info;
    /ACL_SIZE_INFORMATION ALLOCATE THROW TO info
\    if ( !GetAclInformation( pdacl, &info, sizeof info, AclSizeInformation ) )
\        Err( "GetAclInformation" );
    AclSizeInformation /ACL_SIZE_INFORMATION info pdacl GetAclInformation ?ERR: GetAclInformation2

\    // it's a bit easier to delete aces while iterating backwards
\    // so that the iterator doesn't get honked up
\    DWORD i = info.AceCount;
    DBG( ." AceCount=" info .AceCount @ . CR )
    0 info .AceCount @ 1-
    ?DO \ I . CR KEY 27 = IF BYE THEN
\    while ( i-- ){
\        ACCESS_ALLOWED_ACE* pAce = 0;
        0 TO pAce
\        if ( !GetAce( pdacl, i, reinterpret_cast<void**>(&pAce) ) )
\            Err( "GetAce" );
        AT pAce I pdacl GetAce ?ERR: GetAce
\        if ( EqualSid( psid, &pAce->SidStart ) )
\            DeleteAce( pdacl, i );
        pAce 2 CELLS + ( .SidStart) psid EqualSid 
            IF I pdacl DeleteAce 
\               DBG( DUP ERR ?DUP IF ." DeleteAce=" . CR ELSE ." DeleteAce Ok" CR THEN )
               DROP THEN
\    }
    -1 +LOOP
    info FREE THROW
\ }
;

: ADD-ACCESS-ALLOWED-ACE
\  HEX .S
\  WIN-VER 4 = IF 
  AddAccessAllowedAceEx4 
\  ELSE AddAccessAllowedAceEx THEN
  ?ERR: AddAccessAllowedAceEx4
;

: GrantSessionSIDAccessToWinstationAndDesktop { htok bGrant \ tgs cbtgs psidLogonSession hws pdacl hd -- }
\ void GrantSessionSIDAccessToWinstationAndDesktop( HANDLE htok, bool bGrant ){
\    BYTE tgs[4096];
\    htok . CR
    4096 TO cbtgs
    cbtgs ALLOCATE THROW TO tgs
\    DWORD cbtgs = sizeof tgs;
\    HANDLE hProcessHeap = GetProcessHeap();
\    if ( !GetTokenInformation( htok, TokenGroups, tgs, cbtgs, &cbtgs ) )
\        Err( "GetTokenInformation" );
    AT cbtgs cbtgs tgs TokenGroups htok GetTokenInformation ?ERR: GetTokenInformation
\    tgs tgs @ /SID_AND_ATTRIBUTES * CELL+ DUMP CR
\    const TOKEN_GROUPS* ptgs = reinterpret_cast<TOKEN_GROUPS*>(tgs);
\    const SID_AND_ATTRIBUTES* it = ptgs->Groups;
\    const SID_AND_ATTRIBUTES* end = it + ptgs->GroupCount;

    FALSE    
    tgs CELL+ tgs @ /SID_AND_ATTRIBUTES * OVER + SWAP
\    while ( end != it ){
    ?DO
\        if ( it->Attributes & SE_GROUP_LOGON_ID )
\            break;
        I .Attributes @ SE_GROUP_LOGON_ID AND
        IF DROP TRUE I .Sid @ ( DUP H. CR) TO psidLogonSession LEAVE THEN
\        ++it;
\    }
    /SID_AND_ATTRIBUTES +LOOP
\    if ( end == it )
\        Err( "UNEXPECTED: No Logon SID in TokenGroups" );
    0= ABORT" UNEXPECTED: No Logon SID in TokenGroups"

\    void* psidLogonSession = it->Sid;

\     HWINSTA hws = GetProcessWindowStation();
    GetProcessWindowStation TO hws
\    if ( !hws )
\        Err( "GetProcessWindowStation" );
    hws ?ERR: GetProcessWindowStation
\    {
\        ACL* pdacl = 0;
        0 TO pdacl
\        if ( bGrant ){

        bGrant
        IF
\            // get the existing DACL, with enough extra space for adding a couple more aces
\            const DWORD cbExtra = 2 * CalcAceSizeFromSid( psidLogonSession );
            psidLogonSession CalcAceSizeFromSid 2*
\            pdacl = GetUserObjectDacl( hws, cbExtra );
            hws SWAP GetUserObjectDacl TO pdacl
\            // grant the logon session all access to winsta0
\            if ( !AddAccessAllowedAce( pdacl, ACL_REVISION,
\                                        WINSTA_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
\                                        psidLogonSession ) )
\                Err( "AddAccessAllowedAce" );
            psidLogonSession 
            WINSTA_ALL_ACCESS STANDARD_RIGHTS_REQUIRED OR
            ACL_REVISION pdacl 
            AddAccessAllowedAce
\       DBG( DUP ERR ?DUP IF ." AddAccessAllowedAce=" . CR ELSE ." AddAccessAllowedAce ok" . CR THEN )
            ?ERR: AddAccessAllowedAce
\            // grant the logon session all access to any new desktops created in winsta0
\            // by adding an inherit-only ace
\            int ver=0xFF & GetVersion();
\            int res=0;
\            if ( !AddAccessAllowedAceEx4( pdacl, ACL_REVISION,
\                                        SUB_CONTAINERS_AND_OBJECTS_INHERIT | INHERIT_ONLY,
\                                        DESKTOP_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
\                                        psidLogonSession ))
\                Err( "AddAccessAllowedAceEx" );
            psidLogonSession
            DESKTOP_ALL_ACCESS STANDARD_RIGHTS_REQUIRED OR
            0x3 ( SUB_CONTAINERS_AND_OBJECTS_INHERIT)  INHERIT_ONLY OR
            ACL_REVISION pdacl 
            ADD-ACCESS-ALLOWED-ACE
\        }
\        else
\        {
        ELSE
\            pdacl = GetUserObjectDacl( hws, 0 );
            hws 0 GetUserObjectDacl TO pdacl
\            DeleteMatchingAces( pdacl, psidLogonSession );
            psidLogonSession pdacl DeleteMatchingAces 
\        }
        THEN

\        // apply the changes to winsta0
\        // unlike GetSecurityInfo, SetSecurityInfo has no troubles on SP3 :-)
\        DWORD err = SetSecurityInfo( hws, SE_WINDOW_OBJECT, DACL_SECURITY_INFORMATION, 0, 0, pdacl, 0 );
\        if ( err )
\            Err( "SetSecurityInfo", err );
         0 pdacl 0 0 DACL_SECURITY_INFORMATION 7 ( SE_WINDOW_OBJECT) hws SetSecurityInfo ?ERR2: SetSecurityInfo1

\        HeapFree( hProcessHeap, 0, pdacl );
\        pdacl ." pdacl=" . CR
        pdacl FREE THROW
\    }

\    CloseWindowStation( hws );
    hws CloseWindowStation DROP

\    HDESK hd = GetThreadDesktop( GetCurrentThreadId() );
\    if ( !hd )
\        Err( "GetThreadDesktop" );
    
    GetCurrentThreadId GetThreadDesktop DUP TO hd  ?ERR: GetThreadDesktop
   
\    {
\        ACL* pdacl = 0;
        0 TO pdacl
\        if ( bGrant ){
        bGrant
        IF
\            // get the existing DACL, with enough extra space for adding a couple more aces
\            const DWORD cbExtra = CalcAceSizeFromSid( psidLogonSession );
           psidLogonSession CalcAceSizeFromSid 2*
\            pdacl = GetUserObjectDacl( hd, cbExtra );
           hd SWAP GetUserObjectDacl TO pdacl

\            // grant the logon session all access to the default desktop
\            if ( !AddAccessAllowedAce( pdacl, ACL_REVISION,
\                                        DESKTOP_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
\                                        psidLogonSession ) )
\                Err( "AddAccessAllowedAce" );
            psidLogonSession
            DESKTOP_ALL_ACCESS STANDARD_RIGHTS_REQUIRED OR
            ACL_REVISION pdacl
            AddAccessAllowedAce
\    DBG( DUP ERR ?DUP IF ." AddAccessAllowedAce=" . CR ELSE ." AddAccessAllowedAce ok" . CR THEN )            
            ?ERR: AddAccessAllowedAce
\        }
\        else
\        {
        ELSE
\            pdacl = GetUserObjectDacl( hd, 0 );
            hd 0 GetUserObjectDacl TO pdacl
\            DeleteMatchingAces( pdacl, psidLogonSession );
            psidLogonSession pdacl DeleteMatchingAces
\        }
        THEN

\        // apply the changes to the default desktop
\        // unlike GetSecurityInfo, SetSecurityInfo has no troubles on SP3 :-)
\        DWORD err = SetSecurityInfo( hd, SE_WINDOW_OBJECT, DACL_SECURITY_INFORMATION, 0, 0, pdacl, 0 );
\        if ( err )
\            Err( "SetSecurityInfo", err );
        0 pdacl 0 0 DACL_SECURITY_INFORMATION 7 ( SE_WINDOW_OBJECT) hd SetSecurityInfo  ?ERR2: SetSecurityInfo2
\        HeapFree( hProcessHeap, 0, pdacl );
\        pdacl ." pdacl=" . CR
        pdacl FREE THROW
\    }

\    CloseDesktop( hd );
    hd CloseDesktop DROP
\ }
;

\ typedef BOOL (WINAPI * CREATE_ENVIRONMENT_BLOCK) ( void**, HANDLE, BOOL );
\ typedef BOOL (WINAPI * DESTROY_ENVIRONMENT_BLOCK) ( void* );
\ typedef BOOL (WINAPI * LOAD_USER_PROFILE) ( HANDLE, PROFILEINFO* );
\ typedef BOOL (WINAPI * UNLOAD_USER_PROFILE) ( HANDLE, HANDLE );
\ CREATE_ENVIRONMENT_BLOCK    m_createEnvironmentBlock;
\ DESTROY_ENVIRONMENT_BLOCK   m_destroyEnvironmentBlock;
\ LOAD_USER_PROFILE           m_loadUserProfile;
\ UNLOAD_USER_PROFILE         m_unloadUserProfile;

\ HMODULE m_hModule;
\ void _getAddr( const char* psz, FARPROC* pProc ){
\     *pProc = (FARPROC)GetProcAddress( m_hModule, psz ) ;
\     if ( !*pProc )
\         Err( "GetProcAddress" );
\ }

\ void UserEnvInterface(){
\    m_hModule = LoadLibrary( "userenv.dll" );
\    if ( !m_hModule )
\        Err( "LoadLibrary( userenv.dll )" );
\    _getAddr( "CreateEnvironmentBlock",  (FARPROC *)&m_createEnvironmentBlock );
\    _getAddr( "DestroyEnvironmentBlock", (FARPROC *)&m_destroyEnvironmentBlock );
\    _getAddr( "LoadUserProfileW",        (FARPROC *)&m_loadUserProfile );
\    _getAddr( "UnloadUserProfile",       (FARPROC *)&m_unloadUserProfile );
\ }

USER m_hModule
USER pProfInfo
USER AsLoggedOk

: userenv.dll ( a u -- ?)
    m_hModule @ 0= 
    IF 
        S" userenv.dll" DROP LoadLibraryA DUP ?ERR: LoadLibrary( userenv.dll )
        m_hModule !
    THEN
    DROP
    m_hModule @ GetProcAddress DUP ?ERR: GetProcAddress
    API-CALL
;

: m_createEnvironmentBlock     S" CreateEnvironmentBlock"  userenv.dll ;
: m_destroyEnvironmentBlock    S" DestroyEnvironmentBlock" userenv.dll ;
: m_loadUserProfile            S" LoadUserProfileW"        userenv.dll ;
: m_unloadUserProfile          S" UnloadUserProfile"       userenv.dll ;

0 [IF]
VARIABLE <xx>
: (xx) ." Step: " . CR ;
: xx
    <xx> @ <xx> 1+!
    POSTPONE LITERAL
    POSTPONE (xx)
; IMMEDIATE
[THEN]

: CreateEnvironmentBlock ( htok -- )
    1 SWAP APP-ENV-BLOCK m_createEnvironmentBlock ?ERR: m_createEnvironmentBlock
;
: loadUserProfile { htok \ szUserName cchUserName -- }
    htok ImpersonateLoggedOnUser ?ERR: ImpersonateLoggedOnUser

    128 TO cchUserName
    cchUserName ALLOCATE THROW TO szUserName
    AT cchUserName szUserName GetUserNameA ?ERR: GetUserName

    RevertToSelf DROP

    8 CELLS ALLOCATE THROW pProfInfo !
    8 CELLS pProfInfo @ !
    0       pProfInfo @ CELL+ !
    szUserName pProfInfo @ 2 CELLS + !
    pProfInfo @ htok m_loadUserProfile ?ERR: m_loadUserProfile
;

:NONAME { load_profile htok \ szUserName cchUserName -- }
    APP-ENV-BLOCK 0!
    pProfInfo 0!
    load_profile 
    IF
        RevertToSelf DROP
        AsLoggedOk @ 0= IF htok TRUE ['] GrantSessionSIDAccessToWinstationAndDesktop CATCH IF 2DROP THEN THEN
        htok ['] loadUserProfile CATCH IF DROP THEN
        htok ['] CreateEnvironmentBlock CATCH IF DROP APP-ENV-BLOCK 0! THEN
        htok ImpersonateLoggedOnUser ?ERR: ImpersonateLoggedOnUser
    THEN
\    szUserName FREE DROP
;

: LoadUserProfile ( load_profile? htok -- ) 
    DBG( ." LoadUserProfile[" DUP . ." ]=" )
    LITERAL CATCH ?DUP 
    IF 
        DBG( DUP . CR )
        2DROP 
    ELSE
        DBG( ." ok" CR )
    THEN ;

:NONAME  { htok -- }
    APP-ENV-BLOCK @ ?DUP IF m_destroyEnvironmentBlock DROP THEN
    pProfInfo @ ?DUP 
    IF 7 CELLS + @ htok m_unloadUserProfile DROP 
       pProfInfo @ 2 CELLS + @ FREE DROP
       pProfInfo @ FREE DROP
    THEN
    AsLoggedOk @ 0= IF htok FALSE ['] GrantSessionSIDAccessToWinstationAndDesktop CATCH IF 2DROP THEN THEN
\    htok CloseHandle DROP

    m_hModule @ ?DUP IF FreeLibrary DROP THEN
;

: UnloadUserProfile LITERAL CATCH IF DROP THEN ;

<EOF>

: (StartAppAsUserWithProfile) { si szcmd u1 htok0 evt \ htok szUserName cchUserName profinfo pEnvBlock error -- ? }
    AT htok 1 ( <-TokenPrimary) 2 ( <-SecurityImpersonation) 0 0 htok0 DuplicateTokenEx 
            ?ERR: DuplicateTokenEx                                                   

    htok TRUE GrantSessionSIDAccessToWinstationAndDesktop

    1024 ALLOCATE THROW TO szUserName
    1024 TO cchUserName
    htok ImpersonateLoggedOnUser ?ERR: ImpersonateLoggedOnUser

    AT cchUserName szUserName GetUserNameA ?ERR: GetUserName
    RevertToSelf DROP

    8 CELLS ALLOCATE THROW TO profinfo
    8 CELLS profinfo !
    0       profinfo CELL+ !
    szUserName profinfo 2 CELLS + !
    profinfo htok m_loadUserProfile ?ERR: m_loadUserProfile

    0 TO pEnvBlock
     FALSE htok AT pEnvBlock m_createEnvironmentBlock ?ERR: m_createEnvironmentBlock

    0 TO error
    evt SetEvent DROP

    pEnvBlock APP-ENV-BLOCK !
    APP-Flags @ CREATE_UNICODE_ENVIRONMENT OR APP-Flags !
    si szcmd u1 htok StartAppAsUserWait DUP 0= IF GetLastError TO error THEN


    pEnvBlock m_destroyEnvironmentBlock DROP

    profinfo 7 CELLS + @ htok m_unloadUserProfile DROP

    htok FALSE GrantSessionSIDAccessToWinstationAndDesktop

    htok CloseHandle DROP

    szUserName FREE THROW
    m_hModule @ FreeLibrary DROP
    error SetLastError DROP
;

0
1 CELLS -- .si
1 CELLS -- .szcmd
1 CELLS -- .htok
1 CELLS -- .sacode
1 CELLS -- .sares
1 CELLS -- .saerr
1 CELLS -- .saevt
1 CELLS -- .saflags
1 CELLS -- .sadir
CONSTANT /SAAUWP

: SAAUWPfree { buf -- }
    GLOBAL
    buf .si @ FREE DROP
    buf .szcmd @ FREE DROP
    buf FREE DROP
    LOCAL
;

:NONAME { buf -- }
    buf .saflags @ APP-Flags !
    buf .sadir   @ APP-Dir !
    buf .si @
    buf .szcmd @ ASCIIZ> 2DUP TYPE CR
    buf .htok @
    buf .saevt @ 
    ['] (StartAppAsUserWithProfile) CATCH ?DUP
    IF buf .saerr ! 2DROP 2DROP FALSE 
    ELSE 
        DUP ERR ( DUP . CR) buf .saerr !
    THEN
    buf .sares !
    ExitCodeProc buf .sacode !
; TASK: SAAUWP

: SAAUWPbuf { si szcmd u1 htok \ buf -- buf }
    GLOBAL
    /SAAUWP ALLOCATE THROW TO buf
    szcmd u1 S>ZALLOC buf .szcmd !
    si ?DUP IF 
              /STARTUPINFO ALLOCATE THROW DUP buf .si !
              /STARTUPINFO CMOVE
            ELSE
                buf .si 0!
            THEN
    LOCAL
    htok buf .htok !
    0 0 1 0 CreateEventA buf .saevt !
    APP-Dir @ buf .sadir !
    APP-Flags @ buf .saflags !
    buf
;


: (SAAUWP) { si szcmd u1 htok timeout \ buf h -- ? }
    si szcmd u1 htok SAAUWPbuf TO buf
    buf SAAUWP START TO h
    30000 buf .saevt @ WaitForSingleObject DROP
    buf .saevt @ CloseHandle DROP
    timeout h WaitForSingleObject WAIT_TIMEOUT =
    h CLOSE-FILE DROP
    IF TRUE 0
    ELSE
        buf .sares @
        buf .saerr @ 
        buf .sacode @ TO ExitCodeProc 
    THEN
    buf SAAUWPfree
\    THROW
    DROP
;

: StartAppAsUserWithProfile ( si szcmd u1 htok -- ?)
    1000 (SAAUWP) ;

: StartAppAsUserWithProfileWait  ( si szcmd u1 htok -- ?)
    INFINITE (SAAUWP) ;
 
<EOF>
: test { \ htok -- }
\    .S
    0 S" e:\win\the bat!1\thebat.exe /NOLOGO" 
    0 TO htok
    AT htok 
    LOGON32_PROVIDER_DEFAULT 
    LOGON32_LOGON_INTERACTIVE 
    S" mycomputer" DROP
    S" COMPUTERNAME" ENV DROP
    S" Nicholas"  DROP
    LogonUserA ?ERR: LogonUser
    htok
    StartAppAsUserWithProfile . CR
\    .S
    htok CloseHandle DROP
;
1 2 3 test
