REQUIRE { ~nn/lib/locals.f
REQUIRE DAYS ~nn/lib/time.f
REQUIRE .R lib/ext/core-ext.f

\      (., " 
\   ", ., "", 1988,    [1]):
\ 
\ a = year % 4 
\ b = year % 7 
\ c = year % 19 
\ d = ( 19 * c + 15 ) % 30 
\ e = ( 2 * a + 4 * b - d + 34 ) % 7
\ month = 3 + (d + e + 21) / 31 
\ day = ( d + e + 21 ) % 31 + 1 
: OrthodoxEasterOld { year \ a b c d e -- mon day }
    year 4 MOD TO a
    year 7 MOD TO b
    year 19 MOD TO c
    19 c * 15 + 30 MOD TO d
    a 2* b 4 * + d - 34 + 7 MOD TO e
    d e + 21 + DUP 31 / 3 +
    SWAP 31 MOD 1+
;

\                15    16    17    18    19    20    21
CREATE OrthOffs  10 C, 10 C, 11 C, 12 C, 13 C, 13 C, 14 C,
: ToNewStyle { y m d -- y1 m1 d1 }
    y m d   y 100 / 15 - OrthOffs + C@  DAY+ ;

: OrthodoxEaster DUP OrthodoxEasterOld ToNewStyle ROT DROP ;

\ 
\        :
\ 
\ century = year/100 
\ g = year % 19 
\ k = (century - 17)/25 
\ i = (century - century/4 - (century - k)/3 + 19*g + 15) % 30 
\ i = i - (i/28)*(1 - (i/28)*(29/(i + 1))*((21 - g)/11)) 
\ j = (year + year/4 + i + 2 - century + century/4) % 7 
\ l = i - j 
\ Month = 3 + (l + 40)/44 
\ Day = l + 28 - 31*(Month/4)
: CatholicEaster { year \ cent g k i j l -- mon day }
    year 100 / TO cent
    year 19 MOD TO g
    cent 17 - 25 / TO k
    cent cent 4 / - cent k - 3 / - g 19 * + 15 + 30 MOD TO i
    i  i 28 /  1  i 28 / 29 i 1+ / * 21 g - 11 / * - * - TO i
    year  year 4 / + i + 2 + cent - cent 4 / + 7 MOD TO j
    i j - TO l
    3  l 40 + 44 / +  ( mon)
    DUP 4 / 31 * l 28 + SWAP -
;
: .dt ( m d) SWAP 2 .R  ." ." . ;
: .Easter ( from to -- )
    ." Year    Old Style      New Style       Catholic" CR
    1+ SWAP ?DO 
            I . ."  -  "
            I OrthodoxEasterOld .dt  9 EMIT 9 EMIT
            I OrthodoxEaster    .dt    9 EMIT 9 EMIT
            I CatholicEaster    .dt  CR    
    LOOP ;
1995 2010 .Easter CR