\ Copy Dir

REQUIRE FOR-FILES ~nn/lib/for-files3.f
REQUIRE GetFileSA ~nn/lib/security/secinfo.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE MAKE-DIRS ~nn/lib/makedirs.f
REQUIRE FIND-MASK ~nn/lib/masks.f

USER COPY-SA?

GET-CURRENT
VOCABULARY COPY-DIR-VOC
ALSO COPY-DIR-VOC DEFINITIONS
USER DST
USER SRC
USER-VALUE DST-BUF
USER-VALUE SRC-BUF
USER-VALUE BUF
10240 CONSTANT BUF-SIZE
USER-VALUE BEFORE-DIR
USER-VALUE BEFORE-FILE

: DST@ DST @ ASCIIZ> ;
: SRC@ SRC @ ASCIIZ> ;
: DIR+ >R R@ ZPLACE S" \" R@ +ZPLACE R@ +ZPLACE  R> ASCIIZ> ;
: DST+ DST@ DST-BUF DIR+ ;
: SRC+ SRC@ SRC-BUF DIR+ ;

: DIR-INIT
    TO BEFORE-FILE TO BEFORE-DIR
    DST @ 0=
    IF
        MAX_PATH ALLOCATE THROW DST !
        MAX_PATH ALLOCATE THROW SRC !
        1024 ALLOCATE THROW TO DST-BUF
        1024 ALLOCATE THROW TO SRC-BUF
        BUF-SIZE ALLOCATE THROW TO BUF
    THEN
    DST @ ZPLACE
    SRC @ ZPLACE
;

: DIR-FREE
    SRC @ FREE THROW
    DST @ FREE THROW
    SRC-BUF FREE THROW
    DST-BUF FREE THROW
    BUF FREE THROW
;
: DIR-SA ( a u - ) COPY-SA? @ IF GetDirSA ELSE 2DROP 0 THEN MAKE-DIR-SA ! ;     

PREVIOUS
SET-CURRENT

: (COPY-FILE) { a1 u1 a2 u2 flag_sa \ fh1 fh2 -- }
    [ ALSO COPY-DIR-VOC ]
    a2 u2 DELETE-FILE DROP
    a1 u1 R/O OPEN-FILE-SHARED THROW TO fh1
    fh1 0 
    CREATE_ALWAYS
    flag_sa IF fh1 GetHSA ELSE 0 THEN
    3 GENERIC_WRITE a2 CreateFileA 
    DUP INVALID_HANDLE_VALUE <> ERR THROW TO fh2
    
    BEGIN BUF BUF-SIZE fh1 READ-FILE THROW ?DUP WHILE
        BUF SWAP fh2 WRITE-FILE THROW
\        COPY-FILE-XT @ CATCH THROW
    REPEAT

    fh1 CLOSE-FILE THROW
    fh2 CLOSE-FILE THROW
    [ PREVIOUS ]
;

: COPY-FILE ( a1 u1 a2 u2 flag_sa -- ior)
    ['] (COPY-FILE) CATCH
    DUP IF >R 2DROP 2DROP DROP R> THEN
;

: COPY-DIR ( a1 u1 a2 u2 before_dir before_file --)
    [ ALSO COPY-DIR-VOC ]
    DIR-INIT
    SRC@ DIR-SA  DST@ MAKE-DIRS THROW
    SRC@ S" \*.*" S+ OVER >R
    FOR-FILES
        FOUND-RELPATH FIT-PATH?
        IF
            IS-DIR? 
            IF 
                FF-RECURSIVE? @
                IF 
                
                   FOUND-RELPATH SRC+ 
\                   ." Dir:" 2DUP TYPE CR
                   DIR-SA
                   FOUND-RELPATH DST+ MAKE-DIR
                THEN
            ELSE
                FOUND-RELPATH SRC+ \ ." File:" 2DUP TYPE CR
                FOUND-RELPATH DST+
                COPY-SA? @ COPY-FILE
            THEN
        THEN
    ;FOR-FILES
    R> FREE THROW
    DIR-FREE
    [ PREVIOUS ]
;

: FIT-PATH? ( a u -- ?)
    MaskList
    IF MaskList @
        IF
           2DUP MaskList FIND-MASK
        ELSE TRUE THEN
    ELSE TRUE THEN
    >R
    XMaskList
    IF XMaskList @
        IF
           2DUP XMaskList FIND-MASK
        ELSE FALSE THEN
    ELSE FALSE THEN
    0= >R
    2DROP
    R> R> AND
;

( 
: test
    RECURSIVE
    TRUE COPY-SA? !
    S" e:\home\src\backup2"
    S" e:\tmp\backup2"
    0 0 COPY-DIR
;
test
)