\ REQUIRE GetFileSA ~nn/lib/security/secinfo.f
REQUIRE GetFileSA ~nn/lib/sec/file.f
REQUIRE MAKE-DIRS ~nn/lib/makedirs.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
\ REQUIRE ONLYDIR ~nn/lib/filename.f

\ WINAPI: SetFileAttributesA KERNEL32.DLL
WINAPI: GetFileTime KERNEL32.DLL
WINAPI: SetFileTime KERNEL32.DLL
WINAPI: GetFileAttributesA KERNEL32.DLL
\ WINAPI: SetFileAttributesA KERNEL32.DLL


102400 VALUE BUF-SIZE

VARIABLE COPY-DIR-ATTRIBUTES? TRUE COPY-DIR-ATTRIBUTES? !

GET-CURRENT
VOCABULARY COPY-FILE-VOC
ALSO COPY-FILE-VOC DEFINITIONS

USER FH1
USER FH2
VARIABLE BUF
USER SRC
USER DST
USER SA?
USER PROPER-COPY

: CreateDst0 ( -- ior)
    FILE_ATTRIBUTE_NORMAL DST @ SetFileAttributesA DROP
    0 0
    CREATE_ALWAYS
    SA? @ IF SRC @ ASCIIZ> GetFileSA ELSE 0 THEN
    3 GENERIC_WRITE  DST @ CreateFileA
    DUP INVALID_HANDLE_VALUE <> ERR
    SWAP FH2 !
;

: OpenSrc ( -- ior) SRC @ ASCIIZ> R/O OPEN-FILE-SHARED SWAP FH1 ! ;


SET-CURRENT

: COPY-DIR { a1 u1 a2 u2 \ dir1 dir2 -- ior }
    MAX_PATH ALLOCATE9x THROW TO dir1 a1 u1 dir1 ZPLACE
    MAX_PATH ALLOCATE9x THROW TO dir2 a2 u2 dir2 ZPLACE
    SA? @ IF dir1 u1 GetFileSA ELSE 0 THEN
    dir2 u2 CreateDirSA
    ( ior)
\    ." --- " DUP . CR
    DUP 0= COPY-DIR-ATTRIBUTES? @ AND
    IF
\        ." Get dir attributes: " dir1 ASCIIZ> TYPE SPACE
        dir1 GetFileAttributesA \ DUP .  GetLastError . CR    
\        ." Set dir attributes: " a2 u2 TYPE SPACE 
        DUP -1 ( INVALID_FILE_ATTRIBUTES) <>
        IF
            dir2 SetFileAttributesA \ DUP . GetLastError . 
            DROP
        ELSE DROP THEN
        \ CR
    THEN
    dir1 FREE9x DROP
    dir2 FREE9x DROP
;

: COPY-DIRS { a1 u1 a2 u2 -- ior }
\      a1 u1 TYPE CR
\      a2 u2 TYPE CR
    a1 u1 a2 u2 COPY-DIR ?DUP 0= IF 0 EXIT THEN
    DUP ERROR_PATH_NOT_FOUND?
    IF DROP
       a1 u1 DROP-RIGHT-DIR
       IF
          a2 u2 DROP-RIGHT-DIR
          IF
             RECURSE ?DUP 0=
             IF  
                 a1 u1 a2 u2 COPY-DIR
             THEN
          ELSE
            ERROR_BAD_PATHNAME
          THEN
       ELSE
          ERROR_BAD_PATHNAME
       THEN
    THEN
;

: COPY-DIRS-SA ( a1 u1 a2 u2 sa? -- ior )
    SA? ! COPY-DIRS
;

GET-CURRENT
DEFINITIONS

: CopyDirs ( asrc usrc adst udst  -- ior )
    COPY-DIRS
\      SA? @
\      IF
\          COPY-DIRS
\      ELSE
\          2SWAP 2DROP
\          MAKE-DIR-SA 0!
\          MAKE-DIRS
\      THEN
;

: FH2-CLOSE FH2 @ ?DUP IF CLOSE-FILE DROP FH2 0! THEN ;
: FH1-CLOSE FH1 @ ?DUP IF CLOSE-FILE DROP FH1 0! THEN ;

: CF-FREE
\    DST @ ?FREE
\    SRC @ ?FREE
\    BUF @ ?FREE

    FH1-CLOSE
    FH2-CLOSE
;


: SetDstTime&Attrib { \ tc ta tw -- }
    0 0 SP@ TO tc
    0 0 SP@ TO ta
    0 0 SP@ TO tw
    tw ta tc FH1 @ GetFileTime
    IF  tw ta tc FH2 @ SetFileTime DROP THEN
    2DROP 2DROP 2DROP
    
    CF-FREE \ for 9x: archive attribute
    
    SRC @ GetFileAttributesA DUP -1 <>
        IF DST @ SetFileAttributesA THEN DROP
;

: CreateDst ( -- ior)
    CreateDst0
    DUP ERROR_PATH_NOT_FOUND?
    IF DROP
       SRC @ ASCIIZ> DROP-RIGHT-DIR
       IF
         DST @ ASCIIZ> DROP-RIGHT-DIR
         IF CopyDirs ?DUP 0= IF CreateDst0 THEN
         ELSE ERROR_BAD_PATHNAME THEN
       ELSE ERROR_BAD_PATHNAME THEN
    THEN
\    DUP 0=  IF SetDstTime THEN
;

: (PROPER-COPY)
    BEGIN BUF @ BUF-SIZE FH1 @ READ-FILE THROW ?DUP WHILE
        BUF @ SWAP FH2 @ WRITE-FILE THROW
    REPEAT
;

: (COPY-FILE) ( a1 u1 a2 u2 sa? xt -- )
    PROPER-COPY !
\    DST 0! SRC 0!
    FH1 0! FH2 0!
\    BUF 0!
    SA? !

    DST @ 0= IF
                MAX_PATH ALLOCATE THROW DST !
                MAX_PATH ALLOCATE THROW SRC ! THEN
    DST @ ZPLACE   SRC @ ZPLACE

    BUF @ 0= IF BUF-SIZE GLOBAL ALLOCATE LOCAL THROW BUF ! THEN


    OpenSrc THROW
    CreateDst THROW
    
\    SRC @ ASCIIZ> TYPE ."  --> " DST @ ASCIIZ> TYPE CR
\    FH1 @ CLOSE-FILE DROP FH1 0!
\    FH2 @ CLOSE-FILE DROP FH2 0!
\    FALSE DST @ SRC @ CopyFileA ERR THROW

    PROPER-COPY @ EXECUTE

\    CF-FREE
    
    SetDstTime&Attrib \ also perform CF-FREE

;

PREVIOUS
SET-CURRENT

: COPY-FILE ( a1 u1 a2 u2 sa? -- ior )
    [ ALSO COPY-FILE-VOC ]
    ['] (PROPER-COPY) ['] (COPY-FILE) CATCH DUP
    IF >R 2DROP 2DROP 2DROP R> CF-FREE THEN
    [ PREVIOUS ]
;

(
: t
    S" E:\home\nick\books\Antiq\Livi\get.cmd"
    S" e:\tmp\books\Antiq\Livi\get.cmd" TRUE
    COPY-FILE THROW
;
t
)