\ tables
REQUIRE CLASS: ~nn/class/class.f
REQUIRE DoList ~nn/lib/list.f
REQUIRE [NONAME ~nn/lib/noname.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE <TIB ~nn/lib/tib.f
REQUIRE QUOTE ~nn/lib/subst1.f
REQUIRE GET ~nn/lib/mutex.f
REQUIRE MAKE-FILE ~nn/lib/file.f
REQUIRE InDict? ~nn/lib/free.f
REQUIRE ON ~nn/lib/onoff.f
REQUIRE GLOBAL ~nn/lib/globalloc.f


: tf ( n | name -- n+1) DUP CONSTANT 1+ ;

CLASS: TABLE
    var vFileName       \ filename of table
    var vFieldCounter   \ number of fields
    var vCursor         \ current record
    var vRecordList     \ list of records
    var vResource       \ mutex
    var buf
    var fh
    var vUpdate
\   :
\  vRecordList    
\          

VM: sget @ ?DUP IF ASCIIZ> ELSE S" " THEN ;
VM: sset ( a1 u1 a2 -- ) GLOBAL DUP @ ?FREE >R S>ZALLOC R> ! LOCAL ;
VM: sset2 ( a1 u1 a2 -- ) DUP InDict? IF HERE 1+ SWAP ! S", 0 C, ELSE sset THEN ;
M: buf@ buf @ ;
M: fh@ fh @ ;

M: seize vResource GET ;
M: release vResource RELEASE ;

M: getFileName  vFileName sget ;
M: setFileName  vFileName sset2 ;
M: getFieldCounter vFieldCounter @ ;
M: setFieldCounter vFieldCounter ! ;
M: getCursor vCursor @ ;
M: setCursor vCursor ! ;

M: freeAll
    GLOBAL
    [NONAME
        NodeValue
        getFieldCounter 0 ?DO
            DUP I CELLS + @ ?DUP IF FREE DROP THEN
        LOOP
        DROP
    NONAME]
    vRecordList DoList
    LOCAL
    vRecordList 0!
    vCursor 0!
    vUpdate 0!
;

M: clear
    freeAll
    vResource CloseHandle DROP vResource 0!
;
    CONSTR: init ( a u cnt -- )
        setFieldCounter setFileName
    ;

    DESTR: free
        clear
        vFileName @ ?DUP IF GLOBAL FREE DROP LOCAL THEN  ;

M: eof? vCursor @ 0= ;
M: EOF? seize eof? release ;

M: fget  ( # -- a u)
    DUP getFieldCounter < eof? 0= AND
    IF
        CELLS vCursor @ NodeValue + sget
    ELSE
        DROP 0 0
    THEN
;

M: FGET ( # -- a u)
    seize
    fget
    release
;

M: fput
    DUP getFieldCounter < eof? 0= AND
    IF
        CELLS vCursor @ NodeValue +
        sset
        vUpdate ON
    ELSE DROP 2DROP THEN
;

M: FPUT ( a u # -- )
    seize
    fput
    release
;

M: SEEK
;

M: rbegin  vRecordList @ vCursor ! ;
M: RBEGIN seize rbegin release ;



M: rnew
    getFieldCounter CELLS GLOBAL ALLOCATE LOCAL ?DUP IF NIP release EXIT THEN
    DUP getFieldCounter CELLS ERASE
    vRecordList GLOBAL AppendNode LOCAL
    AddedNode @ vCursor !
    vUpdate ON
    0
;

M: RNEW (  -- ior )
    seize
    rnew
    release
;

M: rnext  eof? 0= IF vCursor @ @ vCursor ! THEN ;

M: RNEXT seize rnext release ;

: freeTmp
    buf@ ?DUP IF FREE DROP THEN buf 0!
    fh@ ?DUP IF CLOSE-FILE DROP THEN fh 0!
;

M: READ (  -- ior )
    seize
    freeAll
    getFileName R/O OPEN-FILE-SHARED ?DUP IF NIP freeTmp release EXIT THEN fh !
    C/L 2+ ALLOCATE ?DUP IF NIP freeTmp release  EXIT THEN buf !
    BEGIN buf@ C/L fh@  READ-LINE ?DUP
        IF NIP NIP freeTmp release EXIT THEN
    WHILE
        rnew ?DUP IF freeTmp release EXIT THEN
        buf@ SWAP
        <TIB
            getFieldCounter 0 ?DO
                get-string I fput
                [CHAR] , SKIP
                BL SKIP
            LOOP
        TIB>
    REPEAT
    DROP
    freeTmp
    vUpdate OFF
    release
    0
;

M: WRITE ( -- ior )
    seize
    C/L 2+ ALLOCATE ?DUP IF NIP release EXIT THEN buf !
    getFileName W/O MAKE-FILE ?DUP IF NIP freeTmp release EXIT THEN  fh !
    rbegin
    BEGIN eof? 0= WHILE
        buf@ 0!
        getFieldCounter 0 ?DO
            QUOTE buf@ +ZPLACE
            I fget buf@ +ZPLACE
            QUOTE buf@ +ZPLACE
            I 1+ getFieldCounter <>
            IF  S" ," buf@ +ZPLACE THEN
        LOOP
        buf@ ASCIIZ> fh@ WRITE-LINE ?DUP IF freeTmp EXIT THEN
        rnext
    REPEAT
    fh@ FILE-SIZE DROP fh@ RESIZE-FILE DROP
    freeTmp
    vUpdate 0!
    release
    0
;

M: ?WRITE ( -- ior) vUpdate @ IF WRITE ELSE 0 THEN ;

M: rfindxt { a u n xt -- ?}
\  ,    n    a u.
\   xt
    rbegin
    BEGIN eof? 0= WHILE
        n fget a u xt EXECUTE 0=
        IF TRUE EXIT THEN
        rnext
    REPEAT
    FALSE
;

M: rfind ['] COMPARE rfindxt ;

M: RFIND ( a u n -- ?)
\    
    seize
    rfind
    release
;

M: RDELETE ( -- )
\   
    seize
    eof? 0=
    IF
        GLOBAL
        vCursor @ rnext
        NodeValue   \  
        getFieldCounter 0 ?DO DUP I CELLS + @ ?DUP IF FREE DROP THEN LOOP
        DUP FREE DROP \  
        vRecordList DelNode \  
        LOCAL
        vUpdate ON
    THEN
    release
;

M: FOR-ALL-WHERE { xt xtcond -- }
    RBEGIN
    BEGIN EOF? 0= WHILE
        xtcond EXECUTE IF xt EXECUTE THEN
        RNEXT
    REPEAT
;

M: FOR-ALL ( xt -- ) ['] TRUE FOR-ALL-WHERE ;

M: DELETE-WHERE { xtcond -- }
    RBEGIN
    BEGIN EOF? 0= WHILE
        xtcond EXECUTE IF RDELETE ELSE RNEXT THEN
    REPEAT
;

;CLASS

REQUIRE \EOF ~nn/lib/eof.f
\EOF

S" etc\test.txt" 3 TABLE OBJECT: t1
: test
     .S
    t1 READ . CR
    t1 RBEGIN
    4 0 DO I . I t1 FGET TYPE CR LOOP

    S" 3" 0 t1 RFIND IF t1 RDELETE THEN

    t1 WRITE . CR
    .S
;

REQUIRE JMP ~nn/lib/jmp.f
' BYE ' QUIT JMP
test BYE