REQUIRE { ~nn/lib/locals.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE FIND-FIRST-FILE ~nn/lib/find.f
REQUIRE FT>DATE ~nn/lib/time.f
REQUIRE AddNode ~nn/lib/list.f

USER-VALUE FF-MASK
USER-VALUE FF-XMASK
USER-VALUE FF-FIRST
USER-VALUE FF-FOUND
USER-VALUE FF-BASE
USER-VALUE FF-BUF
USER       FF-STACK
USER       FF-RECURSIVE?
0 
1 CELLS -- FFS-BASE
1 CELLS -- FFS-MASK
1 CELLS -- FFS-XMASK
1 CELLS -- FFS-FIRST
1 CELLS -- FFS-FOUND
1 CELLS -- FFS-BUF
1 CELLS -- FFS-FFB
1 CELLS -- FFS-FFH
CONSTANT /FFS



: FOUND-FILENAME  FF-FOUND ASCIIZ> ;
: FOUND-FULLPATH  ( -- a u )
    FF-BASE ASCIIZ> FF-BUF ZPLACE
    S" \" FF-BUF +ZPLACE
    FOUND-FILENAME FF-BUF +ZPLACE
    FF-BUF ASCIIZ> ;
: FOUND-RELPATH ( -- a u )
    FOUND-FULLPATH DROP
    FF-STACK @ @ 
    IF
       FF-STACK 
       BEGIN @ DUP @ @ 0= UNTIL
       NodeValue FFS-BASE @ 
    ELSE
       FF-BASE
    THEN
    ASCIIZ> NIP ?DUP IF + 1+ THEN ASCIIZ>
;

: CREATION-DATE ( -- u) FF-CREATION-TIME FT>DATE ;
: ACCESS-DATE FF-ACCESS-TIME FT>DATE ;
: WRITE-DATE FF-WRITE-TIME FT>DATE ;

: IS-/OR\? ( c -- ?) DUP [CHAR] \ = SWAP [CHAR] / = OR ;

: FF-FRACT { a u \ asep -- }
    a u + u IF 1- THEN
    BEGIN  DUP a <> OVER C@ IS-/OR\? 0= AND  WHILE 1- REPEAT
    TO asep
    asep a =
    IF  S" " a u 
    ELSE
        a asep a - u OVER - 1- asep 1+ SWAP
    THEN
    S>ZALLOC TO FF-MASK
\    2DUP TYPE CR
    S>ZALLOC TO FF-BASE
;

: FF-BEGIN ( a u --)
    FF-FRACT
    1 TO FF-FIRST 
    MAX_PATH ALLOCATE THROW TO FF-BUF
;

: FF-CLR
    0 TO FF-MASK 0 TO FF-BASE 
    0 TO FF-BUF  0 TO FF-XMASK ;

: FF-SAVE
    /FFS ALLOCATE THROW >R
    FF-MASK  R@ FFS-MASK !
    FF-XMASK R@ FFS-XMASK !
    FF-FIRST R@ FFS-FIRST !
    FF-FOUND R@ FFS-FOUND !
    FF-BASE  R@ FFS-BASE !
    FF-BUF   R@ FFS-BUF ! 
    __FFB    R@ FFS-FFB !
    __FFH    R@ FFS-FFH !
    R> FF-STACK AddNode
    FF-CLR
;

: FF-REST

    FF-MASK ?DUP IF FREE DROP THEN
    FF-BASE ?DUP IF FREE DROP THEN
    FF-BUF  ?DUP IF FREE DROP THEN
    FF-XMASK ?DUP IF FREE DROP THEN

    FIND-CLOSE
    FF-STACK @ ?DUP
    IF NodeValue >R
       R@ FFS-FFH @ TO __FFH
       R@ FFS-FFB @ TO __FFB
       R@ FFS-BUF @ TO FF-BUF 
       R@ FFS-BASE @ TO FF-BASE
       R@ FFS-FOUND @ TO FF-FOUND
       R@ FFS-FIRST @ TO FF-FIRST
       R@ FFS-MASK @ TO FF-MASK
       R> FREE DROP
       FF-STACK @ DUP @ FF-STACK !
       FREE DROP
    THEN
;

: FF-PATH/MASK ( -- az)
    FF-MASK ASCIIZ> DUP >R
    FF-BASE ASCIIZ> DUP R> + 2+ ALLOCATE THROW >R
    FF-BASE C@ IF R@ ZPLACE S" /" R@ +ZPLACE ELSE 2DROP THEN
    R@ +ZPLACE
    R>
;

: (FF) ( -- ?)
    FF-FIRST 1 AND
    IF
        FF-PATH/MASK DUP >R FIND-FIRST-FILE
        R> FREE DROP
    ELSE
        FIND-NEXT-FILE
    THEN
    FALSE TO FF-FIRST
    IF TO FF-FOUND  TRUE ELSE FALSE THEN
;

: FF1 ( -- ?)
    BEGIN
        (FF) \ ." :::" FOUND-FILENAME TYPE CR
    WHILE
        FOUND-FILENAME S" ." COMPARE 0=
        FOUND-FILENAME S" .." COMPARE 0= OR 0=
        IF TRUE EXIT THEN
    REPEAT
    FALSE
;

: FF-DOWN
    FOUND-FULLPATH DROP >R \   FF-BUF
    S" \" R@ +ZPLACE
    FF-MASK ASCIIZ> R@ +ZPLACE
    FF-SAVE
    R> ASCIIZ>
    FF-BEGIN
;

\ : RECURSIVE-FF1 ( -- ?)
\    BEGIN 
\        FF1
\    WHILE
\        IS-DIR? 0= IF TRUE EXIT THEN
\        FF-DOWN
\    REPEAT
\    FF-STACK @ @
\    IF  FF-REST RECURSE ELSE FALSE THEN ;

: RECURSIVE-FF ( -- ?)
    FF-FIRST 0=
    IF IS-DIR? IF FF-DOWN THEN THEN
    FF1 ?DUP 0=
    IF FF-STACK @ @
        IF FF-REST 2 TO FF-FIRST RECURSE ELSE FALSE THEN THEN
;

: FF   FF-RECURSIVE? @ IF RECURSIVE-FF ELSE FF1 THEN ;

: FF-SAVE-STACK R>  FF-STACK @ >R >R  FF-STACK 0! ;
: FF-REST-STACK R> R> FF-STACK ! >R ;

: FOR-FILES \ compile: ( -- )
            \ execute: ( a u --)
    POSTPONE FF-SAVE-STACK
    POSTPONE FF-SAVE
    POSTPONE FF-BEGIN
    POSTPONE BEGIN
    POSTPONE FF
    POSTPONE WHILE
; IMMEDIATE

: RECURSIVE TRUE FF-RECURSIVE? ! ;
: ~RECURSIVE FF-RECURSIVE? 0! ;


: ;FOR-FILES
    POSTPONE REPEAT
\    POSTPONE FIND-CLOSE
    POSTPONE FF-REST
    POSTPONE FF-REST-STACK
    POSTPONE FF-RECURSIVE? POSTPONE 0!
    ; IMMEDIATE
