REQUIRE { ~nn/lib/locals.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE FIND-FIRST-FILE ~nn/lib/find.f
REQUIRE FT>DATE ~nn/lib/time.f
\ REQUIRE AddNode ~nn/lib/list.f
\ REQUIRE ALLOCATE9x ~nn/lib/alloc95.f
REQUIRE [NONAME ~nn/lib/noname.f
\ REQUIRE WC-COMPARE ~nn/lib/wcmatch.f

USER-VALUE FF-BUF
USER       FF-RECURSIVE?
0 
1 CELLS  -- ffBaseLen
1 CELLS  -- ffCurLen
1 CELLS  -- ffFlags
1 CELLS  -- ffXT
MAX_PATH -- ffMask
MAX_PATH -- ffPath
CONSTANT /FF-BUF

1 CONSTANT FF-FIRST

: FOUND-FILENAME FF-BUF ffPath FF-BUF ffCurLen @ + 1+ ASCIIZ> ;
: FOUND-FULLPATH  ( -- a u )  FF-BUF ffPath ASCIIZ> ;
: FOUND-RELPATH ( -- a u )   FF-BUF ffPath FF-BUF ffBaseLen @ + 1+ ASCIIZ> ;

: CREATION-DATE ( -- u) FF-CREATION-TIME FT>DATE ;
: ACCESS-DATE FF-ACCESS-TIME FT>DATE ;
: WRITE-DATE FF-WRITE-TIME FT>DATE ;

: IS-/OR\? ( c -- ?) DUP [CHAR] \ = SWAP [CHAR] / = OR ;

: FF-FRACT { a u \ asep -- }
    a u + u IF 1- THEN
    BEGIN  DUP a <> OVER C@ IS-/OR\? 0= AND  WHILE 1- REPEAT
    TO asep
    asep a =
    IF  S" " a u 
    ELSE
        a asep a - u OVER - 1- asep 1+ SWAP
    THEN
\    2DUP TYPE CR
    FF-BUF ffMask ZPLACE
\    2DUP TYPE CR
    DUP FF-BUF ffBaseLen ! 
    DUP FF-BUF ffCurLen !
    FF-BUF ffPath ZPLACE
;

: FF-ADD1 ( a u -- )  
    FF-BUF ffPath FF-BUF ffCurLen @ + 
    DUP S" \" ROT ZPLACE 1+ ZPLACE ;

: FF-PATH/MASK ( -- az)  
     FF-BUF ffMask ASCIIZ> FF-ADD1 FF-BUF ffPath ;
\    S" *.*" FF-ADD1 FF-BUF ffPath ;

: (FF-NEXT) ( -- ?)
    FF-BUF ffFlags @ FF-FIRST AND
    IF
        FF-PATH/MASK FIND-FIRST-FILE
 \       __FFH .
    ELSE
        FIND-NEXT-FILE
    THEN
\    DUP .
    FF-BUF ffFlags @ FF-FIRST -1 XOR AND FF-BUF ffFlags !
    IF 
        ASCIIZ> ( 2DUP TYPE CR) FF-ADD1
        TRUE 
    ELSE FALSE THEN
;

: FF-NEXT ( -- ?)
    BEGIN
        (FF-NEXT) \ ." :::" FOUND-FILENAME TYPE CR
    WHILE
        FOUND-FILENAME S" ." COMPARE 0=
        FOUND-FILENAME S" .." COMPARE 0= OR 0=
\        IS-DIR? 0= IF FOUND-FILENAME FF-BUF ffMask ASCIIZ> WC-COMPARE AND THEN
        IF TRUE EXIT THEN
    REPEAT
    FALSE
;


: FF-PASS
    __FFB >R  __FFH >R
    BEGIN FF-NEXT WHILE
        FF-BUF ffXT @ EXECUTE
        IS-DIR? FF-RECURSIVE? @ AND
        IF 
            FF-BUF ffCurLen @ >R
            FOUND-FULLPATH FF-BUF ffCurLen ! DROP
            FF-FIRST FF-BUF ffFlags !
            RECURSE
            R> FF-BUF ffCurLen !
        THEN
    REPEAT
    FIND-CLOSE
    R> TO __FFH  R> TO __FFB  
;

: RECURSIVE TRUE FF-RECURSIVE? ! ;
: ~RECURSIVE FF-RECURSIVE? 0! ;

: (FOR-FILES) ( a u xt -- )
    FF-BUF >R
    /FF-BUF ALLOCATE9x THROW TO FF-BUF
    FF-BUF ffXT !
    FF-FIRST FF-BUF ffFlags !
    FF-FRACT

    FF-PASS

    FF-BUF FREE9x THROW
    R> TO FF-BUF
    ~RECURSIVE
;

: FOR-FILES \ compile: ( -- )
            \ execute: ( a u --)
    POSTPONE [NONAME
; IMMEDIATE



: ;FOR-FILES
    POSTPONE NONAME]
    POSTPONE (FOR-FILES)
; IMMEDIATE


