#include <windows.h>

#define HOOK_BEG 2100
#define HookClass "SPFHookTest"


//#define DllImport   __declspec( dllimport )
//#define DllExport   __declspec( dllexport )


BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}


#pragma data_seg(".shared")
HWND hwshell=NULL;
HHOOK HookHandle;
#pragma data_seg()
#pragma comment(linker, "/SECTION:.shared,RWS") 


//DllExport
LRESULT CALLBACK shell_proc(
  int nCode,      // hook code
  WPARAM wParam,  // event-specific information
  LPARAM lParam   // event-specific information
){ 
   if(hwshell==NULL) hwshell=FindWindow(HookClass, NULL);
   if(  nCode==HSHELL_WINDOWACTIVATED ||
        nCode==HSHELL_WINDOWCREATED ||
        nCode==HSHELL_WINDOWDESTROYED ||
        nCode==HSHELL_REDRAW){
        if(hwshell!=NULL){
          int  len=GetWindowTextLength((HWND)wParam);
          char *win_title=GlobalAlloc(GMEM_FIXED, len+1);
          GetWindowText((HWND)wParam, win_title, len+1);
          PostMessage(hwshell, HOOK_BEG+nCode, wParam, (LPARAM)win_title);
        }
   }
   CallNextHookEx(HookHandle,nCode,wParam,lParam);
   return 0;
} 
 
//DllExport
LRESULT CALLBACK set_shell_hook(HANDLE dll_handle){
    HookHandle=SetWindowsHookEx(WH_SHELL, (HOOKPROC)shell_proc, dll_handle, 0);
    return 0;
}

