REQUIRE { ~nn/lib/locals.f
REQUIRE <TIB ~nn/lib/tib.f
REQUIRE CASE lib/ext/case.f
REQUIRE get-number ~nn/lib/getstr.f
REQUIRE VK_BROWSER_BACK ~nn/lib/win/sys/vk_mm.f

WINAPI: keybd_event USER32.DLL
\ VOID keybd_event(
\   BYTE bVk,               // virtual-key code
\   BYTE bScan,             // hardware scan code
\   DWORD dwFlags,          // function options
\   ULONG_PTR dwExtraInfo   // additional keystroke data
\ );

(
\  lparam      <   WM_CHAR>
0x1E0001    CONSTANT KEYDOWN_BASIC_LPARAM
\   
0x11E0001   CONSTANT KEYDOWN_EXT_LPARAM
\    
0x0C01E0001 CONSTANT KEYUP_BASIC_LPARAM
\    
0x0C11E0001 CONSTANT KEYUP_EXT_LPARAM
)

500 VALUE sk_delay

USER-VALUE HKBLT
\ : HKBLT 0 GetForegroundWindow GetWindowThreadProcessId GetKeyboardLayout ;
USER-VALUE
0 VALUE SPEC-WID
USER SK-DELAY1
USER SK-DELAY2
USER SK-HWND

: keybd_event1 { extra flags scan vk -- ? }
    SK-HWND @
    IF
        scan 16 LSHIFT 1 OR
        flags KEYEVENTF_KEYUP AND 0<>
        IF
          0xC0000000 OR
          WM_KEYUP
        ELSE
          WM_KEYDOWN
        THEN
        vk SWAP SK-HWND @
        SendMessageA
    ELSE
\        extra . flags . scan . vk . CR
        extra flags scan vk keybd_event
    THEN
;

: (normalKey) { c \ VK SCAN EXTRA -- }
    HKBLT c 0xFF AND VkKeyScanExA TO VK
    HKBLT 0 VK MapVirtualKeyExA TO SCAN
    GetMessageExtraInfo TO EXTRA
    
    EXTRA 0 SCAN VK keybd_event1 DROP
    EXTRA KEYEVENTF_KEYUP SCAN VK keybd_event1 DROP
    SK-DELAY1 @ ?DUP IF PAUSE THEN
\      ." norm: (" HKBLT HEX .  c . VK . SCAN . EXTRA . DECIMAL ." ) "
;

: spec_key { VK param \ SCAN EXTRA -- }
    HKBLT 0 VK MapVirtualKeyExA TO SCAN
    GetMessageExtraInfo TO EXTRA
    EXTRA param SCAN VK keybd_event1 DROP
\      ." spec: (" HEX VK . SCAN . EXTRA . param . DECIMAL ." ) "
;
: specKeyDN ( VK -- )   0 spec_key ;
: specKeyUP ( VK -- )   KEYEVENTF_KEYUP spec_key ;

CREATE sh_keys0 C" ~!@#$%^&*()_+|<>?{}:x" ",  CHAR " HERE 1- C!
CREATE sh_keys1 C" `1234567890-=\,./[];'" ",    \ "

: ShiftKey ( c -- )
    VK_SHIFT specKeyDN
    (normalKey)
    VK_SHIFT specKeyUP
;

: normalKey { c -- }
    c [CHAR] A < c [CHAR] Z > OR 0=
    IF
        c ShiftKey
    ELSE
        FALSE
        sh_keys0 COUNT OVER + SWAP
        DO I C@ c = IF DROP I LEAVE THEN LOOP
        ?DUP
        IF
            sh_keys0 - sh_keys1 + C@ ShiftKey
        ELSE
            c (normalKey)
        THEN
    THEN
;

\ : sk_message SendMessageA DROP ;
: charKey ( c -- )
    normalKey
\    KEYDOWN_BASIC_LPARAM SWAP WM_CHAR GetForegroundWindow sk_message
;
: extSpecChar { VK \ SCAN EXTRA -- }
    HKBLT 0 VK MapVirtualKeyExA TO SCAN
    GetMessageExtraInfo TO EXTRA
    EXTRA 0 SCAN VK keybd_event1 DROP
    EXTRA KEYEVENTF_KEYUP SCAN VK keybd_event1 DROP
\    KEYDOWN_EXT_LPARAM OVER WM_KEYDOWN GetForegroundWindow >R R@ sk_message
\    KEYUP_EXT_LPARAM   SWAP WM_KEYUP   R> sk_message
    SK-DELAY1 @ ?DUP IF PAUSE THEN
;

GET-CURRENT
VOCABULARY SPEC-KEYS
ALSO SPEC-KEYS DEFINITIONS
CONTEXT @ TO SPEC-WID

: BACKSPACE VK_BACK charKey ;
: BS BACKSPACE ; : BKSP BACKSPACE ;
\ BREAK {BREAK}
: BREAK VK_PAUSE extSpecChar ;

: CAPSLOCK  VK_CAPITAL     extSpecChar ;
: DELETE    VK_DELETE       extSpecChar ;
: DOWN      VK_DOWN         extSpecChar ;
: END       VK_END          extSpecChar ;
: ENTER VK_RETURN charKey ;
: ESC VK_ESCAPE charKey ;
\ HELP {HELP}
: HOME      VK_HOME         extSpecChar ;
: INSERT    VK_INSERT       extSpecChar ;
: LEFT      VK_LEFT         extSpecChar ;
: NUMLOCK   VK_NUMLOCK      extSpecChar ;
: PAGEDOWN  VK_NEXT    extSpecChar ;
    : PGDN PAGEDOWN ;
: PAGEUP    VK_PRIOR   extSpecChar ;
    : PGUP PAGEUP ;
: PRINTSCREEN  VK_SNAPSHOT extSpecChar ;
    : PRTSC PRINTSCREEN ;
: RIGHT     VK_RIGHT        extSpecChar ;
: SCROLLLOCK VK_SCROLL extSpecChar ;
: TAB VK_TAB charKey ;
: UP  VK_UP                 extSpecChar ;
: F1  VK_F1                 extSpecChar ;
: F2  VK_F2                 extSpecChar ;
: F3  VK_F3                 extSpecChar ;
: F4  VK_F4                 extSpecChar ;
: F5  VK_F5                 extSpecChar ;
: F6  VK_F6                 extSpecChar ;
: F7  VK_F7                 extSpecChar ;
: F8  VK_F8                 extSpecChar ;
: F9  VK_F9                 extSpecChar ;
: F10 VK_F10                extSpecChar ;
: F11 VK_F11                extSpecChar ;
: F12 VK_F12                extSpecChar ;
: F13 VK_F13                extSpecChar ;
: F14 VK_F14                extSpecChar ;
: F15 VK_F15                extSpecChar ;
: F16 VK_F16                extSpecChar ;
: WIN VK_LWIN               extSpecChar ;

: NUMPAD0 VK_NUMPAD0 extSpecChar ;
: NUMPAD1 VK_NUMPAD1 extSpecChar ;
: NUMPAD2 VK_NUMPAD2 extSpecChar ;
: NUMPAD3 VK_NUMPAD3 extSpecChar ;
: NUMPAD4 VK_NUMPAD4 extSpecChar ;
: NUMPAD5 VK_NUMPAD5 extSpecChar ;
: NUMPAD6 VK_NUMPAD6 extSpecChar ;
: NUMPAD7 VK_NUMPAD7 extSpecChar ;
: NUMPAD8 VK_NUMPAD8 extSpecChar ;
: NUMPAD9 VK_NUMPAD9 extSpecChar ;
: MULTIPLY VK_MULTIPLY extSpecChar ;
: ADD   VK_ADD extSpecChar ;
\ : SEPARATOR VK_SEPARATOR extSpecChar ;
: SUBTRACT VK_SUBTRACT extSpecChar ;
: DECIMAL VK_DECIMAL extSpecChar ;
: DIVIDE VK_DIVIDE extSpecChar ;

: APP 0x5D extSpecChar ;
\ : RMENU VK_RMENU extSpecChar ;
\ : LMENU VK_LMENU extSpecChar ;


: BROWSER_BACK VK_BROWSER_BACK extSpecChar ;
: BROWSER_FORWARD VK_BROWSER_FORWARD extSpecChar ;
: BROWSER_REFRESH VK_BROWSER_REFRESH extSpecChar ;
: BROWSER_STOP VK_BROWSER_STOP extSpecChar ;
: BROWSER_SEARCH VK_BROWSER_SEARCH extSpecChar ;
: BROWSER_FAVORITES VK_BROWSER_FAVORITES extSpecChar ;
: BROWSER_HOME VK_BROWSER_HOME extSpecChar ;

: VOLUME_MUTE VK_VOLUME_MUTE extSpecChar ;
: VOLUME_DOWN VK_VOLUME_DOWN extSpecChar ;
: VOLUME_UP VK_VOLUME_UP extSpecChar ;
: MEDIA_NEXT_TRACK VK_MEDIA_NEXT_TRACK extSpecChar ;
: MEDIA_PREV_TRACK VK_MEDIA_PREV_TRACK extSpecChar ;
: MEDIA_STOP VK_MEDIA_STOP extSpecChar ;
: MEDIA_PLAY_PAUSE VK_MEDIA_PLAY_PAUSE extSpecChar ;
: LAUNCH_MAIL VK_LAUNCH_MAIL extSpecChar ;
: LAUNCH_MEDIA_SELECT VK_LAUNCH_MEDIA_SELECT extSpecChar ;
: LAUNCH_APP1 VK_LAUNCH_APP1 extSpecChar ;
: LAUNCH_APP2 VK_LAUNCH_APP2 extSpecChar ;

: DELAY get-number PAUSE ;
: QUOTE [CHAR] ' ShiftKey ;

PREVIOUS SET-CURRENT

: SkipChar EndOfChunk 0= IF >IN 1+! THEN ;
: NextChar ( -- c ? ) GetChar SkipChar ;
: SpecKey
    ALSO SPEC-KEYS
    [CHAR] } PARSE 2DUP 2DUP S"  " SEARCH ROT DROP IF - ELSE DROP THEN
    SPEC-WID SEARCH-WORDLIST
    IF DROP ['] EVALUATE CATCH IF 2DROP THEN
    ELSE DROP C@ normalKey THEN
    PREVIOUS ;

VECT send_keys

: specGroup ( vk )
    DUP specKeyDN
    NextChar
    IF
        DUP [CHAR] ( =
        IF DROP
            [CHAR] ) PARSE send_keys
        ELSE
        DUP [CHAR] { =
        IF DROP SpecKey
        ELSE normalKey THEN THEN
    ELSE DROP THEN
    specKeyUP
;

:NONAME ( a u  -- )
    <TIB
    BEGIN NextChar WHILE
        CASE
            [CHAR] { OF SpecKey              ENDOF
            [CHAR] + OF VK_SHIFT   specGroup ENDOF
            [CHAR] ^ OF VK_CONTROL specGroup ENDOF
            [CHAR] @ OF VK_MENU    specGroup ENDOF
            [CHAR] $ OF VK_LWIN    specGroup ENDOF
            10       OF ( nothing) ENDOF
            DUP normalKey
        ENDCASE
    REPEAT DROP
    TIB>
; TO send_keys

: SEND-KEYS ( a u -- )
    0 GetForegroundWindow GetWindowThreadProcessId GetKeyboardLayout TO HKBLT
    send_keys
    SK-DELAY2 @ PAUSE
;

: SEND-KEYS-DELAY ( delay1 delay2 -- )
    SK-DELAY2 !  SK-DELAY1 ! ;

\EOF

: AppActivate ( a u -- )
    DROP 0 FindWindowA ?DUP
    IF
       DUP SetActiveWindow >R
       DUP SetFocus DROP
       DUP SetForegroundWindow DROP
           BringWindowToTop DROP
       R>
       DROP
    THEN
;

REQUIRE StartApp ~nn/lib/process.f

: test1
    0 S" calc.exe"  StartApp DROP
    1000 PAUSE
    S" Calculator" AppActivate
    S" 2{+}3=*3=" SEND-KEYS     3000 PAUSE
    S" %{F4}" SEND-KEYS
;
: test
    S" S{QUOTE} Hello! My Dear Friends{QUOTE} TYPE{ENTER}" SEND-KEYS
;

: test2
    0 S" e:\win\the bat!\thebat.exe"  StartApp DROP
    3000 PAUSE
    S" The Bat!" AppActivate
\    S" {F2}" SEND-KEYS 3000 PAUSE
    S" +(^P)" SEND-KEYS 3000 PAUSE
    S" %{F4}" SEND-KEYS 3000 PAUSE
    S" %{F4}" SEND-KEYS
;

: test3
\    0x00020202 SK-HWND !
    S" Untitled - Notepad" AppActivate
    100 PAUSE
\    S" {HOME}+({END})" SEND-KEYS
    S" @(+)+() {ENTER}"  SEND-KEYS
    1000 PAUSE
    CR CR
    S" @(+)TEST test"  SEND-KEYS
;

 test3
