REQUIRE >EOF ~nn/lib/eof.f
REQUIRE GET-CUR-TIME ~nn/lib/time.f
REQUIRE HOLDS lib/ext/string.f
REQUIRE GET ~nn/lib/mutex.f
REQUIRE OPEN/CREATE-FILE ~nn/lib/file.f
REQUIRE QUEUE ~nn/lib/utils/queue.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
REQUIRE PICK lib/ext/core-ext.f

\ C" GetCurrentProcessId" FIND NIP 0= [IF] WINAPI: GetCurrentProcessId KERNEL32.DLL [THEN]
\ -1 CONSTANT INFINITE

\ VARIABLE LOG-MUTEX
0 VALUE LOG-FILE
QUEUE POINTER QLOG
VARIABLE LOG-RES

: OPEN/CREATE ( a u -- h ) R/W OPEN/CREATE-FILE THROW ;
: LOG-WR ( a # --)  LOG-FILE WRITE-FILE THROW ;

: LOG-CR LT LTL @ LOG-WR ;

VARIABLE QLOG-TASK-ID
:NONAME
    DECIMAL
    GLOBAL
    64 QUEUE NEW TO QLOG
    GetCurrentThreadId QLOG-TASK-ID !    
    BEGIN
        QLOG Get DUP >R ASCIIZ>
        QLOG Get DUP >R ASCIIZ>
        [NONAME
            2SWAP OPEN/CREATE TO LOG-FILE
            LOG-FILE >EOF
            LOG-WR LOG-CR
            LOG-FILE CLOSE-FILE THROW
        NONAME] CATCH IF 2DROP 2DROP THEN
        R> FREE DROP
        R> FREE DROP
    AGAIN
; TASK: QLOG-TASK

\ : HOLDS ( A # --) OVER + 1- DO I C@ HOLD -1 +LOOP ;

: (LOG-TIME) ( -- addr u)
    GET-CUR-TIME
    <#
\        BL HOLD
        Sec@  S>D # #       2DROP [CHAR] : HOLD
        Min@  S>D # #       2DROP [CHAR] : HOLD
        Hour@ S>D # #       2DROP BL       HOLD
        Year@ S>D # # # #   2DROP [CHAR] . HOLD
        Mon@  S>D # #       2DROP [CHAR] . HOLD
        Day@  S>D # #             BL       HOLD
        WDay@ 1- 3 * WDAYS 1+ + 3 HOLDS
    #>
;
VECT LOG-TIME
' (LOG-TIME) TO LOG-TIME

USER-CREATE <SAVE-HOLD> 40 USER-ALLOT
: SAVE-HOLD <# HLD @ 40 - <SAVE-HOLD> 40 CMOVE ;
: REST-HOLD <SAVE-HOLD> <# HLD @ 40 - 40 CMOVE ;

: QLOG-START QLOG NULL? 
    IF QLOG-TASK-ID 0! 
        0 QLOG-TASK START CLOSE-FILE DROP
        BEGIN
         1 PAUSE
         QLOG-TASK-ID @
        UNTIL
    THEN ;

: (LOG) ( a # a-file #-file --)
    QLOG-START
    SAVE-HOLD
    LOG-RES GET
    GLOBAL
    S>ZALLOC QLOG Put
    ( a u )
    GET-CUR-TIME
    LOG-TIME ?DUP
    IF
        2 PICK OVER + 2+ ALLOCATE THROW >R
        R@ ZPLACE
        S"  " R@ +ZPLACE
        REST-HOLD
        R@ +ZPLACE
        R>
    ELSE
        REST-HOLD
        S>ZALLOC
    THEN
    QLOG Put
    LOCAL
    LOG-RES RELEASE
;

: (LOG2) ( a # a-file #-file --)
    QLOG-START
    LOG-RES GET
    GLOBAL
    S>ZALLOC QLOG Put
    ( a u )
    S>ZALLOC QLOG Put
    LOCAL
    LOG-RES RELEASE
\ *          SAVE-HOLD
\ *          LOG-MUTEX GET
\ *             OPEN/CREATE TO LOG-FILE
\ *             LOG-FILE >EOF
\ *             REST-HOLD
\ *             LOG-WR LOG-CR
\ *             LOG-FILE CLOSE-FILE THROW
\ *          LOG-MUTEX RELEASE
;

: LOGGING ( A1 #1 A2 #2 xt -- )
\    DEBUG? IF >R 2OVER ." LOG: " TYPE CR R> THEN
    CATCH ?DUP
    IF >R 2DROP 2DROP
       ." Log error # " R> . CR
    THEN ;

: LOG  ( A1 #1 A2 #2 -- ) ['] (LOG) LOGGING ;
: LOG2  ['] (LOG2) LOGGING ;
