#include <windows.h>
#include <winwlx.h>
typedef DWORD (*PFNMSGECALLBACK)(BOOL bVerbose, LPWSTR lpMessage);

typedef struct _WLX_NOTIFICATION_INFO {
    ULONG  Size ;
    ULONG  Flags ;
    PWSTR  UserName ;
    PWSTR  Domain ;
    PWSTR  WindowStation ;
    HANDLE hToken ;
    HDESK  hDesktop ;
    PFNMSGECALLBACK pStatusCallback ;
} WLX_NOTIFICATION_INFO, * PWLX_NOTIFICATION_INFO ;

//Entrance function for the DLL
BOOL WINAPI LibMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
    switch (dwReason)
    {
        case DLL_PROCESS_ATTACH:
            {
             //Disable DLL_THREAD_ATTACH & DLL_THREAD_DETACH
             //notification calls. This is a performance optimization
             //for multi-threaded applications that do not need 
             //thread-level notifications of attachment or detachment.

            DisableThreadLibraryCalls (hInstance);
            }
            break;
    }

    return TRUE;
}


VOID wlLogon (PWLX_NOTIFICATION_INFO pInfo){
}


VOID wlLogoff (PWLX_NOTIFICATION_INFO pInfo)
{
}

VOID wlLock (PWLX_NOTIFICATION_INFO pInfo)
{
    Beep(5000, 1000);
}

VOID wlUnlock (PWLX_NOTIFICATION_INFO pInfo)
{
    Beep(10000, 3000);
}

VOID wlShutdown (PWLX_NOTIFICATION_INFO pInfo){
}

VOID wlStartScreenSaver (PWLX_NOTIFICATION_INFO pInfo){
}

VOID wlStartShell (PWLX_NOTIFICATION_INFO pInfo){
}

VOID wlStartup (PWLX_NOTIFICATION_INFO pInfo){
}
VOID wlStopScreenSaver (PWLX_NOTIFICATION_INFO pInfo){
}
