REQUIRE DEBUG? ~nn/lib/qdebug.f
REQUIRE HOLDS lib/ext/string.f
REQUIRE SocketLine ~nn/lib/net/socketline.f

USER POP3server
USER POP3port
USER POP3user
USER POP3pass
USER POP3connection
VARIABLE POP3timeout
60000 POP3timeout !

: POP3write ( addr u -- )
  [ DEBUG? ] [IF] 2DUP TYPE [THEN]
  POP3connection @ sl_socket @ WriteSocket THROW
;

: <#CRLF ( -- d ) 0 0 <# LT LTL @ HOLDS ;

: POP3line ( -- )
  POP3connection @ SocketReadLine #TIB ! TO TIB >IN 0!
  [ DEBUG? ] [IF] SOURCE TYPE CR [THEN]
;
: POP3replyERR ( -- flag )
  POP3line
  TIB C@ [CHAR] - =
  BL WORD DROP
;

: POP3login ( -- flag )
  POP3replyERR IF FALSE EXIT THEN
  <#CRLF POP3user @ ASCIIZ> HOLDS S" USER " HOLDS #> POP3write
  POP3replyERR IF FALSE EXIT THEN
  <#CRLF POP3pass @ ASCIIZ> HOLDS S" PASS " HOLDS #> POP3write
  POP3replyERR 0=
;

: POP3logout
  <#CRLF S" QUIT" HOLDS #> POP3write
  POP3replyERR DROP
;

: POP3connect
  POP3server @ ASCIIZ> GetHostIP THROW
  POP3port @ CreateSocket THROW DUP POP3connection !
  POP3timeout @ POP3connection @ SetSocketTimeout DROP
  ConnectSocket THROW
  POP3timeout @ POP3connection @ SetSocketTimeout DROP
  POP3connection @ SocketLine POP3connection !
;
: POP3disconnect
  POP3connection @ sl_socket @ CloseSocket THROW
  POP3connection @ FREE DROP
;

: WORD: 0 0 BL WORD COUNT >NUMBER 2DROP D>S ;

: POP3STAT ( -- cnt )
  <#CRLF S" STAT" HOLDS #> POP3write
  POP3replyERR IF 0 EXIT THEN
  WORD: 
;

: POP3Check ( serv u1 user u2 pass u3  -- cnt)
    S>ZALLOC POP3pass !
    S>ZALLOC POP3user !
    S>ZALLOC POP3Server !
    110 POP3port !

;
