\ Forth console
REQUIRE SocketLine ~nn/lib/net/socketline.f
REQUIRE <ACCEPT> ~nn/lib/spf4/con_io.f
REQUIRE [NONAME ~nn/lib/noname.f 
\ REQUIRE MARKER lib/ext/core-ext.f
REQUIRE EVAL-SUBST ~nn/lib/subst1.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
REQUIRE FIT-MASK? ~nn/lib/masks.f
REQUIRE GET ~nn/lib/mutex.f

USER CON-IOR
VECT CON-LOG  
VECT CON-ON-CONNECT     ' NOOP TO CON-ON-CONNECT
VECT CON-ON-DISCONNECT  ' NOOP TO CON-ON-DISCONNECT

VARIABLE RemAllowed
VARIABLE RemDisallowed
VARIABLE RemConsoleIsStarted

( 
VARIABLE CON-RES

: CONg CON-RES GET ;
: CONr CON-RES RELEASE ;
)

:NONAME EVAL-SUBST TYPE CR ; TO CON-LOG

MODULE: sVOC
USER sIO
USER <BYE>
: ?CON-ERROR
    ?DUP IF CON-IOR ! S" Console server error # %CON-IOR @%." CON-LOG THEN
;

WARNING @ WARNING 0!
: BYE
    <BYE> @ IF EXIT THEN
    <BYE> 1+!
    [NONAME
        sIO @ ?DUP 
        IF 
           CON-ON-DISCONNECT
\           CON-IOR @ ?CON-ERROR
           S" Connection from %sIOPeerName+IP% is closed (%CON-IOR @%)." CON-LOG
           DUP ->CLASS SocketLine Close 
           DELETE
        THEN
    NONAME] CATCH DROP
    0 ExitThread
;
WARNING !

: ?BYE 
    DUP -1002 = IF DROP BYE ELSE ?DUP IF CON-IOR ! BYE THEN THEN ;

: sACCEPT ( c-addr +n1 -- +n2 )

    [NONAME
        sIO @ ->CLASS SocketLine ReadLine
        ROT MIN >R SWAP R@ MOVE R>
    NONAME] CATCH 
    ?BYE
;

: sTYPE ( a u -- ) [NONAME sIO @ ->CLASS SocketLine Write NONAME] CATCH ?DUP IF >R 2DROP R> ?BYE THEN ;

:NONAME \ EMIT ( c -- ) 
    SP@ 1 TYPE DROP ; ' EMIT JMP
:NONAME \ CR
    LT LTL @ TYPE ; ' CR JMP

: sKEY? ( -- ?) [NONAME sIO @ ->CLASS SocketLine ToRead 0<> NONAME] CATCH ?BYE ;

: sKEY ( -- n ) [NONAME 0 SP@ 1 sIO @ ->CLASS SocketLine Read DROP  NONAME] CATCH ?BYE ;

\ : sACCEPT1 DROP S" WORDS" ROT ZPLACE 5 ;
: SetSocketIO ( -- )
    ['] sACCEPT <ACCEPT> !
    ['] sTYPE   <TYPE> !
    ['] sKEY    <KEY> !
    ['] sKEY?   <KEY?> !
;

:NONAME ( socket -- )
    [NONAME
      SocketLine NEW sIO !
      DUP 
      ->CLASS Socket vSock @   sIO @ ->CLASS SocketLine vSock !
      GLOBAL DELETE LOCAL

      C" sIOPeerIP" FIND IF EXECUTE ELSE DROP S" " THEN
      RemAllowed RemDisallowed FIT-MASK? 0=
      IF 
        S" Connection from %sIOPeerName+IP% is declined."  CON-LOG
        BYE
      THEN
      S" Connection from %sIOPeerName+IP% is established." CON-LOG
      SetSocketIO
      ONLY FORTH DEFINITIONS
      DECIMAL
      S0 @ SP! R0 @ RP!
      CON-ON-CONNECT
      TITLE
      BEGIN
        0 TO SOURCE-ID
        [COMPILE] [
        ['] MAIN1 CATCH
        ['] ERROR CATCH DROP
      AGAIN
    NONAME] CATCH ?BYE
; TASK: sCONSOLE-TASK

Socket POINTER ss
:NONAME ( port -- )
    [NONAME
       Socket NEW TO ss
       ss Create
       ss vPort !
       ss Bind
       ss Listen
       S" Console server is started." CON-LOG
       RemConsoleIsStarted ON
       BEGIN
         GLOBAL [NONAME ss Accept NONAME] CATCH LOCAL 
         0= IF sCONSOLE-TASK START CLOSE-FILE DROP THEN
       AGAIN
    NONAME] CATCH ?CON-ERROR
; TASK: CONSOLE-SERVER

EXPORT

: sIOPeerName [NONAME sIO @ ->CLASS SocketLine PeerName NONAME] CATCH IF S" localhost" THEN ;
: sIOPeerIP [NONAME sIO @ ->CLASS SocketLine PeerIP NtoA NONAME] CATCH IF S" 127.0.0.1" THEN ;
: sIOPeerName+IP S" '%sIOPeerName%' (%sIOPeerIP%)" EVAL-SUBST ;


: START-CONSOLE-SERVER CONSOLE-SERVER START  CLOSE-FILE DROP ;

;MODULE
