\ FTP commands
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE PLACE lib/ext/string.f
REQUIRE ZPLACE ~nn/lib/az.f
REQUIRE S>NUM  ~nn/lib/s2num.f

0 VALUE CUR-CMD    \   ⥪饩  (⮫쪮 )
0 
1    -- CMD-PAR    \ flag. if TRUE, command has parameter
1    -- CMD-REP    \ flag. TRUE - repeatable
CELL -- CMD-STR    \ Name or full command
CELL -- CMD-RL     \ Responses list 
CONSTANT /CMD

: CtrlRead ( -- ) CtrlSock ReadLine 2DUP vInpBuf @ ZPLACE 
                  2 FTP-LOG ;
: RESP-CODE ( -- n) vInpBuf @ 3 S>NUM ;

: EXEC-RESP { list \ code -- }
    RESP-CODE TO code
    list
    BEGIN @ ?DUP WHILE
        DUP CELL+ W@ code =
        IF CELL+ 2+ EXECUTE EXIT THEN
    REPEAT
;

: WR-LOG
    S" --> " PAD ZPLACE
    PAD +ZPLACE
    PAD ASCIIZ> 2 FTP-LOG
;

: (EXEC-CMD) { buf -- }
    ?OPEN
    buf ASCIIZ> 2DUP WR-LOG
    CtrlSock WriteLine
    CtrlRead 
;

: EXEC-CMD { cmd \ buf result -- }
    1024 ALLOCATE THROW TO buf
    cmd CMD-STR @ COUNT buf ZPLACE
    cmd CMD-PAR C@
    IF S"  " buf +ZPLACE  buf +ZPLACE THEN
    0 TO result
    BEGIN
        buf ['] (EXEC-CMD) CATCH DUP TO result
        IF 
            cmd CMD-REP C@  \  ?
            IF  CtrlSock vAttempt @ 0 > 
                IF FALSE    \ , 塞 
                ELSE TRUE   \ 稫 ⪨.
                THEN
            ELSE TRUE THEN
        ELSE
          cmd CMD-RL EXEC-RESP TRUE
        THEN
    UNTIL
    buf FREE DROP
    result THROW
;

\ ------ responses -----------------
: resp-ok ;
: resp-abort -10000 THROW ;
: resp-retry -10001 THROW ;
: resp-tmretry 10002 THROW ;

\ ----------------------------------

: CMD ( name line \ pars -- )
    CREATE
    HERE TO CUR-CMD /CMD ALLOT
    CUR-CMD /CMD ERASE
    CUR-CMD CMD-PAR C!
    get-string PAD PLACE
    HERE CUR-CMD CMD-STR ! PAD ",
    DOES>
        EXEC-CMD
    ;

: 0CMD 0 CMD ;
: 1CMD 1 CMD ;
: RESP ( a n -- a1)  HERE ROT , SWAP W, :NONAME DROP ;
: :RESP ( -- a ) HERE 0 , ;
: ;RESP ( a -- ) CUR-CMD CMD-RL ! ;
: repeateble 1 CUR-CMD CMD-REP C! ;

0CMD binary "TYPE I"
    :RESP  200 RESP resp-ok ; ;RESP

0CMD ascii  "TYPE A"
    :RESP  200 RESP resp-ok ; ;RESP

0CMD system SYST
    :RESP  215 RESP resp-ok ; ;RESP

0CMD bye QUIT
    :RESP  221 RESP resp-ok ; ;RESP

1CMD list LIST
    :RESP 150 RESP resp-ok ; ;RESP
1CMD port PORT
    :RESP 200 RESP resp-ok ; ;RESP

VARIABLE ESTABL-CONN-RL   \ open response list
:RESP
    120 RESP resp-tmretry ;
    220 RESP resp-ok ;
\    421 RESP resp-abort ;
    ESTABL-CONN-RL !

