\ Set time
REQUIRE CreateSocket ~nn/lib/sock.f
REQUIRE MonLength ~nn/lib/time.f

DECIMAL 
: serv1 S" clock.psu.edu" ;
\ : serv2 S" chime.utoronto.ca" ;

VARIABLE <time>

: TCHGORD
    <time> C@     <time> 1+ C@    <time> 2+ C@    <time> 3 + C@  
    <time> C!     <time> 1+ C!    <time> 2+ C!    <time> 3 + C!
;

( 
: TCHGORD2
    <time> @ 
    DUP   0xFF   AND 24 LSHIFT
    OVER  0xFF00 AND 8  LSHIFT OR
    OVER  0xFF0000 AND 8 RSHIFT OR
    SWAP  0xFF000000 AND 24 RSHIFT OR
    <time> !
;
)

: UT>TIME { u \ d m y -- s m h d m y }
    u 0 60 UM/MOD 
    60 /MOD
    24 /MOD 
    1461 /MOD 4 * TO y 365 /MOD y + 1900 + TO y
    1+
    1 TO m
    13 1
    DO  y I MonLength \ 2DUP . . CR
        2DUP > 
        IF - m 1+ TO m 
        ELSE DROP TO d LEAVE THEN
    LOOP
    d  m  y 
;

: GET-TIME { a u \ s -- }
    SocketsStartup THROW
    CreateSocket THROW TO s
\    CreateUdpSocket THROW TO s
\    5 s SetSocketTimeout THROW
    a u GetHostIP THROW
    GetTickCount SWAP
    37 s ConnectSocket THROW
    <time> 4 s ReadSocket THROW DROP
    GetTickCount SWAP - . CR
    s CloseSocket THROW
    SocketsCleanup THROW
    TCHGORD
    <time> @ UT>TIME . . . . . .
    GET-CUR-TIME ." --- " Min@ . Sec@ . CR
 ;

: test ['] GET-TIME CATCH ?DUP IF ." ERROR # " . 2DROP CR THEN ;
\ serv1 test

: test1
    S" servlist.txt" R/O OPEN-FILE THROW >R
    BEGIN PAD 256 R@ READ-LINE THROW WHILE
        ?DUP 
        IF
            PAD C@ BL <>
            IF PAD SWAP 2DUP + 0 SWAP C!
               2DUP TYPE SPACE
               test
            THEN
        THEN
    REPEAT
    DROP
    R> CLOSE-FILE DROP
;
\ test1

\  2,208,988,800 corresponds to 00:00  1 Jan 1970 GMT
\ 2208988800 UT>TIME . . . . . . CR 

\  2,398,291,200 corresponds to 00:00  1 Jan 1976 GMT
\ 2398291200 UT>TIME . . . . . . CR

\  2,524,521,600 corresponds to 00:00  1 Jan 1980 GMT
\ 2524521600 UT>TIME . . . . . . CR

\  2,629,584,000 corresponds to 00:00  1 May 1983 GMT
\ 2629584000 UT>TIME . . . . . . CR
