\ Forth console
REQUIRE SocketLine ~nn/lib/net/socketline.f
REQUIRE <ACCEPT> ~nn/lib/spf4/con_io.f
REQUIRE [NONAME ~nn/lib/noname.f 
\ REQUIRE MARKER lib/ext/core-ext.f
REQUIRE EVAL-SUBST ~nn/lib/subst1.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
REQUIRE FIT-MASK? ~nn/lib/masks.f
REQUIRE GET ~nn/lib/mutex.f

USER SNIF-IOR
VECT SNIF-LOG  
VECT SNIF-ON-CONNECT     ' NOOP TO SNIF-ON-CONNECT
VECT SNIF-ON-DISCONNECT  ' NOOP TO SNIF-ON-DISCONNECT

VARIABLE RemAllowed
VARIABLE RemDisallowed


( 
VARIABLE SNIF-RES

: CONg SNIF-RES GET ;
: CONr SNIF-RES RELEASE ;
)

:NONAME EVAL-SUBST TYPE CR ; TO SNIF-LOG

MODULE: SNIFFER

USER TargetHost
USER TargetPort

: ?SNIF-ERROR
    ?DUP IF SNIF-IOR ! S" Sniffer server error # %SNIF-IOR @%." SNIF-LOG THEN
;

Socket POINTER ss   \ server socket
Socket POINTER ts   \ target socket
SocketLine POINTER sl




:NONAME ( buf -- )
    [NONAME
        >R
        BEGIN
           R@ @ ->CLASS SocketLine ReadLine 2DUP TYPE CR
           R@ CELL+ @  ->CLASS SocketLine WriteLine
        AGAIN
    NONAME] CATCH ERROR
; TASK: TRANSFER

: TRANSFER-TASK ( from to -- )
    2 CELLS GLOBAL ALLOCATE LOCAL THROW >R  SWAP R@ ! R@ CELL+ !
    R> TRANSFER START ;

: DO-SNIF ( socket -- )
    [NONAME
      SocketLine NEW TO sl 
      DUP 
      ->CLASS Socket vSock @   sl vSock !
      DELETE
      S" Connection is established." SNIF-LOG
      sl SELF ts SELF TRANSFER-TASK DROP
      ts SELF sl SELF TRANSFER-TASK DROP
      BEGIN
        10000 PAUSE
      AGAIN
    NONAME] CATCH ERROR
;

CLASS: SNIF 
    var vPort
    var vTargetHost
    var vTargetPort
    CONSTR: init ( a u tp p -- )
        vPort !
        vTargetPort !
        S>ZALLOC vTargetHost ! ;
;CLASS

SNIF POINTER snif
:NONAME ( snif -- )
    TO snif
    DECIMAL
    S0 @ SP! R0 @ RP!
    [NONAME
    SocketLine NEW TO ts 
    snif vTargetHost @ ASCIIZ> ts Addr!
    snif vTargetPort @ ts vPort !
    ts Create
    ts Connect
    Socket NEW TO ss
    ss Create  
    snif vPort @ ss vPort ! ss Bind ss Listen
    S" Sniffer server is started." SNIF-LOG
    BEGIN
      ss Accept DO-SNIF
    AGAIN
    NONAME] CATCH ERROR
; TASK: SNIFFER-SERVER

EXPORT

: START-SNIFFER-SERVER ( S" target-host" target-port port -- ) 
    SNIF GLOBAL NEW LOCAL SNIFFER-SERVER START  CLOSE-FILE DROP ;

;MODULE

\ S" localhost" 2401 2403 START-SNIFFER-SERVER
S" localhost" 8700 9700 START-SNIFFER-SERVER
