REQUIRE CLASS: ~nn/class/class.f
REQUIRE CreateSocket ~nn/lib/sock.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE GET ~nn/lib/mutex.f

CLASS: Socket
    var vSock
    var vPort
    var vAddr   \ az IP or hostname
    var vIOR    \ i/o result

    M: Sock vSock @ ;
VARIABLE SOCKET-INIT
VARIABLE SOCKET-RES
: sTHROW ( ior -- ) ?DUP IF DUP vIOR ! THROW THEN ;

: ?INIT 
    SOCKET-RES GET
    SOCKET-INIT @ 0=
    IF SocketsStartup ELSE 0 THEN
    SOCKET-INIT 1+!
    SOCKET-RES RELEASE    
    sTHROW
;

: ?CLEAN
    SOCKET-RES GET
    SOCKET-INIT @ 0 >
    IF -1 SOCKET-INIT +! THEN
    SOCKET-INIT @ 0=
    IF SocketsCleanup ELSE 0 THEN
    SOCKET-RES RELEASE
    sTHROW
;

CONSTR: init ?INIT ;
DESTR: free ?CLEAN ;

M: Addr! ( a u -- ) S>ZALLOC vAddr ! ;
M: Create ( -- )  CreateSocket sTHROW vSock ! ;
M: Bind   ( -- )  vPort @ Sock BindSocket sTHROW ;
M: Listen Sock ListenSocket sTHROW ;
M: Read ( a u -- rlen ) Sock ReadSocket sTHROW ;
M: Write ( a u -- ) Sock WriteSocket sTHROW ;
M: WriteLine Sock WriteSocketLine sTHROW ;
M: WriteCRLF Sock WriteSocketCRLF sTHROW ;
M: Accept ( -- new-socket-object)
    Sock AcceptSocket sTHROW
    Socket NEW  >R R@ => vSock ! R>
;
M: PeerName ( -- a u ) Sock GetPeerName sTHROW ;
M: PeerIP ( -- n) Sock GetPeerIP sTHROW ;
M: SetTimeout ( timeout -- ) Sock SetSocketTimeout sTHROW ;
M: ToRead ( -- n) Sock ToRead sTHROW ;

M: IPAddr ( -- IP)
    vAddr @ 0= ABORT" vAddr is 0"
    vAddr @AZ GetHostIP sTHROW ;

M: Connect ( -- ) IPAddr vPort @ Sock ConnectSocket sTHROW ;

M: Close Sock vSock 0! CloseSocket sTHROW ;

;CLASS
