REQUIRE { ~nn/lib/locals.f
REQUIRE Socket ~nn/lib/net/socket.f


CLASS: SocketLine <SUPER Socket
    var vPoint
    var vLast
    var vBuf

10000 VALUE LINE_BUFF_SIZE         \  

\ 0                                  \  " "
\ 4 -- sl_socket                     \  
\ 4 -- sl_point                      \      
\ 4 -- sl_last                       \      
\ CONSTANT /sl

M: InitLast  vBuf @ vLast ! ;
CONSTR: init
    init
    LINE_BUFF_SIZE ALLOCATE THROW vBuf !
    InitLast vPoint 0! ;
DESTR: free vBuf @ ?DUP IF FREE THROW THEN ;

\ SocketLine       
\     

\ : SocketLine ( socket -- addr-S )
\  { \ addr }
\  LINE_BUFF_SIZE /sl + ALLOCATE THROW => addr
\  addr sl_socket !
\  addr sl_point 0!
\  addr /sl + addr sl_last !
\  addr
\ ;

\ GetPending    ,   ,
\     

M: GetPending ( -- addr u )
  vLast @  vBuf @  vPoint @ + OVER - 0 MAX
;

\ ReadFromPending      
\   u1 
\  , ..   ""  .

M: ReadFromPending ( max-len -- addr u ) \ u2 <= u1
  { max-len }
  GetPending NIP max-len > 0=
  IF GetPending
     vPoint 0!  InitLast
  ELSE
     GetPending max-len MIN
     vLast @ OVER + vLast !
  THEN
;

\ SocketContRead
\

M: ContRead1 ( -- )
    { \ a u }
  GetPending
  OVER C@ 10 ( LF ) = OVER 0 > AND IF 1- SWAP 1+ SWAP THEN  TO u TO a
  a vBuf @ u MOVE
  InitLast

  vBuf @ u +
  LINE_BUFF_SIZE u - DUP 0 >
  IF
    Read
    u + vPoint !
  ELSE 2DROP THEN
;
M: ContRead ( -- )
  { \ a u }
    GetPending TO u TO a
    a vBuf @ u MOVE
    InitLast

    vBuf @  u +
    LINE_BUFF_SIZE u -  Read
    u + vPoint !
;

\ SocketReadLine  ,  LF  CRLF
\       .
\     ,   
\ ,      .  
\     .
\    ,      
\ ,      
\ ( ).    
\        ,  ..
\   ,      
\ ,      ...

M: ReadLine ( -- addr u )
  { \ pa1 pu1 acr }
  GetPending TO pu1 TO pa1
  pa1 pu1 LT 1+ 1 SEARCH
  IF
      DROP TO acr
      acr 1+ vLast !
      pa1 acr OVER - 2DUP + 1- C@ 13 = IF 1- 0 MAX THEN
  ELSE
     2DROP
     pu1 LINE_BUFF_SIZE =
     IF
        vPoint 0!
        InitLast
        pa1 pu1 EXIT
     THEN
     ContRead RECURSE
  THEN
;

M: Accept ( -- new-socket-object)
    Sock AcceptSocket sTHROW
    SocketLine NEW  >R R@ => vSock ! R>
;

;CLASS
