REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE [NONAME ~nn/lib/noname.f
REQUIRE S>ZALLOC ~nn/lib/az.f
REQUIRE DEBUG? ~nn/lib/qdebug.f

REQUIRE EVAL-SUBST ~nn/lib/subst1.f
\ REQUIRE GLOBAL ~nn/lib/globalloc.f

\ WINAPI: re_start regexp.dll
\ WINAPI: re_next regexp.dll
\ WINAPI: re_stop regexp.dll

WINAPI: SetLastError KERNEL32.DLL
WINAPI: GetModuleHandleA KERNEL32.DLL
WINAPI: FreeLibrary KERNEL32.DLL

: re_dll S" regexp.dll" DROP ;
: re_load re_dll LoadLibraryA ERR THROW ;
: re_free re_dll GetModuleHandleA ?DUP IF FreeLibrary DROP THEN ;
: re_api \ a u -- ?
    DROP re_dll GetModuleHandleA ?DUP 
    IF GetProcAddress ?DUP 
        IF API-CALL ELSE GetLastError THROW THEN
    ELSE GetLastError THROW THEN  ;

: re_start S" re_start" re_api ;
: re_stop  S" re_stop"  re_api ;
: re_next  S" re_next"  re_api ;

USER RE-H
USER RE-XT

0
1  CELLS -- re_re
16 CELLS -- re_s
16 CELLS -- re_e
1  CELLS -- re_cnt
1  CELLS -- re_last_res
1  CELLS -- re_text
1  CELLS -- re_pat
1  CELLS -- re_last_beg
CONSTANT /RE

: RE-START ( text u1 re u2 -- re-handle ?)
    /RE ALLOCATE THROW >R
    S>ZALLOC R@ re_pat !
    S>ZALLOC R@ re_text !
    re_load
    R> DUP re_start ;

: RE-NEXT ( re-handle -- ?) re_next ;
: RE-STOP ( re-handle -- ?) 
    DUP >R re_stop 
    R@ re_pat @ FREE THROW
    R@ re_text @ FREE THROW
    R> FREE THROW 
    re_free
;

: RE RE-H @ ;
: $RE ( # -- a u )
    DUP RE re_cnt @ <
    OVER CELLS RE re_s + @ 0< 0= AND
    IF
        CELLS >R
        RE re_s R@ + @ 
        RE re_text @ OVER + RE re_last_beg @ +
        RE re_e R> + @ ROT -
    ELSE DROP S" " THEN
;

: $RE: CREATE C, DOES> C@ $RE ;

0 $RE: $0          1 $RE: $1            2 $RE: $2          3 $RE: $3
4 $RE: $4          5 $RE: $5            6 $RE: $6          7 $RE: $7
8 $RE: $8          9 $RE: $9            10 $RE: $10        11 $RE: $11
12 $RE: $12        13 $RE: $13          14 $RE: $14        15 $RE: $15

: RE-MATCH ( a-text u-text a-re u-re -- ?)
    [ DEBUG? ] [IF] ." RE: '" 2OVER TYPE ." '~'" 2DUP TYPE ." '=" [THEN]
    RE-START SWAP RE-STOP DROP
    [ DEBUG? ] [IF] DUP . CR [THEN]
     ;
: RE-MATCH$ ( # a-text u-text a-re u-re -- a u ?)
   RE-START SWAP RE-H ! IF $RE EVAL-SUBST TRUE ELSE S" " FALSE THEN
   RE-H @ RE-STOP DROP
;
: (RE-ALL) ( a-text u-text a-re u-re xt -- )
    RE-H @ >R RE-XT @ >R 
    RE-XT !
    RE-START SWAP RE-H !
    IF
        BEGIN
            RE-XT @ CATCH 
            IF
                TRUE
            ELSE
                RE-H @ RE-NEXT 0=
            THEN
        UNTIL
    THEN
    RE-H @ RE-STOP DROP
    R> RE-XT ! R> RE-H !
;

: RE-ALL POSTPONE [NONAME ; IMMEDIATE
: ;RE-ALL POSTPONE NONAME] POSTPONE (RE-ALL) ; IMMEDIATE

<EOF>

: TEST1
    S" xxxxhttp://xx.yy.com/zz/yy/aa.zipcbcbcbcftp://xx.yy.com/zz/yy/aa.rareieruiywuywi" 
    S" /(http)|(ftp):\/\/[^ ]+?\.(zip)|(rar)|(gz)|(bz2)|(tar)/"
    RE-ALL
        $0 TYPE CR
        KEY DROP
    ;RE-ALL
;

TEST1

<EOF>
: TEST2 ( text u re u -- )
    RE-START
    IF
        >R
        ." Matches:" CR
        BEGIN 
            R@ RE-GET TYPE CR
            R@ RE-NEXT 0=
        UNTIL
        R> RE-STOP
    ELSE 
        DROP ." no matches" CR 
    THEN
;

: T1
    S" xxxxhttp://xx.yy.com/zz/yy/aa.zipcbcbcbcftp://xx.yy.com/zz/yy/aa.rareieruiywuywi" 
    S" /(http)|(ftp):\/\/.+?\.(zip)|(rar)|(gz)|(bz2)|(tar)/"
    TEST2
;
T1