REQUIRE { ~nn/lib/locals.f
REQUIRE WinNT? ~nn/lib/winver.f

DECIMAL

WINAPI: GetSidLengthRequired ADVAPI32.DLL
WINAPI: InitializeSid ADVAPI32.DLL
WINAPI: GetSidSubAuthority ADVAPI32.DLL
WINAPI: InitializeAcl ADVAPI32.DLL
WINAPI: AddAccessAllowedAce ADVAPI32.DLL
WINAPI: InitializeSecurityDescriptor ADVAPI32.DLL
WINAPI: SetSecurityDescriptorDacl ADVAPI32.DLL

64 CONSTANT ACL-SIZE
CREATE AclBuf ACL-SIZE ALLOT
VARIABLE AclCreated

CREATE siaWorld 1 , 0 W,
CREATE siaCreator 3 , 0 W, 
CREATE BufEveryoneSid 32 ALLOT  BufEveryoneSid 32 ERASE
CREATE BufOwnerSid 32 ALLOT     BufOwnerSid 32 ERASE

CREATE SecAttr 3 CELLS , 0 , TRUE , 
CREATE SecD 20 ALLOT SecD 20 ERASE

: EveryoneAcl { access \ cbAclSize -- pAcl }
    WinNT? 0= IF 0 EXIT THEN
    AclCreated @ 0=
    IF
\ calc ACL size
        24 1 GetSidLengthRequired 2* + TO cbAclSize
        cbAclSize ACL-SIZE > IF 0 EXIT THEN
\ intialize well known sids 
        1 siaWorld BufEveryoneSid InitializeSid 0= IF 0 EXIT THEN
        0 BufEveryoneSid GetSidSubAuthority SECURITY_WORLD_RID SWAP !

        1 siaCreator BufOwnerSid InitializeSid 0= IF 0 EXIT THEN
        0 BufOwnerSid GetSidSubAuthority SECURITY_CREATOR_OWNER_RID SWAP !

        ACL_REVISION cbAclSize AclBuf InitializeAcl 0= IF 0 EXIT THEN

        BufEveryoneSid access ACL_REVISION AclBuf AddAccessAllowedAce 0= IF 0 EXIT THEN
        BufOwnerSid FILE_ALL_ACCESS ACL_REVISION AclBuf AddAccessAllowedAce 0= IF 0 EXIT THEN
        TRUE AclCreated !
    THEN
    AclBuf ;

: EveryoneSA { access \ pacl -- secur_attr }
    WinNT? 0= IF 0 EXIT THEN
    access EveryoneAcl ?DUP 0= IF 0 EXIT THEN TO pacl
    SECURITY_DESCRIPTOR_REVISION SecD InitializeSecurityDescriptor
        0= IF 0 EXIT THEN
    FALSE pacl TRUE SecD SetSecurityDescriptorDacl
        0= IF 0 EXIT THEN
    0 SecAttr CELL+ !
    SecAttr
;

\ BOOL 
\ BuildNamedPipeAcl( 
\    PACL pAcl, 
\    PDWORD cbAclSize 
\    ) 
\ { 
\    DWORD dwAclSize; 
 
\    SID_IDENTIFIER_AUTHORITY siaWorld = SECURITY_WORLD_SID_AUTHORITY; 
\    SID_IDENTIFIER_AUTHORITY siaCreator = SECURITY_CREATOR_SID_AUTHORITY; 
 
\    BYTE BufEveryoneSid[32]; 
\    BYTE BufOwnerSid[32]; 
 
\    PSID pEveryoneSid = (PSID)BufEveryoneSid; 
\    PSID pOwnerSid = (PSID)BufOwnerSid; 
\ 
\    // 
\    // compute size of acl 
\    // 
\    dwAclSize = sizeof(ACL) + 
\        2 * ( sizeof(ACCESS_ALLOWED_ACE) - sizeof(DWORD) ) + 
\        GetSidLengthRequired( 1 ) + // well-known Everyone Sid 
\        GetSidLengthRequired( 1 ) ; // well-known Creator Owner Sid 
 
\    if(*cbAclSize < dwAclSize) { 
\        *cbAclSize = dwAclSize; 
\        return FALSE; 
\    } 
 
\    *cbAclSize = dwAclSize; 
\ 
\    // 
\    // intialize well known sids 
\    // 
\ 
\    if(!InitializeSid(pEveryoneSid, &siaWorld, 1)) return FALSE; 
\    *GetSidSubAuthority(pEveryoneSid, 0) = SECURITY_WORLD_RID; 
 
\    if(!InitializeSid(pOwnerSid, &siaCreator, 1)) return FALSE; 
\    *GetSidSubAuthority(pOwnerSid, 0) = SECURITY_CREATOR_OWNER_RID; 
 
\    if(!InitializeAcl(pAcl, dwAclSize, ACL_REVISION)) 
\        return FALSE; 
\ 
\    // 
\    // 
\    if(!AddAccessAllowedAce( 
\        pAcl, 
\        ACL_REVISION, 
\        FILE_GENERIC_READ | FILE_GENERIC_WRITE, 
\        pEveryoneSid 
\        )) 
\        return FALSE; 
\ 
\    // 
\    // 
\    return AddAccessAllowedAce( 
\        pAcl, 
\        ACL_REVISION, 
\        FILE_ALL_ACCESS, 
\        pOwnerSid 
\        ); 
\ } 
