#include <windows.h>
#include "md5.h"

MD5_CTX * CALLBACK MD5Init(){
    MD5_CTX * md5Info=(MD5_CTX *)GlobalAlloc(GPTR,sizeof(MD5_CTX));
    MD5_Init(md5Info); 
    return md5Info;
}

void CALLBACK MD5Update(MD5_CTX * md5Info, const BYTE * inBuffer, const int length ){
    MD5_Update(md5Info, (BYTE *)inBuffer, length);
}

void CALLBACK MD5Final(MD5_CTX * md5Info, BYTE * outBuffer){
    MD5_Final(outBuffer, md5Info );
    GlobalFree(md5Info);
}

void CALLBACK MD5Full(const BYTE * inBuffer, const int length, BYTE *outBuffer){
    MD5_CTX *md5Info, md5InfoBuffer;

    md5Info = &md5InfoBuffer;

    MD5_Init( md5Info );
    MD5_Update( md5Info, ( BYTE * ) inBuffer, length );
    MD5_Final( outBuffer, md5Info );
}

void CALLBACK MD5File(char *filename, BYTE *outBuffer){
    HANDLE fh=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0);
}

BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}
