REQUIRE ?FREE ~nn/lib/free.f
REQUIRE [NONAME ~nn/lib/noname.f

MODULE: MD5-MODULE

WINAPI: MD5Init md5.dll
\ void MD5Init(struct MD5Context *ctx)
WINAPI: MD5Update md5.dll
\ void MD5Update(struct MD5Context *ctx, unsigned char const *buf, unsigned len);
WINAPI: MD5Final md5.dll
\ void MD5Final(struct MD5Context *ctx, unsigned char digest[16]);
WINAPI: MD5Full md5.dll
\ void MD5Full(unsigned char const * inBuffer, int length, unsigned char *outBuffer);
WINAPI: MD5ContextSize md5.dll

USER-VALUE fh
USER-VALUE buf
USER-VALUE info
1024 VALUE MD5bufsize

: md5file ( digest a u \  -- )
    [NONAME
    R/O OPEN-FILE-SHARED THROW TO fh
    MD5ContextSize ALLOCATE THROW TO info
    info MD5Init DROP
    MD5bufsize ALLOCATE ?DUP 
    IF info FREE DROP
       fh CLOSE-FILE DROP
        THROW THEN TO buf
    BEGIN buf MD5bufsize fh READ-FILE THROW ?DUP WHILE
      buf info MD5Update DROP
    REPEAT
    ( digest --)  info MD5Final DROP
    NONAME] CATCH DUP IF >R 2DROP DROP R> THEN
    info ?FREE
    buf ?FREE
    fh ?DUP IF CLOSE-FILE DROP THEN
;

CREATE DIGIT$
  48 C, 49 C, 50 C, 51 C, 52 C, 53 C, 54 C, 55 C, 56 C, 57 C,
  97 C, 98 C, 99 C, 100 C, 101 C, 102 C,

EXPORT
WARNING @ WARNING 0!
: MD5Init ( -- MD5context) MD5ContextSize ALLOCATE DUP THROW MD5Init DROP ;
: MD5Update ( a u MD5Context --) >R SWAP R> MD5Update DROP ;
: MD5Final ( digest MD5context --) >R R@ MD5Final DROP R> FREE THROW ;
: MD5Full ( digest a u --) SWAP MD5Full DROP ;
: MD5File ( digest a u -- ior ) md5file ;
: MD5String ( digest -- a u) 
    <#
        DUP 15 + 
        DO 
            I C@ DUP 15 AND DIGIT$ + C@ HOLD
            4 RSHIFT DIGIT$ + C@ HOLD
        -1 
        +LOOP
        0 0 #>
;

: MD5StoD ( digest a u -- )
    BASE @ >R HEX

    R> BASE !
;

WARNING !

;MODULE

REQUIRE \EOF ~nn/lib/eof.f
\ EOF

\ test
REQUIRE TIMER-RESET ~nn/lib/timer.f

10000 VALUE N#
: [TEST]  PAD S" ABCDEFGHIJKLMNOPQRSTUVWXYZ" MD5Full ;
: SPEED-TEST2 [ DECIMAL ]
  CR ." md5 test for " N# . ." loops in milliseconds is "
    TIMER-RESET  N# 0 DO [TEST] LOOP  .ELAPSED
;

10000 CONSTANT #TESTSPACE

CREATE TESTSPACE #TESTSPACE ALLOT  TESTSPACE #TESTSPACE BL FILL

: SPEED-TEST
   CR ." MD5 TEST: BUFFER OF " #TESTSPACE . ." SPACES DONE " N# . ." TIMES IS "
   TIMER-RESET N# 0 DO  PAD TESTSPACE #TESTSPACE MD5Full  LOOP  .ELAPSED
   CR ." HASH IS: " PAD MD5String TYPE  CR
;

: .MD5 ( a u -- ) 2DUP PAD ROT ROT MD5Full PAD MD5String TYPE SPACE  ." '" TYPE ." ' " CR ;

: MD5Test ( -- ) \ complete test with correct results and founded ones !
  ." MD5 test suite results:"
  CR ." The correct results are: (Fred Warren's message dated 8Nov00 18:37)"

  CR ." d41d8cd98f00b204e9800998ecf8427e ''"
  CR ." 0cc175b9c0f1b6a831c399e269772661 'a'"
  CR ." 900150983cd24fb0d6963f7d28e17f72 'abc'"
  CR ." f96b697d7cb7938d525a2f31aaf161d0 'message digest'"
  CR ." c3fcd3d76192e4007dfb496cca67e13b 'abcdefghijklmnopqrstuvwxyz'"
  CR ." d174ab98d277d9f5a5611c2c9f419d9f 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'"
  CR ." 57edf4a22be3c955ac49da2e2107b67a '12345678901234567890123456789012345678901234567890123456789012345678901234567890'"
  CR ." f38898bb69bb02bccb9594dfe471c5c0 '10,000 spaces'"
  CR ." The MD5test Results are:" CR
  S" " .MD5
  S" a" .MD5
  S" abc" .MD5
  S" message digest" .MD5
  S" abcdefghijklmnopqrstuvwxyz" .MD5
  S" ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789" .MD5
  S" 12345678901234567890123456789012345678901234567890123456789012345678901234567890" .MD5 
  ( RFC1939 POP3 :)
\  S" <1896.697170952@dbc.mtview.ca.us>tanstaaf" .MD5
\  TESTSPACE #TESTSPACE .MD5
  SPEED-TEST CR
  [TEST] PAD MD5String TYPE CR
;

REQUIRE ENV ~nn/lib/env.f
: filename
    S" COMPUTERNAME" ENV S" NNN" COMPARE 0=
    IF
         S" e:\home\distr\xp\xpsp1_en_x86.exe" 
    ELSE S" C:\downloads\W2Ksp3.exe" THEN
;
: MD5FileTest
    TIMER-RESET
    PAD filename MD5File THROW
    PAD MD5String TYPE CR
    .ELAPSED CR
;

\ MD5Test
\ MD5FileTest
