REQUIRE SHA256 ~nn/lib/security/sha256.f
REQUIRE HASH. ~nn/lib/security/sha256display.f

\ ====================  File hash wordset  ====================
  VARIABLE  rfileid     \ Holds fileid number of input file

: InputFileName  ( -- ior)
  CR  CR  ." Filename: "  PAD  DUP  80  ACCEPT ( adr #)
  2DUP + 0 SWAP C!
  R/O  OPEN-FILE  SWAP  rfileid !  ( ior)
;

: TryAgain?  ( -- ?)
  CR  CR ." Invalid iput file, try again? (Y/N)"
  KEY  DUP  EMIT  DUP [CHAR] N =  SWAP [CHAR] n = OR
;

\ Read n bytes from input file, store at addr array
: bytes@  ( adr n - )  rfileid @  READ-FILE  2DROP ;

: storelen  ( lo hi - )  \ Store count into last two cells
  D2*  D2*  D2*  [ W 56 CHARS + ]L !  [ W 60 CHARS + ]L !
;

: getpartial ( cnt  -- W'  cnt2 ?)
  W  2DUP  SWAP  DUP >R  bytes@        ( cnt1 adr1  )
  + 128 OVER C! CHAR+ 55 R@ - R> 55 >  ( adr2 cnt2 ?)
;

MACRO block@  " W  64  bytes@ "

: SHAfile ( -- )
  BEGIN  InputFileName  ( ior)                  \ Enter filename
  WHILE  TryAgain? IF  EXIT  THEN               \ Not valid, try (not) again
  REPEAT SHAinit                                \ Valid file, init transform
  rfileid @  FILE-SIZE  DROP  ( ud )            \ Get bytesize of input file
  2 0  D-                                       \ Dec cnt by 2 for CR|LF EOF
  CR ." Bytesize: " 2DUP  D.                    \ Display filesize to screen
  2DUP  2>R                                     \ Save message cnt on RETURN
  64  UM/MOD  ( rembytes nblocks )              \ Compute nblocks & rembytes
  0 ?DO  block@  W endian16  SHA256  LOOP       \ Do n full blocks
  ( rembytes)  getpartial ( adr cnt ?)          \ Read remaining bytes
  IF 8 + 0 FILL  W endian16  SHA256  W 56 THEN  \ Do if rembytes > 55
  0 FILL  2R> storelen  W endian14  SHA256      \ Do last block
  CR  ." SHA-256 : "  SHAstring  TYPE  CR       \ Show SHA-256 hash for file
  rfileid @  CLOSE-FILE  DROP                   \ Close the input file
;

