REQUIRE PLACE lib/ext/string.f
REQUIRE <TIB  ~nn/lib/tib.f
REQUIRE ZPLACE ~nn/lib/az.f
REQUIRE DEBUG? ~nn/lib/qdebug.f
REQUIRE GETENV ~nn/lib/env.f

: PAD1 PAD 257 + ;
: PAD2 PAD 514 + ;


64  VALUE SUBST-NUM-BUFS
256 CONSTANT INIT-SUBST-LEN


\ USER-CREATE SUBST-BUFS  SUBST-NUM-BUFS CELLS USER-ALLOT
USER SUBST-BUFS

USER SUBST-LEN
USER SUBST-BUF-LEN
USER SUBST-IGNORE-ERRORS
USER SUBST-DECREASE \       
USER SUBST-SP       \      ( )

USER-VALUE #SUBST
USER-VALUE SUBST-BUF
USER-CREATE SUBST-SRC 2 CELLS USER-ALLOT

VECT EVAL-SUBST-ERROR
:NONAME ( a u -- )
    ." Error macro variable substitution:" TYPE CR ; TO EVAL-SUBST-ERROR

: <SUBST ( a u -- )
    SUBST-BUFS @ 0= IF SUBST-NUM-BUFS CELLS ALLOCATE THROW SUBST-BUFS ! THEN
     R>
    SUBST-SRC 2@ 2>R    SUBST-BUF >R
    SUBST-BUF-LEN @ >R  SUBST-LEN @ >R
    SUBST-SP @ >R
    SUBST-DECREASE @ >R
    >R
    SUBST-SRC 2!
    SP@ SUBST-SP !
    SUBST-DECREASE 0!
    #SUBST ABS SUBST-NUM-BUFS MOD TO #SUBST
    #SUBST CELLS SUBST-BUFS @ + TO SUBST-BUF
    SUBST-BUF @ ?DUP IF FREE DROP THEN
    INIT-SUBST-LEN SUBST-BUF-LEN !
    INIT-SUBST-LEN ALLOCATE THROW SUBST-BUF !
    SUBST-BUF @ 0!
    SUBST-LEN 0!
    STATE 0!
    #SUBST 1+ TO #SUBST
;
: SUBST> ( -- a u)
    SUBST-DECREASE @ 0 ?DO DROP LOOP
    SUBST-BUF @ ( ASCIIZ>) SUBST-LEN @
    R>
    R> SUBST-DECREASE !
    R> SUBST-SP !
    R> SUBST-LEN !   R>  SUBST-BUF-LEN !
    R> TO SUBST-BUF  2R> SUBST-SRC 2!
    >R
;

: ZMOVE ( a u a1 -- )  2DUP 2>R SWAP MOVE 2R> + 0 SWAP C! ;
: SUBST+  { a u \ newbuf -- }
\    [ DEBUG? ] [IF] ." SUBST+: " a u TYPE CR [THEN]
    u SUBST-BUF-LEN @ SUBST-LEN @ - 1+ >
    IF  SUBST-BUF-LEN @ u + 256 + DUP SUBST-BUF-LEN !
        ALLOCATE THROW TO newbuf
        SUBST-BUF @ SUBST-LEN @ newbuf ZMOVE
        SUBST-BUF @ FREE THROW
        newbuf SUBST-BUF !
    THEN
    a u SUBST-BUF @ SUBST-LEN @ + ZMOVE
    u SUBST-LEN +!
;


0 [IF]
: ENV1 { a u \ az buf -- a1 u1 }
\    DEBUG?  IF ." ENV1: " a . u . a u TYPE CR THEN
    a u S>ZALLOC TO az
    255 ALLOCATE THROW TO buf
    255 buf az GetEnvironmentVariableA ?DUP 0=
    IF buf FREE THROW az FREE THROW
        S" " EXIT THEN
    DUP 255 >
    IF buf FREE THROW
       DUP ALLOCATE THROW TO buf
       buf az GetEnvironmentVariableA
    THEN
    az FREE THROW
    buf SWAP
;
[THEN]

: ?EVAL-SUBST-ERROR
    SUBST-IGNORE-ERRORS @ 0=
    IF EVAL-SUBST-ERROR
    ELSE S" %" SUBST+ SUBST+
        EndOfChunk 0= IF S" %" SUBST+ THEN
    THEN
;

: EVAL-SUBST ( a u -- a1 u1)
\ [ DEBUG? ] [IF] ." EVAL-SUBST START. DEPTH = " DEPTH . CR [THEN]
\  2DUP
  DUP >R S>ZALLOC R> OVER >R
\  DEBUG?  IF ." DEPTH=" DEPTH . ." Subst inp: " 2DUP ." <" TYPE ." >" CR THEN
  <SUBST
  SUBST-SRC 2@ <TIB
  BEGIN
      BEGIN                \  ." 1:" TIB >IN @ + #TIB @ >IN @ - TYPE CR
       [CHAR] % PARSE      \ ." 2:" 2DUP TYPE CR
       SUBST+
       GetChar
       IF
         [CHAR] % =
         IF
            S" %" SUBST+  >IN 1+!
            FALSE
         ELSE TRUE THEN
       ELSE DROP TRUE THEN
      UNTIL
      [CHAR] % PARSE DUP \  ." 3:" .S CR
  WHILE
     >IN @ >R SP@ >R
\        ." <" 2DUP TYPE ." >" CR
     2DUP ['] EVALUATE CATCH 
\ [ DEBUG? ] [IF] DUP IF ." EVAL-SUBST ERROR # " DUP . ."  DEPTH = " DEPTH . CR THEN [THEN]
     IF
        \ ERROR
        2DROP RDROP R>
        TIB> SUBST-SRC 2@ <TIB >IN !
        2DUP GETENV THROW ?DUP
        IF 2DUP SUBST+ DROP FREE THROW
        ELSE DROP
          2DUP ?EVAL-SUBST-ERROR
        THEN
     ELSE
         SP@ R@ ( sp) SWAP - DUP 2 CELLS =
         IF \  
            DROP RDROP SUBST+
         ELSE
         1 CELLS =
         IF \  
             RDROP DUP >R ABS S>D <# #S R> SIGN #>
             SUBST+
         ELSE \        
             R> SP!
             SUBST-SRC 2@ ?EVAL-SUBST-ERROR
         THEN THEN
         RDROP
     THEN
     2DROP
  REPEAT
  2DROP
  TIB>
  SUBST>
\  DEBUG? IF ." DEPTH=" DEPTH . ." Subst out: " 2DUP ." <" TYPE ." >" CR THEN

  R> FREE DROP
\ [ DEBUG? ] [IF] ." EVAL-SUBST STOP. DEPTH = " DEPTH . CR [THEN]
\ ." --<" 2SWAP TYPE ." >--" CR
;

: EVAL-SUBST/ie ( a u -- a1 u1)
    SUBST-IGNORE-ERRORS @ >R
    SUBST-IGNORE-ERRORS ON
    EVAL-SUBST
    R> SUBST-IGNORE-ERRORS !
;

0 [IF] -- Old version
: EVAL-SUBST ( a u -- a1 u1)
\    ORDER
  DEBUG?  IF ." Subst inp: " 2DUP TYPE CR THEN
  <SUBST
  SUBST-SRC 2@ <TIB
  BEGIN
                        \  ." 1:" TIB >IN @ + #TIB @ >IN @ - TYPE CR
      [CHAR] % PARSE    \  ." 2:" 2DUP TYPE CR
      SUBST+
      [CHAR] % PARSE DUP \  ." 3:" .S CR
  WHILE
    2DUP ENV1 ?DUP
    IF 2DUP SUBST+ DROP FREE THROW 2DROP
    ELSE DROP
        >IN @ >R SP@ >R
\        ." <" 2DUP TYPE ." >" CR
        2DUP ['] EVALUATE CATCH   \   ." 4:" .S CR
        IF 2DROP RDROP R>
           TIB> SUBST-SRC 2@ <TIB >IN !
           2DUP EVAL-SUBST-ERROR
        ELSE
            SP@ R@ ( sp) SWAP - DUP 2 CELLS =
            IF \  
               DROP RDROP SUBST+
            ELSE
            1 CELLS =
            IF \  
                RDROP DUP >R ABS S>D <# #S R> SIGN #>
                SUBST+
            ELSE \        
                R> SP!
                SUBST-SRC 2@ EVAL-SUBST-ERROR
            THEN THEN
            RDROP
        THEN
        2DROP
     THEN
  REPEAT
  2DROP
  TIB>
  SUBST>

  DEBUG? IF ." Subst out: " 2DUP TYPE CR THEN
\  SUBST-BUF 100 DUMP CR
;
[THEN]


\ : STR@ ( a -- a1 u ) ASCIIZ> EVAL-SUBST ;
: S! ( a u a1 -- ) >R S>ZALLOC R> ! ;
: FILE ( addr u -- addr1 u1 )
  S>SZ OVER >R
  0 0 <SUBST
  R/O OPEN-FILE-SHARED IF DROP SUBST> R> FREE THROW EXIT THEN  >R
  R@ FILE-SIZE THROW D>S DUP ALLOCATE THROW  ( # a -- )
  DUP ROT R@ READ-FILE THROW
  2DUP SUBST+ DROP
  R> CLOSE-FILE THROW
  FREE THROW
  SUBST>
  R> FREE THROW
;

: FILE: BL SKIP 1 PARSE ['] FILE CATCH IF 2DROP S" " THEN ;

CREATE <CRLFCRLF> 13 C, 10 C, 13 C, 10 C,
CREATE <CRLF> 13 C, 10 C,

: CRLF <CRLF> 2 ;
: 2CRLF <CRLFCRLF> 4 ;
: crlf CRLF ;

CREATE QUOT 1 C, CHAR " C, 0 C,
: QUOTE QUOT COUNT ;
: PERCENT S" %" ;

: esPICK ( n1 -- n2 )
    DUP 1+ DUP SUBST-DECREASE @ > IF SUBST-DECREASE ! ELSE DROP THEN
    CELLS SUBST-SP @ + @
;

: esPICKS ( n -- a u ) DUP esPICK SWAP 1- esPICK ;
