\ Find Files
REQUIRE { ~nn/lib/locals.f
REQUIRE UZPLACE ~nn/lib/u/util/wz.f
REQUIRE ALLOCATE9x ~nn/lib/alloc95.f
REQUIRE WSEARCH ~nn/lib/u/util/wstr.f
REQUIRE PATH-TO-\\?\ ~nn/lib/u/util/filename.f

DECIMAL C" MAX_PATH" FIND NIP 0= [IF] 260 CONSTANT MAX_PATH [THEN]

0                             \ typedef struct _WIN32_FIND_DATA { // wfd
1 CELLS -- dwFileAttributes   \    DWORD    dwFileAttributes;
2 CELLS -- ftCreationTime     \    FILETIME ftCreationTime;
2 CELLS -- ftLastAccessTime   \    FILETIME ftLastAccessTime;
2 CELLS -- ftLastWriteTime    \    FILETIME ftLastWriteTime;
1 CELLS -- nFileSizeHigh      \    DWORD    nFileSizeHigh;
1 CELLS -- nFileSizeLow       \    DWORD    nFileSizeLow;
1 CELLS -- dwReserved0        \    DWORD    dwReserved0;
1 CELLS -- dwReserved1        \    DWORD    dwReserved1;
MAX_PATH 2*  -- cFileName          \    TCHAR    cFileName[ MAX_PATH ];
14 2*   -- cAlternateFileName \    TCHAR    cAlternateFileName[ 14 ];
CONSTANT /WIN32_FIND_DATA     \ } WIN32_FIND_DATA;

\ 18 CONSTANT ERROR_NO_MORE_FILES

WINAPI: FindFirstFileW   kernel32.dll
\ HANDLE FindFirstFile(LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData)
\ If the function succeeds, the return value is a search handle used in
\ a subsequent call to FindNextFile or FindClose.
\ If the function fails, the return value is INVALID_HANDLE_VALUE(-1).
\ To get extended error information, call GetLastError.

WINAPI: FindNextFileW    kernel32.dll
\ BOOL FindNextFile( HANDLE hFindFile, LPWIN32_FIND_DATA lpFindFileData)
\ If the function succeeds, the return value is nonzero.
\ If the function fails, the return value is zero.
\ To get extended error information, call GetLastError.
\ If no matching files can be found, the GetLastError function returns
\ ERROR_NO_MORE_FILES.

WINAPI: FindClose       kernel32.dll
\ BOOL FindClose(HANDLE hFindFile)    // file search handle

WINAPI: GetFullPathNameW KERNEL32.DLL
\ DWORD GetFullPathName(
\  LPCTSTR lpFileName,  // pointer to name of file to find path for
\  DWORD nBufferLength, // size, in characters, of path buffer
\  LPTSTR lpBuffer,     // pointer to path buffer
\  LPTSTR *lpFilePart);   // pointer to filename in path


\ CREATE __FFB /WIN32_FIND_DATA ALLOT
USER-VALUE __FFB
USER-VALUE __FFH
: FIND-RESULT ( ~? -- wa wu TRUE / FALSE)
    IF
        GetLastError
        DUP ERROR_NO_MORE_FILES <> OVER ERROR_FILE_NOT_FOUND <> AND
        OVER ERROR_PATH_NOT_FOUND <> AND
        IF THROW ELSE DROP THEN
        FALSE
    ELSE __FFB cFileName WASCIIZ> TRUE THEN ;

: FIND-FIRST-FILE ( wa wu -- wa wu TRUE / FALSE)
    DUP MAX_PATH > IF PATH-TO-\\?\ DROP ELSE W>ZALLOC THEN >R
    /WIN32_FIND_DATA ALLOCATE9x THROW TO __FFB
    __FFB R@ FindFirstFileW
    DUP TO __FFH INVALID_HANDLE_VALUE = FIND-RESULT
    R> FREE DROP
;

: FIND-NEXT-FILE ( -- wa wu TRUE / FALSE)
    __FFB __FFH  FindNextFileW
    DUP ERROR_NO_MORE_FILES = SWAP 0= OR
    FIND-RESULT ;

: FIND-CLOSE ( --)
    __FFH FindClose DROP
    __FFB FREE9x DROP
;

: GET-FULL-PATH { wa wu \ len buf filepart -- wa1 wu1}
    AT filepart 0 0 wa GetFullPathNameW DUP ERR THROW TO len
    len 1+ WALLOCATE TO buf
    AT filepart buf len wa GetFullPathNameW DUP ERR THROW
    buf SWAP
;

: FF-SIZE __FFB nFileSizeHigh 2@ ;
: FF-ATTRIB  __FFB dwFileAttributes @ ;
: FF-ATTRIB? FF-ATTRIB AND 0<> ;
: IS-DIR?       FILE_ATTRIBUTE_DIRECTORY    FF-ATTRIB? ;
: IS-ARCHIVE?   FILE_ATTRIBUTE_ARCHIVE      FF-ATTRIB? ;
: IS-HIDDEN?    FILE_ATTRIBUTE_HIDDEN       FF-ATTRIB? ;
: IS-READONLY?  FILE_ATTRIBUTE_READONLY     FF-ATTRIB? ;
: IS-SYSTEM?    FILE_ATTRIBUTE_SYSTEM       FF-ATTRIB? ;

: FF-CREATION-TIME  __FFB ftCreationTime 2@ SWAP ;
: FF-ACCESS-TIME    __FFB ftLastAccessTime 2@ SWAP ;
: FF-WRITE-TIME     __FFB ftLastWriteTime 2@ SWAP ;


REQUIRE FILE-ATTRIBUTES ~nn/lib/u/file/fileattr.f

: FILE-EXIST { wa wu \ sp res -- ? ior }
    wa wu W" *" WSEARCH NIP NIP 0= wa wu W" ?" WSEARCH NIP NIP 0= AND
    IF wa GetFileAttributesW -1 <> DUP ERR  EXIT THEN
    SP@ TO sp
    SP@ /WIN32_FIND_DATA - SP!
    SP@ wa wu FILE-ATTRIBUTES TO res
    sp SP! res DUP ERR
;

: EXIST? FILE-EXIST DROP ;

REQUIRE \EOF ~nn/lib/eof.f
\ EOF

: show UNICODE>S OVER >R TYPE CR R> FREE ;

: test
    W" E:\tmp\test\ff\*" 2DUP 1+ 2* DUMP CR FIND-FIRST-FILE
    BEGIN  WHILE
       show
       FIND-NEXT-FILE
    REPEAT
    GetLastError . CR
    FIND-CLOSE
    GetLastError . CR
;
test
BYE