\ Loading user profile
REQUIRE { ~nn/lib/locals.f
REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE WIN-VER ~nn/lib/winver.f
REQUIRE ENUM ~nn/lib/enum.f

\ 0x0000037F CONSTANT WINSTA_ALL_ACCESS
\ 0x000001FF CONSTANT DESKTOP_ALL_ACCESS 
WINAPI: GetUserObjectSecurity USER32.DLL
WINAPI: GetSecurityDescriptorDacl advapi32.dll
WINAPI: GetAclInformation advapi32.dll
WINAPI: InitializeAcl advapi32.dll
WINAPI: GetAce advapi32.dll
WINAPI: AddAce advapi32.dll
WINAPI: GetLengthSid advapi32.dll
WINAPI: AddAccessAllowedAce advapi32.dll
WINAPI: EqualSid advapi32.dll
WINAPI: DeleteAce advapi32.dll
\ WINAPI: AclSizeInformation advapi32.dll

0               \ typedef struct _ACE_HEADER { // acehdr 
1 -- ah_AceType    \    BYTE AceType; 
1 -- ah_AceFlags   \    BYTE AceFlags; 
2 -- ah_AceSize    \    WORD AceSize; 
DROP            \ } ACE_HEADER; 

0                   \ typedef struct _ACL_SIZE_INFORMATION {
4 -- asi_AceCount       \    DWORD   AceCount;
4 -- asi_AclBytesInUse  \    DWORD   AclBytesInUse;
4 -- asi_AclBytesFree   \    DWORD   AclBytesFree;
CONSTANT /ACL_SIZE_INFORMATION    \ } ACL_SIZE_INFORMATION;

0                    \ typedef struct _ACCESS_ALLOWED_ACE { // aaace
4 -- aaa_Header      \    ACE_HEADER Header;
4 -- aaa_Mask        \    ACCESS_MASK Mask;
4 -- aaa_SidStart    \    DWORD SidStart;
CONSTANT /ACCESS_ALLOWED_ACE    \ } ACCESS_ALLOWED_ACE;

USER-CREATE asi_info /ACL_SIZE_INFORMATION USER-ALLOT

1
ENUM TokenUser
ENUM TokenGroups
ENUM TokenPrivileges
ENUM TokenOwner
ENUM TokenPrimaryGroup
ENUM TokenDefaultDacl
ENUM TokenSource
ENUM TokenType
ENUM TokenImpersonationLevel
ENUM TokenStatistics
ENUM TokenRestrictedSids
ENUM TokenSessionId
DROP


: GET-USER-OBJ-SEC { h \ si cb psd -- psd }
    0 TO cb  DACL_SECURITY_INFORMATION TO si     
    AT cb cb AT si h GetUserObjectSecurity DROP     \   Get size
    GetLastError DUP ERROR_INSUFFICIENT_BUFFER <> IF THROW ELSE DROP THEN
    cb ALLOCATE THROW TO psd
    DACL_SECURITY_INFORMATION TO si
    AT cb cb psd AT si h GetUserObjectSecurity ERR THROW
    psd
;

: GET-USER-OBJ-DACL { h cbExtra \ si cb psd bPresent bDefaulted pdaclOld pdaclNew pace -- acl }
    h GET-USER-OBJ-SEC TO psd
    AT bDefaulted AT pdaclOld AT bPresent psd GetSecurityDescriptorDacl ERR THROW
    2 /ACL_SIZE_INFORMATION asi_info pdaclOld GetAclInformation ERR THROW

    asi_info asi_AclBytesInUse @ cbExtra + TO cb
    cb ALLOCATE THROW TO pdaclNew

    ACL_REVISION cb pdaclNew InitializeAcl ERR THROW 
    
    asi_info asi_AceCount @ 0 
    ?DO
        0 TO pace 
        AT pace I pdaclOld GetAce ERR THROW
        pace ah_AceSize W@ pace @ MAXDWORD ACL_REVISION pdaclNew AddAce ERR THROW
    LOOP
    psd FREE THROW
    pdaclNew
;

: CALC-ACE-SIZE-FROM-SID ( psid -- size )
    /ACCESS_ALLOWED_ACE 4 - SWAP GetLengthSid +
;

: ADD-ACCESS-ALLOWED-ACE-EX { pAcl dwAceRevision AceFlags AccessMask pSid \ pace -- ? }
    WIN-VER 5 <
    IF
        pSid AccessMask dwAceRevision AddAccessAllowedAce 0= IF FALSE EXIT THEN
        2 /ACL_SIZE_INFORMATION asi_info pAcl GetAclInformation
            0= IF FALSE EXIT THEN
        AT pace asi_info asi_AceCount 1- pAcl GetAce 0= IF FALSE EXIT THEN
        AceFlags pace ah_AceFlags C!
        TRUE 
    ELSE
       S" AddAccessAllowedAceEx" DROP
       S" ADVAPI32.DLL" DROP GetModuleHandleA GetProcAddress API-CALL
    THEN
;

: DELETE-MATCHING-ACES  { pdacl psid \ pAce -- }
    2 /ACL_SIZE_INFORMATION asi_info pdacl GetAclInformation ERR THROW
    asi_info asi_AceCount @
    BEGIN ?DUP WHILE
        0 TO pAce 
        AT pAce OVER pdacl GetAce ERR THROW
        pAce aaa_SidStart psid EqualSid 
            IF  DUP pdacl DeleteAce DROP THEN
        1-
    REPEAT
;
<EOF>
\ void GrantSessionSIDAccessToWinstationAndDesktop( HANDLE htok, bool bGrant )
\ {
: GRANT-SESSION-SID-ACCESS-TO-WINSTATION-AND-DESKTOP { htok bGrant \ tgs ptgs cbtgs end -- }
\    BYTE tgs[4096];
    4096 ALLOCATE THROW TO tgs
\    DWORD cbtgs = sizeof tgs;
    4096 TO cbtgs 
\    if ( !GetTokenInformation( htok, TokenGroups, tgs, cbtgs, &cbtgs ) )
\        Err( L"GetTokenInformation" );
    AT cbtgs cbtgs tgs TokenGroups htok GetTokenInformation ERR THROW
    tgs TO ptgs 
\    const SID_AND_ATTRIBUTES* it = ptgs->Groups;
    ptgs CELL+ TO it
\    const SID_AND_ATTRIBUTES* end = it + ptgs->GroupCount;
    it ptgs @ 2 CELLS * + TO end
\    while ( end != it )
\    {
    BEGIN end it <> 
\        if ( it->Attributes & SE_GROUP_LOGON_ID )
\            break;
        DUP
        IF DROP it CELL+ @ SE_GROUP_LOGON_ID AND 0= THEN
    WHILE
\        ++it;
        it 2 CELLS + TO it
\    }
    REPEAT
\    if ( end == it )
\        Err( L"UNEXPECTED: No Logon SID in TokenGroups" );
    it end = ABORT" UNEXPECTED: No Logon SID in TokenGroups"

    void* psidLogonSession = it->Sid;

    HWINSTA hws = GetProcessWindowStation();
    if ( !hws )
        Err( L"GetProcessWindowStation" );

    {
        ACL* pdacl = 0;
        if ( bGrant )
        {
            // get the existing DACL, with enough extra space for adding a couple more aces
            const DWORD cbExtra = 2 * CalcAceSizeFromSid( psidLogonSession );
            pdacl = GetUserObjectDacl( hws, cbExtra );

            // grant the logon session all access to winsta0
            if ( !AddAccessAllowedAce( pdacl, ACL_REVISION,
                                        WINSTA_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
                                        psidLogonSession ) )
                Err( L"AddAccessAllowedAce" );

            // grant the logon session all access to any new desktops created in winsta0
            // by adding an inherit-only ace
            if ( !AddAccessAllowedAceEx( pdacl, ACL_REVISION,
                                        SUB_CONTAINERS_AND_OBJECTS_INHERIT | INHERIT_ONLY,
                                        DESKTOP_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
                                        psidLogonSession ) )
                Err( L"AddAccessAllowedAceEx" );
        }
        else
        {
            pdacl = GetUserObjectDacl( hws, 0 );
            DeleteMatchingAces( pdacl, psidLogonSession );
        }

        // apply the changes to winsta0
        // unlike GetSecurityInfo, SetSecurityInfo has no troubles on SP3 :-)
        DWORD err = SetSecurityInfo( hws, SE_WINDOW_OBJECT, DACL_SECURITY_INFORMATION, 0, 0, pdacl, 0 );
        if ( err )
            Err( L"SetSecurityInfo", err );

        HeapFree( g_hProcessHeap, 0, pdacl );
    }

    CloseWindowStation( hws );

    HDESK hd = GetThreadDesktop( GetCurrentThreadId() );
    if ( !hd )
        Err( L"GetThreadDesktop" );

    {
        ACL* pdacl = 0;
        if ( bGrant )
        {
            // get the existing DACL, with enough extra space for adding a couple more aces
            const DWORD cbExtra = CalcAceSizeFromSid( psidLogonSession );
            pdacl = GetUserObjectDacl( hd, cbExtra );

            // grant the logon session all access to the default desktop
            if ( !AddAccessAllowedAce( pdacl, ACL_REVISION,
                                        DESKTOP_ALL_ACCESS | STANDARD_RIGHTS_REQUIRED,
                                        psidLogonSession ) )
                Err( L"AddAccessAllowedAce" );

        }
        else
        {
            pdacl = GetUserObjectDacl( hd, 0 );
            DeleteMatchingAces( pdacl, psidLogonSession );
        }

        // apply the changes to the default desktop
        // unlike GetSecurityInfo, SetSecurityInfo has no troubles on SP3 :-)
        DWORD err = SetSecurityInfo( hd, SE_WINDOW_OBJECT, DACL_SECURITY_INFORMATION, 0, 0, pdacl, 0 );
        if ( err )
            Err( L"SetSecurityInfo", err );

        HeapFree( g_hProcessHeap, 0, pdacl );
    }

    CloseDesktop( hd );
}
