\ gint.dll interface
REQUIRE #define ~nn/lib/define.f

#define OVFLOW        2
#define SIGN          3

#define AUTO_MUL      0
#define GRAMMAR_MUL   1
#define FFT_MUL       2
#define KARAT_MUL     3

\ * typedef struct {
\ *   int sign;
\ *   unsigned short n[1];  /* number of shorts = abs(sign) */
\ * } giantstruct;

\ * typedef giantstruct *giant;

\ * typedef struct _matrix {
\ *     giant ul;   /* upper left  */
\ *     giant ur;   /* upper right */
\ *     giant ll;   /* lower left  */
\ *     giant lr;   /* lower right */
\ * } *gmatrix;

\ * typedef struct {
\ *     double re;
\ *     double im;
\ * } complex;

\ * #define MSGMAX 257

\ * typedef struct {
\ *     int  yes;
\ *     int  parnr;
\ *     char * plasterror;
\ *     char * pversion;
\ *     char version   [MSGMAX];
\ *     char lasterror [MSGMAX];
\ * } einfo;

\ * #define SZMAX 32000

\ * typedef struct {
\ *     int sz;
\ *     char TheData [SZMAX];
\ * } results;


WINAPI: popg gint.dll \ EXT giant popg (void);
WINAPI: pushg gint.dll \ EXT void pushg (int);

\  Creates a new giant, numshorts = INFINITY invokes the maximum MAX_SHORTS.
WINAPI: newgiant gint.dll \ EXT giant newgiant (int numshorts);

\  Creates a new giant matrix, but does not malloc the component giants.
WINAPI: newgmatrix gint.dll \ EXT gmatrix newgmatrix (void);

\  Returns the bit-length n; e.g. n=7 returns 3.
WINAPI: bitlen gint.dll \ EXT int bitlen (giant n);

\  Returns the value of the pos bit of n.
WINAPI: bitval gint.dll \ EXT int bitval (giant n, int pos);

\  Returns whether g is one.
WINAPI: isone gint.dll \ EXT int isone (giant g);

\  Returns whether g is zero.
WINAPI: isZero gint.dll \ EXT int isZero (giant g);

\  Copies one giant to another.
WINAPI: gtog gint.dll \ EXT void gtog (giant src, giant dest);

\  Integer <-> giant.
WINAPI: itog gint.dll \ EXT void itog (int n, giant g);
WINAPI: int gint.dll \ EXT signed int gtoi (giant);

\  Returns the sign of g: -1, 0, 1.
WINAPI: gsign gint.dll \ EXT int gsign (giant g);

\  Returns 1, 0, -1 as a>b, a=b, a<b.
WINAPI: gcompg gint.dll \ EXT int gcompg (giant a, giant b);

\  Set AUTO_MUL for automatic FFT crossover (this is the
\  default), set FFT_MUL for forced FFT multiply, set
\  GRAMMAR_MUL for forced grammar school multiply.
WINAPI: setmulmode gint.dll \ EXT void setmulmode (int mode);

\ *  /***************************************************************
\ *  *                                  *
\ *  * Math Functions                       *
\ *  *                              *
\ *  ***************************************************************/

\  g := -g.
WINAPI: negg gint.dll \ EXT void negg (giant g);

\  g := |g|.
WINAPI: absg gint.dll \ EXT void absg (giant g);

\  g += i, with i non-negative and < 2^16.
WINAPI: iaddg gint.dll \ EXT void iaddg (int i,giant g);

\  g -= i, with i non-negative and < 2^16.
WINAPI: isubg gint.dll \ EXT void isubg (int i,giant g);

\  b += a.
WINAPI: addg gint.dll \ EXT void addg (giant a, giant b);

\  b -= a.
WINAPI: subg gint.dll \ EXT void subg (giant a, giant b);

\  Returns the number of trailing zero bits in g.
WINAPI: numtrailzeros gint.dll \ EXT int numtrailzeros (giant g);

\  u becomes greatest power of two not exceeding u/v.
WINAPI: bdivg gint.dll \ EXT void bdivg (giant v, giant u);

\  Same as invg, but uses bdivg.
WINAPI: binvg gint.dll \ EXT int binvg (giant n, giant x);

\  If 1/x exists (mod n), 1 is returned and x := 1/x.  If
\  inverse does not exist, 0 is returned and x := GCD(n, x).
WINAPI: invg gint.dll \ EXT int invg (giant n, giant x);
WINAPI: mersenneinvg gint.dll \ EXT int mersenneinvg (int q, giant x);

\  Classical GCD, x:= GCD(n, x).
WINAPI: cgcdg gint.dll \ EXT void cgcdg (giant n, giant x);

\  General GCD, x:= GCD(n, x).
WINAPI: gcdg gint.dll \ EXT void gcdg (giant n, giant x);

\  Binary GCD, x:= GCD(n, x).
WINAPI: bgcdg gint.dll \ EXT void bgcdg (giant n, giant x);

\  g := m^n, no mod is performed.
WINAPI: powerg gint.dll \ EXT void powerg (int a, int b, giant g);

\  r becomes the steady-state reciprocal 2^(2b)/d, where b = bit-length of d-1.
WINAPI: make_recip gint.dll \ EXT void make_recip (giant d, giant r);

\  n := [n/d], d positive, using stored reciprocal directly.
WINAPI: divg_via_recip gint.dll \ EXT void divg_via_recip (giant d, giant r, giant n);

\  n := n % d, d positive, using stored reciprocal directly.
WINAPI: modg_via_recip gint.dll \ EXT void modg_via_recip (giant d, giant r, giant n);

\  num := num % den, any positive den.
WINAPI: modg gint.dll \ EXT void modg (giant den, giant num);

\  g := g/n, and (g mod n) is returned.
WINAPI: idivg gint.dll \ EXT int idivg (int n, giant g);

\  num := [num/den], any positive den.
WINAPI: divg gint.dll \ EXT void divg (giant den, giant num);

\  x := x^n (mod z).
WINAPI: powermod gint.dll \ EXT void powermod (giant x, int n, giant z);

\  x := x^n (mod z).
WINAPI: powermodg gint.dll \ EXT void powermodg (giant x, giant n, giant z);

\  x := x^n (mod 2^q+1).
WINAPI: fermatpowermod gint.dll \ EXT void fermatpowermod (giant x, int n, int q);

\  x := x^n (mod 2^q+1).
WINAPI: fermatpowermodg gint.dll \ EXT void fermatpowermodg (giant x, giant n, int q);

\  x := x^n (mod 2^q-1).
WINAPI: mersennepowermod gint.dll \ EXT void mersennepowermod (giant x, int n, int q);

\  x := x^n (mod 2^q-1).
WINAPI: mersennepowermodg gint.dll \ EXT void mersennepowermodg (giant x, giant n, int q);

\  Switched by modmode
WINAPI: s_modg gint.dll \ EXT void s_modg (giant N, giant t);

\  Shift g left by bits, introducing zeros on the right.
WINAPI: gshiftleft gint.dll \ EXT void gshiftleft (int bits, giant g);

\  Shift g right by bits, losing bits on the right.
WINAPI: gshiftright gint.dll \ EXT void gshiftright (int bits, giant g);

\  dest becomes lowermost n bits of src. Equivalent to dest = src % 2^n.
WINAPI: extractbits gint.dll \ EXT void extractbits (int n, giant src, giant dest);

\  negate g. g is mod 2^n+1.
WINAPI: fermatnegate gint.dll \ EXT void fermatnegate (int n, giant g);

\  g := g (mod 2^n-1).
WINAPI: mersennemod gint.dll \ EXT void mersennemod (int n, giant g);

\  g := g (mod 2^n+1).
WINAPI: fermatmod gint.dll \ EXT void fermatmod (int n, giant g);

\  g := g (mod 2^n+1).
WINAPI: fer_mod gint.dll \ EXT void fer_mod (int n, giant g, giant modulus);

\  g *= s.
WINAPI: smulg gint.dll \ EXT void smulg (unsigned short s, giant g);

\  g *= g.
WINAPI: squareg gint.dll \ EXT void squareg (giant g);

\  b *= a.
WINAPI: mulg gint.dll \ EXT void mulg (giant a, giant b);

\  A giant gcd.  Modifies its arguments.
WINAPI: ggcd gint.dll \ EXT void ggcd (giant xx, giant yy);

\  elliptic functions
WINAPI: ell_even gint.dll \ EXT int ell_even  (giant x1,giant z1,giant x2,giant z2,giant An,giant Ad,giant N);
WINAPI: ell_odd gint.dll \ EXT int ell_odd   (giant x1,giant z1,giant x2,giant z2,giant xor,giant zor,giant N);
WINAPI: ell_mul gint.dll \ EXT int ell_mul   (giant xx,giant zz,int n,giant An,giant Ad,giant N);

WINAPI: choose12 gint.dll \ EXT void choose12 (giant x,giant z,int k,giant An,giant Ad,giant N);

\  misc
WINAPI:  GetGINTinfo gint.dll \ EXT int  GetGINTinfo     (void);
WINAPI:  ResetGINTerror gint.dll \ EXT int  ResetGINTerror  (void);
WINAPI:  giantinit gint.dll \ EXT int  giantinit   (int bits);

WINAPI:  bigprimeq gint.dll \ EXT int  bigprimeq   (giant x);
WINAPI:  special_mulg gint.dll \ EXT int  special_mulg    (giant y, giant x);
WINAPI:  special_squareg gint.dll \ EXT int  special_squareg (giant y);

WINAPI:  ResetString gint.dll \ EXT int  ResetString     (void);
WINAPI:  gtos gint.dll \ EXT int  gtos        (giant thegiant);
WINAPI:  tostring gint.dll \ EXT int  tostring    (const char *fmt, ...);
WINAPI:  gianttos gint.dll \ EXT int  gianttos    (giant g);
WINAPI:  stringtog gint.dll \ EXT int  stringtog   (char *inbuf, int numdigits, giant theg);

REQUIRE \EOF ~nn/lib/eof.f

CREATE g1 1024 ALLOT
CREATE g2 1024 ALLOT
CREATE g3 1024 ALLOT
: test { \ g -- }
    g1 S" 123456789" SWAP stringtog 2DROP 2DROP
    g2 S" 2" SWAP stringtog 2DROP 2DROP
    g1 20 DUMP CR
    g1 g2 mulg DROP 2DROP
    g1 20 DUMP CR
;

test
