REQUIRE CLASS: ~nn/class/class.f
REQUIRE SEMAPHORE ~nn/lib/win/sys/semaphore.f
REQUIRE ?FREE ~nn/lib/free.f
REQUIRE AllAllowedSA ~nn/lib/win/sec/sd.f

CLASS: QUEUE
    var vEnd
    var vBeg
    var vHead     ( get from head)
    var vTail     ( put to tail)
    var vSize
    var vEmpty ( semaphore)
    var vFull  ( semaphore)
    var vBusy  ( semaphore)

CONSTR: init { size -- }
    size vSize !
    size CELLS DUP ALLOCATE THROW DUP vBeg !
    + vEnd !
    vBeg @ DUP vHead ! vTail !
    size size AllAllowedSA exSEMAPHORE THROW vEmpty !
    0 size    AllAllowedSA exSEMAPHORE THROW vFull !
;

DESTR: free
    vEmpty @ CLOSE-FILE DROP
    vFull  @ CLOSE-FILE DROP
    vBusy  @ CLOSE-FILE DROP
    vBeg   @ ?FREE
;

: ++ DUP @ CELL+ DUP vEnd @ = IF DROP vBeg @ THEN SWAP ! ;

M: Put ( n -- )
    vEmpty SGET
    vBusy GET
    vTail @ !
    vTail ++
    vFull SRELEASE
    vBusy RELEASE
;

M: Get ( -- n)
    vFull SGET
    vBusy GET
    vHead @ @
    vHead ++
    vEmpty SRELEASE
    vBusy RELEASE
;

M: CanPut? ( -- ?)  vEmpty SEM-FREE? ;
M: CanGet? ( -- ?)  vFull  SEM-FREE? ;

;CLASS

REQUIRE \EOF ~nn/lib/eof.f

\EOF

REQUIRE RANDOM ~nn/lib/ran4.f
REQUIRE .R lib/ext/core-ext.f

QUEUE POINTER q1

:NONAME
    BEGIN
        200 RANDOM DUP q1 Put
        ." ." .
        100 RANDOM PAUSE
    AGAIN
; TASK: task-put

:NONAME
    BEGIN
        q1 CanGet? IF ." it can" CR THEN
        q1 Get ." *" .
        1000 PAUSE
    AGAIN
; TASK: task-get


: test
    50 QUEUE NEW TO q1
    0 task-get START DROP
    1000 0 DO  0 task-put START DROP LOOP
;

test
