REQUIRE TIMER-RESET ~nn/lib/timer.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE StartAppWait ~nn/lib/process.f
REQUIRE FT>MS ~nn/lib/time.f

: SET-CL
  GetCommandLineA ASCIIZ> \ 2DUP TYPE CR
  TIB SWAP C/L MIN DUP #TIB ! MOVE >IN 0!
  get-string 2DROP
;

: HELP ." Usage: timer.exe command" CR BYE ;

: command-line ( -- a u) \ ஢  ப
  SET-CL
  BL SKIP 1 PARSE ?DUP 0= IF HELP THEN
;

WINAPI: GetProcessTimes KERNEL32.DLL
2VARIABLE pCreationTime
2VARIABLE pExitTime
2VARIABLE pKernelTime
2VARIABLE pUserTime

: GetProcTime ( h -- ? )
    WinNT?
    IF
         >R
         pUserTime pKernelTime pExitTime pCreationTime
         R> GetProcessTimes 
    ELSE DROP FALSE THEN
;

: (epilog1) ( ? -- )
\ [ DEBUG? ] [IF] 1000 PAUSE ." New thread ("  APP-pi .dwThreadId @ DUP . ." ) desk: " desk-name TYPE CR [THEN]
  APP-WAIT? @
  IF
    IF APP-Wait @ ?DUP 0= IF -1 THEN APP-Wait 0!
       APP-pi .hProcess @ WaitForSingleObject 
       WAIT_TIMEOUT =
       IF
           -1 APP-pi .hProcess @ TerminateProcess DROP
           -1
       ELSE
            0 SP@ APP-pi .hProcess @ GetExitCodeProcess DROP
       THEN
       TO ExitCodeProc
    THEN
  ELSE
    DROP
  THEN
\  APP-pi .hProcess @ ?DUP IF CLOSE-FILE DROP THEN
\  APP-pi .hThread  @ ?DUP IF CLOSE-FILE DROP THEN
\  APP-err @ SetLastError
;

: StartAppWaitNC ( 'startup-info S" application.exe" -- flag )
    APP-SU? 0!
    TRUE APP-WAIT? !
    (StartApp0)
    DUP (epilog1)    
;


: .MS FT>MS D. ."  ms" ;

: main
\    TIMER-RESET
    0 command-line StartAppWaitNC 
    IF
        APP-pi .hProcess @ GetProcTime
        IF
            ." Total time  : " pExitTime 2@ SWAP pCreationTime 2@ SWAP FT- .MS CR
            ." User time   : " pUserTime 2@ SWAP .MS CR
            ." Kernel time : " pKernelTime 2@ SWAP .MS CR
        ELSE
            .ELAPSED CR
        THEN
        APP-pi .hProcess @ ?DUP IF CLOSE-FILE DROP THEN
        APP-pi .hThread  @ ?DUP IF CLOSE-FILE DROP THEN
    THEN
;

: 1BYE 1 HALT ;
' main TO <MAIN>
0 MAINX !

BASE @ HEX
: JMP  >R  0E9 R@ C! R@ 1+ CELL+ - R> 1+ ! ;
BASE !
' 1BYE ' QUIT JMP
' NOOP ' OPTIONS JMP
FALSE TO SPF-INIT?
S" timer.exe" SAVE
BYE

