\  Spell Distance
REQUIRE /STRING lib/ext/string.f
REQUIRE THIRD ~nn\lib\wilbaden\toolbelt.f

0 [IF] ========================================================
                                          Neil Bawd  2000-07-21

Kernighan and Pike, _The Unix Programming Environment_, (1984)
pp 208--214, give a name-correcting file lookup.  It uses a
function like the following `SPELL-DISTANCE`.  The K&P
definition uses C-style strings, so `SPELL-DISTANCE` had to
be written from scratch.

This is helpful with "word unknown" error.
It catches the most common typing goofs.

<A HREF="spdist.txt"> <BIG>TEXT</BIG></A><BR>

Needed from Tool Belt

NEEDS
    THIRD   3DUP   3DROP
/NEEDS

<BR><BR><A HREF="pattern.txt"> Test Requires Pattern Expansion</A>
-------------------------------------------------------- [THEN]
0 [IF] ========================================================

SPELL-DISTANCE  ( str1 len1 str2 len2 -- {0...3} )
    Returns distance between two names.

Very rough spelling metric.

 *  0 if the strings are identical.
 *  1 if two characters are transposed.
 *  2 if one character different, added, or deleted.
 *  3 otherwise.

-------------------------------------------------------- [THEN]

    : Letter-Match ( str1 len str2 -- str' len' str2' )
        >R
        BEGIN  DUP WHILE
            OVER C@ R@ C@ =
        WHILE
            1 /STRING  R> 1+ >R
        REPEAT THEN
        R> ;

    : Letter-Switch   ( str1 len str2 -- flag )
        THIRD C@  OVER 1+ C@  = NOT
            IF  3DROP  FALSE  EXIT THEN
        THIRD 1+ C@  OVER C@  = NOT
            IF  3DROP  FALSE  EXIT THEN
        >R 2 /STRING R>  2 +  OVER COMPARE 0=
        ;

: Spell-Distance  ( str1 len1 str2 len2 -- {0...3} )
    ROT SWAP          ( str1 str2 len1 len2)
    \  Save difference in lengths for later.
    2DUP - >R                         ( R: diff)
    \  Is difference in lengths > 1?
    R@ ABS 1 > IF
        R@ DROP 2DROP 2DROP  ( )
        3
    EXIT THEN
    MIN SWAP          ( str1 len str2)
    Letter-Match
    \  Are words equal or a letter inserted/deleted?
    OVER 0= IF
        3DROP
        R> DUP IF  DROP 2  THEN
    EXIT THEN
    \  Do the words have the same length?
    R> DUP 0= IF DROP
        \  Is the rest of the two words the same?
        3DUP  >R 1 /STRING R>  1+ OVER COMPARE 0= IF
            3DROP  2
        EXIT THEN
        \  Is a letter switched with the next letter?
        Letter-Switch IF  1  ELSE  3  THEN
    EXIT THEN
    \  Is a letter deleted?
    0< IF
        1+  OVER COMPARE 0= IF  2  ELSE  3  THEN
    EXIT THEN
    \  Is a letter inserted?
    2>R 1+ 2R>  OVER COMPARE 0= IF  2  ELSE  3  THEN
    ;

REQUIRE <EOF> ~nn/lib/eof.f
\ <EOF>
REQUIRE PLACE lib/ext/string.f

CREATE wd1 128 ALLOT

: test
    NextWord wd1 PLACE
    CONTEXT @ @
    BEGIN ?DUP WHILE
\        DUP ." <" ID. ." >=" ." <" wd1 ID. ." > " 
        DUP COUNT DUP wd1 COUNT ROT OVER - ABS 2 < 
        IF Spell-Distance 3 <
            IF DUP ID. SPACE THEN
        ELSE 2DROP 2DROP THEN
        CDR
    REPEAT
;

test DUMP