REQUIRE { ~nn/lib/locals.f
REQUIRE MODULE: ~nn/lib/spf4/spf_modules.f

MODULE: MIXER

WINAPI: mixerOpen winmm.dll
WINAPI: mixerClose winmm.dll
WINAPI: mixerGetLineInfoA winmm.dll
WINAPI: mixerGetLineControlsA winmm.dll
WINAPI: mixerGetControlDetailsA winmm.dll
WINAPI: mixerSetControlDetails winmm.dll

0xFFFF CONSTANT MAX-VOL

\ * typedef struct {
\ *     DWORD cbStruct;
\ *     DWORD dwControlID;
\ *     DWORD cChannels;
\ *     union {
\ *         HWND  hwndOwner;
\ *         DWORD cMultipleItems;
\ *     };
\ *     DWORD  cbDetails;
\ *     LPVOID paDetails;
\ * } MIXERCONTROLDETAILS
6 CELLS CONSTANT /MIXERCONTROLDETAILS

\ * 16 CONSTANT MIXER_SHORT_NAME_CHARS
\ * 64 CONSTANT MIXER_LONG_NAME_CHARS
\ * 32 CONSTANT MAXPNAMELEN
\ * typedef struct {
\ *     DWORD cbStruct;
\ *     DWORD dwDestination;
\ *     DWORD dwSource;
\ *     DWORD dwLineID;
\ *     DWORD fdwLine;
\ *     DWORD dwUser;
\ *     DWORD dwComponentType;
\ *     DWORD cChannels;
\ *     DWORD cConnections;
\ *     DWORD cControls;
\ *     CHAR  szShortName[MIXER_SHORT_NAME_CHARS];
\ *     CHAR  szName[MIXER_LONG_NAME_CHARS];
\ *     struct {
\ *         DWORD     dwType;
\ *         DWORD     dwDeviceID;
\ *         WORD      wMid;
\ *         WORD      wPid;
\ *         MMVERSION vDriverVersion;
\ *         CHAR      szPname[MAXPNAMELEN];
\ *     } Target;
\ * } MIXERLINE;
168 CONSTANT /MIXERLINE

\ * typedef struct {
\ *     DWORD cbStruct;
\ *     DWORD dwControlID;
\ *     DWORD dwControlType;
\ *     DWORD fdwControl;
\ *     DWORD cMultipleItems;
\ *     CHAR  szShortName[MIXER_SHORT_NAME_CHARS];
\ *     CHAR  szName[MIXER_LONG_NAME_CHARS];
\ *     union {
\ *         struct {
\ *             LONG lMinimum;
\ *             LONG lMaximum;
\ *         };
\ *         struct {
\ *             DWORD dwMinimum;
\ *             DWORD dwMaximum;
\ *         };
\ *         DWORD dwReserved[6];
\ *     } Bounds;
\ *     union {
\ *         DWORD cSteps;
\ *         DWORD cbCustomData;
\ *         DWORD dwReserved[6];
\ *     } Metrics;
\ * } MIXERCONTROL, *PMIXERCONTROL, FAR *LPMIXERCONTROL;
148 CONSTANT /MIXERCONTROL

\ * typedef struct {
\ *     DWORD cbStruct;
\ *     DWORD dwLineID;
\ *     union {
\ *         DWORD dwControlID;
\ *         DWORD dwControlType;
\ *     };
\ *     DWORD          cControls;
\ *     DWORD          cbmxctrl;
\ *     LPMIXERCONTROL pamxctrl;
\ * } MIXERLINECONTROLS;
\ *
24 CONSTANT /MIXERLINECONTROLS

: MIXER-OPEN { \ hMixer -- h ior }
     MIXER_OBJECTF_MIXER 0 0 0 AT hMixer mixerOpen
     hMixer SWAP ;

: MIXER-CLOSE ( h -- ior )    mixerClose ;

: MIXER-DEV-ID { m_hMixer dev \ mxl dwLineID mxc mxlc dwControlID -- id }
    /MIXERLINE ALLOCATE THROW TO mxl /MIXERLINE mxl !
    MIXERLINE_COMPONENTTYPE_DST_SPEAKERS mxl 6 CELLS + !
    MIXER_OBJECTF_HMIXER MIXER_GETLINEINFOF_COMPONENTTYPE OR
    mxl m_hMixer mixerGetLineInfoA
    mxl 3 CELLS + @ TO dwLineID
    mxl FREE THROW
    THROW

\ *     // get dwControlID
\ *     MIXERCONTROL mxc;
\ *     MIXERLINECONTROLS mxlc;
    /MIXERCONTROL ALLOCATE THROW TO mxc  /MIXERCONTROL mxc !
    /MIXERLINECONTROLS ALLOCATE THROW TO mxlc  /MIXERLINECONTROLS mxlc !
\ *     mxlc.dwLineID = mxl.dwLineID;
    dwLineID mxlc CELL+ !
\ *     mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUTE;
    dev mxlc 2 CELLS + !
\ *     mxlc.cControls = 1;
    1 mxlc 3 CELLS + !
\ *     mxlc.cbmxctrl = sizeof(MIXERCONTROL);
    /MIXERCONTROL mxlc 4 CELLS + !
\ *     mxlc.pamxctrl = &mxc;
     mxc mxlc 5 CELLS + !
\ *     if (::mixerGetLineControls(reinterpret_cast<HMIXEROBJ>(m_hMixer),
\ *                                &mxlc,
\ *                                MIXER_OBJECTF_HMIXER |
\ *                                MIXER_GETLINECONTROLSF_ONEBYTYPE)
\ *         != MMSYSERR_NOERROR)
\ *     {
\ *         return FALSE;
\ *     }
    MIXER_OBJECTF_HMIXER MIXER_GETLINECONTROLSF_ONEBYTYPE OR
    mxlc m_hMixer mixerGetLineControlsA
\ *     // store dwControlID
\ *     m_strDstLineName = mxl.szName;
\ *     m_strMuteControlName = mxc.szName;
\ *     m_dwMuteControlID = mxc.dwControlID;
    mxc CELL+ @ TO dwControlID
    mxlc FREE THROW
    mxc FREE THROW
    THROW
    dwControlID
;

: MIXER-MUTE-ID MIXERCONTROL_CONTROLTYPE_MUTE MIXER-DEV-ID ;
: MIXER-VOL-ID  MIXERCONTROL_CONTROLTYPE_VOLUME MIXER-DEV-ID ;

: (mixer-get-mxcd) { m_hMixer id \ mxcd -- mxcd }
\ *     MIXERCONTROLDETAILS_BOOLEAN mxcdMute;
\ *     MIXERCONTROLDETAILS mxcd;
\ *     mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS);
    /MIXERCONTROLDETAILS CELL+ ALLOCATE THROW TO mxcd  /MIXERCONTROLDETAILS mxcd !
\ *     mxcd.dwControlID = m_dwMuteControlID;
    id mxcd CELL+ !
\ *     mxcd.cChannels = 1;
    1 mxcd 2 CELLS + !
\ *     mxcd.cMultipleItems = 0;
    0 mxcd 3 CELLS + !
\ *     mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_BOOLEAN);
    1 CELLS mxcd 4 CELLS + !
\ *     mxcd.paDetails = &mxcdMute;
    mxcd /MIXERCONTROLDETAILS + mxcd 5 CELLS + !
    mxcd
;

: MIXER-PUT { value id-xt \ m_hMixer mxcd -- }
    MIXER-OPEN THROW TO m_hMixer
    m_hMixer DUP id-xt EXECUTE (mixer-get-mxcd) TO mxcd
    value mxcd /MIXERCONTROLDETAILS + !
    MIXER_OBJECTF_HMIXER MIXER_SETCONTROLDETAILSF_VALUE OR
    mxcd m_hMixer mixerSetControlDetails
    m_hMixer MIXER-CLOSE THROW
    mxcd FREE THROW
    THROW
;

: MIXER-GET { id-xt \ mxcd m_hMixer -- value }
    MIXER-OPEN THROW TO m_hMixer
    m_hMixer DUP id-xt EXECUTE (mixer-get-mxcd) TO mxcd
    MIXER_OBJECTF_HMIXER MIXER_GETCONTROLDETAILSF_VALUE OR
    mxcd m_hMixer mixerGetControlDetailsA
    mxcd /MIXERCONTROLDETAILS + @
    m_hMixer MIXER-CLOSE THROW
    mxcd FREE THROW
    SWAP THROW
;


: MIXER-MUTE! ( flag -- )  IF 1 ELSE 0 THEN ['] MIXER-MUTE-ID MIXER-PUT ;
: MIXER-VOL! ( vol -- ) ['] MIXER-VOL-ID MIXER-PUT ;

\ -----------------------------------------------------------------------------

EXPORT

: MIXER-STATE ( -- ?) ['] MIXER-MUTE-ID MIXER-GET 0= ;
: MIXER-VOLUME ( -- vol) ['] MIXER-VOL-ID MIXER-GET ;
: MIXER-VOLUME@ ( -- %) MIXER-VOLUME 100 MAX-VOL */ ;
: MIXER+ ( % -- ) MAX-VOL 100 */ MIXER-VOLUME + MAX-VOL MIN 0 MAX MIXER-VOL! ;
: MIXER-VOLUME! ( % -- ) MAX-VOL 100 */ MAX-VOL MIN 0 MAX MIXER-VOL! ;
: MIXER-UP MIXER+ ;
: MIXER-DOWN NEGATE MIXER+ ;
: MIXER-ON 0 MIXER-MUTE! ;
: MIXER-OFF 1 MIXER-MUTE! ;
: MIXER-UNMUTE MIXER-ON ;
: MIXER-MUTE MIXER-OFF ;

;MODULE

REQUIRE \EOF ~nn/lib/eof.f
\EOF
: test { \ h -- }
    MIXER-STATE 0= IF MIXER-ON 5000 PAUSE THEN
    MIXER-OFF
    5000 PAUSE
    MIXER-ON
    .S
    MIXER-VOLUME .
    .S
    10 0 DO 1 MIXER-UP MIXER-VOLUME . 1000 PAUSE LOOP
    10 0 DO 1 MIXER-DOWN MIXER-VOLUME . 1000 PAUSE LOOP
    .S
;
test
BYE