REQUIRE { ~nn/lib/locals.f

WINAPI: OpenEventLogA advapi32.dll

\ * HANDLE OpenEventLog(
\ *   LPCTSTR lpUNCServerName,  // server name
\ *   LPCTSTR lpSourceName      // file name
\ * );

WINAPI: NotifyChangeEventLog advapi32.dll
\ * BOOL NotifyChangeEventLog(
\ *   HANDLE hEventLog,  // handle to event log
\ *   HANDLE hEvent      // handle to event object
\ * );

WINAPI: GetOldestEventLogRecord advapi32.dll
\ * BOOL GetOldestEventLogRecord(
\ *   HANDLE hEventLog,     // handle to event log
\ *   PDWORD OldestRecord   // buffer for number of records
\ * );

WINAPI: GetNumberOfEventLogRecords advapi32.dll
\ * BOOL GetNumberOfEventLogRecords(
\ *   HANDLE hEventLog,        // handle to event log
\ *   PDWORD NumberOfRecords   // buffer for number of records
\ * );

WINAPI: ReadEventLogA advapi32.dll
\ * BOOL ReadEventLog(
\ *   HANDLE hEventLog,                // handle to event log
\ *   DWORD dwReadFlags,               // how to read log
\ *   DWORD dwRecordOffset,            // initial record offset
\ *   LPVOID lpBuffer,                 // buffer for read data
\ *   DWORD nNumberOfBytesToRead,      // bytes to read
\ *   DWORD *pnBytesRead,              // number of bytes read
\ *   DWORD *pnMinNumberOfBytesNeeded  // bytes required
\ * );

WINAPI: CloseEventLog advapi32.dll

0
\ * typedef struct _EVENTLOGRECORD {
1 CELLS -- evLength         \ DWORD  Length;
1 CELLS -- evReserved       \ DWORD  Reserved;
1 CELLS -- evRecordNumber   \ DWORD  RecordNumber;
1 CELLS -- evTimeGenerated  \ DWORD  TimeGenerated;
1 CELLS -- evTimeWritten    \ DWORD  TimeWritten;
1 CELLS -- evEventID        \ DWORD  EventID;
2       -- evEventType      \ WORD   EventType;
2       -- evNumStrings     \ WORD   NumStrings;
2       -- evEventCategory  \ WORD   EventCategory;
2       -- evReservedFlags  \ WORD   ReservedFlags;
1 CELLS -- evClosingRecordNumber \ DWORD  ClosingRecordNumber;
1 CELLS -- evStringOffset   \ DWORD  StringOffset;
1 CELLS -- evUserSidLength  \ DWORD  UserSidLength;
1 CELLS -- evUserSidOffset  \ DWORD  UserSidOffset;
1 CELLS -- evDataLength     \ DWORD  DataLength;
1 CELLS -- evDataOffset     \ DWORD  DataOffset;
\ * //
\ * // Followed by:
\ * //
\ * // TCHAR SourceName[]
0 CELLS -- <evSourceName>
\ * // TCHAR Computername[]
\ * // SID   UserSid
\ * // TCHAR Strings[]
\ * // BYTE  Data[]
\ * // CHAR  Pad[]
\ * // DWORD Length;
\ * //
\ * } EVENTLOGRECORD, *PEVENTLOGRECORD;
CONSTANT /EVENTLOGRECORD

: evSourceName ( a -- a1 ) <evSourceName> ;
: evComputername ( a -- a1 ) evSourceName ASCIIZ> + 1+ ;
: evStrings ( a -- a1) DUP evStringOffset @ + ;
: evStrings2String ( a -- a1 u1)
    DUP evStrings DUP ROT evNumStrings W@ 1-
    0 ?DO
        ASCIIZ> + BL OVER C!
        1+
    LOOP
    DROP
    ASCIIZ>
;
: evNString ( a # -- a )
    OVER evNumStrings W@ 1- MIN >R
    evStrings R> 0 ?DO ASCIIZ> + 1+ LOOP
;

: evUserSid ( a -- a1 u1) DUP evUserSidOffset @ OVER + SWAP evUserSidLength @ ;

: EVLOG-OPEN ( a u -- h ior) DROP 0 OpenEventLogA DUP ERR ;
: EVLOG-CLOSE ( h -- ior) CloseEventLog ERR ;
            
: EVLOG-READ { n h \ buf nBytesRead nMinNumberOfBytesNeeded -- a ior}
    SP@ TO buf
    AT nMinNumberOfBytesNeeded AT nBytesRead 0 buf n
    EVENTLOG_FORWARDS_READ EVENTLOG_SEEK_READ OR
    h ReadEventLogA ERR DUP ERROR_INSUFFICIENT_BUFFER <> IF 0 SWAP EXIT THEN DROP
    nMinNumberOfBytesNeeded ALLOCATE ?DUP IF NIP 0 SWAP EXIT THEN TO buf
    AT nMinNumberOfBytesNeeded AT nBytesRead nMinNumberOfBytesNeeded buf n
    EVENTLOG_FORWARDS_READ EVENTLOG_SEEK_READ OR
    h ReadEventLogA ERR
    nBytesRead buf !
    buf SWAP
;

: EVLOG-OLDEST ( h -- n ior)  >R 0 SP@ R> GetOldestEventLogRecord ERR ;
: EVLOG-NEWEST ( h -- n ior)
    >R R@ EVLOG-OLDEST DROP
    0 SP@ R> GetNumberOfEventLogRecords ERR >R + 1- R> ;

REQUIRE \EOF ~nn/lib/eof.f
\EOF
: test { \ h -- }
    S" System" EVLOG-OPEN THROW TO h
    h EVLOG-NEWEST THROW h EVLOG-READ THROW DUP @ DUMP
\    h EVLOG-NEWEST THROW 1+ h EVLOG-READ THROW DUP @ DUMP
    h EVLOG-CLOSE THROW
;
test BYE