\ ntqueryinfo
REQUIRE 2VARIABLE lib/ext/double.f
REQUIRE .R lib/ext/core-ext.f
REQUIRE PROC-EXIST? ~nn/lib/proc.f

WINAPI: NtQueryInformationProcess NTDLL.DLL
\ NTSYSAPI NtQueryInformationProcess(
\      IN HANDLE ProcessHandle,
\      IN PROCESSINFOCLASS ProcessInformationClass,
\      OUT PVOID ProcessInformation,
\      IN ULONG ProcessInformationLength,
\      OUT PULONG ReturnLength OPTIONAL
\      );

WINAPI: NtQuerySystemInformation NTDLL.DLL
\ NtQuerySystemInformation(
\    IN UINT SystemInformationClass,    // information type
\    OUT PVOID SystemInformation,       // pointer to buffer
\    IN ULONG SystemInformationLength,  // buffer size in bytes
\    OUT PULONG ReturnLength OPTIONAL   // pointer to a 32-bit
\                                       // variable that receives
\                                       // the number of bytes
\                                       // written to the buffer
\ );

\ REQUIRE ENUM ~nn/lib/enum.f
\  0 
\  ENUM picProcessBasicInformation
\  ENUM picProcessQuotaLimits
\  ENUM picProcessIoCounters
\  ENUM picProcessVmCounters
4 CONSTANT picProcessTimes
\  ENUM picProcessBasePriority
\  ENUM picProcessRaisePriority
\  ENUM picProcessDebugPort
\  ENUM picProcessExceptionPort
\  ENUM picProcessAccessToken
\  ENUM picProcessLdtInformation
\  ENUM picProcessLdtSize
\  ENUM picProcessDefaultHardErrorMode
\  ENUM picProcessIoPortHandlers     \     // Note: this is kernel mode only
\  ENUM picProcessPooledUsageAndLimits
\  ENUM picProcessWorkingSetWatch
\  ENUM picProcessUserModeIOPL
\  ENUM picProcessEnableAlignmentFaultFixup
\  ENUM picProcessPriorityClass
\  ENUM picProcessWx86Information
\  ENUM picProcessHandleCount
\  ENUM picProcessAffinityMask,
\  ENUM picProcessPriorityBoost,
\  ENUM picMaxProcessInfoClass

0                                        \  typedef struct _KERNEL_USER_TIMES {
2 CELLS -- kutCreateTime                 \      LARGE_INTEGER CreateTime;
2 CELLS -- kutExitTime                   \      LARGE_INTEGER ExitTime;
2 CELLS -- kutKernelTime                 \      LARGE_INTEGER KernelTime;
2 CELLS -- kutUserTime                   \      LARGE_INTEGER UserTime;
CONSTANT /KERNEL_USER_TIMES              \  } KERNEL_USER_TIMES;

\ REQUIRE #define ~nn/lib/define.f
\ #define SystemBasicInformation       0
2 CONSTANT SystemPerformanceInformation
\ #define SystemTimeInformation        3

0                                        \  typedef struct {
2 CELLS -- spiIdleTime                   \      LARGE_INTEGER   liIdleTime;
76 CELLS -- spiSpare                     \      DWORD           dwSpare[76];
CONSTANT /SYSTEM_PERFORMANCE_INFORMATION \  } SYSTEM_PERFORMANCE_INFORMATION;


0                                       \  typedef struct {
2 CELLS -- stiKeBootTime                \      LARGE_INTEGER liKeBootTime;
2 CELLS -- stiKeSystemTime              \      LARGE_INTEGER liKeSystemTime;
2 CELLS -- stiExpTimeZoneBias           \      LARGE_INTEGER liExpTimeZoneBias;
1 CELLS -- stiCurrentTimeZoneId         \      ULONG         uCurrentTimeZoneId;
1 CELLS -- stiReserved                  \      DWORD         dwReserved;
CONSTANT /SYSTEM_TIME_INFORMATION       \  } SYSTEM_TIME_INFORMATION


: SYS-IDLE-TIME ( -- d )
    WinNT? 0= IF 0. EXIT THEN
    /SYSTEM_PERFORMANCE_INFORMATION ALLOCATE THROW >R
    0 /SYSTEM_PERFORMANCE_INFORMATION R@ SystemPerformanceInformation NtQuerySystemInformation 0=
    IF
        R@ spiIdleTime 2@ SWAP
\        R@ spiSpare 76 CELLS DUMP
    ELSE 0. THEN
    R> FREE THROW
;

: PROC-CPU-TIMES ( a u -- d-kern d-user  )
    { \ ph kut -- }
    WinNT? 0= IF 0. 0. EXIT THEN
    PROC-EXIST? ?DUP
    IF
        0 PROCESS_QUERY_INFORMATION OpenProcess TO ph
        ph 
        IF
            /KERNEL_USER_TIMES ALLOCATE THROW TO kut
            0 /KERNEL_USER_TIMES kut picProcessTimes ph NtQueryInformationProcess 0=
            IF
                kut kutKernelTime 2@ SWAP
                kut kutUserTime 2@ SWAP
            ELSE
                0. 0.
            THEN
            kut FREE DROP
            ph CLOSE-FILE DROP
        ELSE 0. 0. THEN
    ELSE 0. 0. THEN
;

: PROC-USER-TIME ( a u -- d) PROC-CPU-TIMES 2SWAP 2DROP ;
: PROC-KERNEL-TIME ( a u -- d) PROC-CPU-TIMES 2DROP ;

: PROC-CPU-TIME ( a u -- d) PROC-CPU-TIMES D+ ;

1000 VALUE CpuMeasurementTime

: (PROC-CPU-USAGE) { a u ms -- n}
\ ms -  
    a u PROC-CPU-TIME
    ms PAUSE
    a u PROC-CPU-TIME
    2SWAP D-
    ms 100 * MD/ D>S
;

: (CPU-USAGE) { ms -- n}
    SYS-IDLE-TIME
    ms PAUSE
    SYS-IDLE-TIME
    2SWAP D-
    ms 100 * MD/ D>S 100 SWAP -
;

: PROC-CPU-USAGE CpuMeasurementTime (PROC-CPU-USAGE) ;
: CPU-USAGE CpuMeasurementTime (CPU-USAGE) ;

REQUIRE \EOF ~nn/lib/eof.f
\EOF
: test
    BEGIN KEY? 0= WHILE
        ." CPU Usage: " CPU-USAGE 2 .R ." %  nncrond.exe: " 
        S" nncrond.exe" PROC-CPU-USAGE 2 .R ." %    " 13 EMIT
    REPEAT
    KEY DROP 
;
test
