REQUIRE /SYSTEMTIME LIB/EXT/FACIL.F

0
1 CELLS -- pcdByteLength
1 CELLS -- pcdCounterNameTitleIndex
1 CELLS -- pcdCounterNameTitle
1 CELLS -- pcdCounterHelpTitleIndex
1 CELLS -- pcdCounterHelpTitle
1 CELLS -- pcdDefaultScale
1 CELLS -- pcdDetailLevel
1 CELLS -- pcdCounterType
1 CELLS -- pcdCounterSize
1 CELLS -- pcdCounterOffset
CONSTANT /PERF_COUNTER_DEFINITION
\  typedef struct _PERF_COUNTER_DEFINITION {
\      DWORD           ByteLength;         // Length in bytes of this structure
\      DWORD           CounterNameTitleIndex;
\                                          // Index of Counter name into
\                                          // Title Database
\  #ifdef _WIN64
\      DWORD           CounterNameTitle;
\  #else
\      LPWSTR          CounterNameTitle;   // Initially NULL, for use by
\                                          // analysis program to point to
\                                          // retrieved title string
\  #endif
\      DWORD           CounterHelpTitleIndex;
\                                          // Index of Counter Help into
\                                          // Title Database
\  #ifdef _WIN64
\      DWORD           CounterHelpTitle;
\  #else
\      LPWSTR          CounterHelpTitle;   // Initially NULL, for use by
\                                          // analysis program to point to
\                                          // retrieved title string
\  #endif
\      LONG            DefaultScale;       // Power of 10 by which to scale
\                                          // chart line if vertical axis is 100
\                                          // 0 ==> 1, 1 ==> 10, -1 ==>1/10, etc.
\      DWORD           DetailLevel;        // Counter level of detail (for
\                                          // controlling display complexity)
\      DWORD           CounterType;        // Type of counter
\      DWORD           CounterSize;        // Size of counter in bytes
\      DWORD           CounterOffset;      // Offset from the start of the
\                                          // PERF_COUNTER_BLOCK to the first
\                                          // byte of this counter
\  } PERF_COUNTER_DEFINITION, *PPERF_COUNTER_DEFINITION;

0 
1 CELLS -- pidByteLength
1 CELLS -- pidParentObjectTitleIndex
1 CELLS -- pidParentObjectInstance
1 CELLS -- pidUniqueID
1 CELLS -- pidNameOffset
1 CELLS -- pidNameLength
CONSTANT /PERF_INSTANCE_DEFINITION \  } PERF_INSTANCE_DEFINITION, *PPERF_INSTANCE_DEFINITION;

\  typedef struct _PERF_INSTANCE_DEFINITION {
\      DWORD           ByteLength;         // Length in bytes of this structure,
\                                          // including the subsequent name
\      DWORD           ParentObjectTitleIndex;
\                                          // Title Index to name of "parent"
\                                          // object (e.g., if thread, then
\                                          // process is parent object type);
\                                          // if logical drive, the physical
\                                          // drive is parent object type
\      DWORD           ParentObjectInstance;
\                                          // Index to instance of parent object
\                                          // type which is the parent of this
\                                          // instance.
\      LONG            UniqueID;           // A unique ID used instead of
\                                          // matching the name to identify
\                                          // this instance, -1 = none
\      DWORD           NameOffset;         // Offset from beginning of
\                                          // this struct to the Unicode name
\                                          // of this instance
\      DWORD           NameLength;         // Length in bytes of name; 0 = none
\                                          // this length includes the characters
\                                          // in the string plus the size of the
\                                          // terminating NULL char. It does not
\                                          // include any additional pad bytes to
\                                          // correct structure alignment
\  } PERF_INSTANCE_DEFINITION, *PPERF_INSTANCE_DEFINITION;

0 
1 CELLS -- pcbByteLength
CONSTANT /PERF_COUNTER_BLOCK

\  typedef struct _PERF_COUNTER_BLOCK {
\      DWORD           ByteLength;         // Length in bytes of this structure,
\                                          // including the following counters
\  } PERF_COUNTER_BLOCK, *PPERF_COUNTER_BLOCK;

0
8       -- pdbSignature \  WCHAR           Signature[4]
1 CELLS -- pdbLittleEndian
1 CELLS -- pdbVersion
1 CELLS -- pdbRevision
1 CELLS -- pdbTotalByteLength
1 CELLS -- pdbHeaderLength
1 CELLS -- pdbNumObjectTypes
1 CELLS -- pdbDefaultObject
/SYSTEMTIME -- pdbSystemTime       \ SYSTEMTIME      SystemTime
2 CELLS -- pdbPerfTime          \ LARGE_INTEGER   PerfTime
2 CELLS -- pdbPerfFreq          \ LARGE_INTEGER   PerfFreq
2 CELLS -- pdbPerfTime100nSec   \ LARGE_INTEGER   PerfTime100nSec
1 CELLS -- pdbSystemNameLength
1 CELLS -- pdbSystemNameOffset
CONSTANT /PPERF_DATA_BLOCK


\  typedef struct _PERF_DATA_BLOCK {
\      WCHAR           Signature[4];       // Signature: Unicode "PERF"
\      DWORD           LittleEndian;       // 0 = Big Endian, 1 = Little Endian
\      DWORD           Version;            // Version of these data structures
\                                          // starting at 1
\      DWORD           Revision;           // Revision of these data structures
\                                          // starting at 0 for each Version
\      DWORD           TotalByteLength;    // Total length of data block
\      DWORD           HeaderLength;       // Length of this structure
\      DWORD           NumObjectTypes;     // Number of types of objects
\                                          // being reported
\      LONG            DefaultObject;      // Object Title Index of default
\                                          // object to display when data from
\                                          // this system is retrieved (-1 =
\                                          // none, but this is not expected to
\                                          // be used)
\      SYSTEMTIME      SystemTime;         // Time at the system under
\                                          // measurement
\      LARGE_INTEGER   PerfTime;           // Performance counter value
\                                          // at the system under measurement
\      LARGE_INTEGER   PerfFreq;           // Performance counter frequency
\                                          // at the system under measurement
\      LARGE_INTEGER   PerfTime100nSec;    // Performance counter time in 100 nsec
\                                          // units at the system under measurement
\      DWORD           SystemNameLength;   // Length of the system name
\      DWORD           SystemNameOffset;   // Offset, from beginning of this
\                                          // structure, to name of system
\                                          // being measured
\  } PERF_DATA_BLOCK, *PPERF_DATA_BLOCK;


0
1 CELLS -- potTotalByteLength
1 CELLS -- potDefinitionLength
1 CELLS -- potHeaderLength
1 CELLS -- potObjectNameTitleIndex
1 CELLS -- potObjectNameTitle
1 CELLS -- potObjectHelpTitleIndex
1 CELLS -- potObjectHelpTitle
1 CELLS -- potDetailLevel
1 CELLS -- potNumCounters
1 CELLS -- potDefaultCounter
1 CELLS -- potNumInstances
1 CELLS -- potCodePage
1 CELLS -- potPerfTime  \  LARGE_INTEGER   PerfTime
1 CELLS -- potPerfFreq  \  LARGE_INTEGER   PerfFreq
CONSTANT /PERF_OBJECT_TYPE

\  typedef struct _PERF_OBJECT_TYPE {
\      DWORD           TotalByteLength;    // Length of this object definition
\                                          // including this structure, the
\                                          // counter definitions, and the
\                                          // instance definitions and the
\                                          // counter blocks for each instance:
\                                          // This is the offset from this
\                                          // structure to the next object, if
\                                          // any
\      DWORD           DefinitionLength;   // Length of object definition,
\                                          // which includes this structure
\                                          // and the counter definition
\                                          // structures for this object: this
\                                          // is the offset of the first
\                                          // instance or of the counters
\                                          // for this object if there is
\                                          // no instance
\      DWORD           HeaderLength;       // Length of this structure: this
\                                          // is the offset to the first
\                                          // counter definition for this
\                                          // object
\      DWORD           ObjectNameTitleIndex;
\                                          // Index to name in Title Database
\  #ifdef _WIN64
\      DWORD           ObjectNameTitle;    // Should use this as an offset
\  #else
\      LPWSTR          ObjectNameTitle;    // Initially NULL, for use by
\                                          // analysis program to point to
\                                          // retrieved title string
\  #endif
\      DWORD           ObjectHelpTitleIndex;
\                                          // Index to Help in Title Database
\  #ifdef _WIN64
\      DWORD           ObjectHelpTitle;    // Should use this as an offset
\  #else
\      LPWSTR          ObjectHelpTitle;    // Initially NULL, for use by
\                                          // analysis program to point to
\                                          // retrieved title string
\  #endif
\      DWORD           DetailLevel;        // Object level of detail (for
\                                          // controlling display complexity);
\                                          // will be min of detail levels
\                                          // for all this object's counters
\      DWORD           NumCounters;        // Number of counters in each
\                                          // counter block (one counter
\                                          // block per instance)
\      LONG            DefaultCounter;     // Default counter to display when
\                                          // this object is selected, index
\                                          // starting at 0 (-1 = none, but
\                                          // this is not expected to be used)
\      LONG            NumInstances;       // Number of object instances
\                                          // for which counters are being
\                                          // returned from the system under
\                                          // measurement. If the object defined
\                                          // will never have any instance data
\                                          // structures (PERF_INSTANCE_DEFINITION)
\                                          // then this value should be -1, if the
\                                          // object can have 0 or more instances,
\                                          // but has none present, then this
\                                          // should be 0, otherwise this field
\                                          // contains the number of instances of
\                                          // this counter.
\      DWORD           CodePage;           // 0 if instance strings are in
\                                          // UNICODE, else the Code Page of
\                                          // the instance names
\      LARGE_INTEGER   PerfTime;           // Sample Time in "Object" units
\                                          //
\      LARGE_INTEGER   PerfFreq;           // Frequency of "Object" units in
\                                          // counts per second.
\  } PERF_OBJECT_TYPE, *PPERF_OBJECT_TYPE;

