\ SEMAPHORES

REQUIRE GET ~nn/lib/mutex.f

\ HANDLE CreateSemaphore(
\   LPSECURITY_ATTRIBUTES lpSemaphoreAttributes, // SD
\   LONG lInitialCount,                          // initial count
\   LONG lMaximumCount,                          // maximum count
\   LPCTSTR lpName                               // object name
\ );
WINAPI: CreateSemaphoreA    KERNEL32.DLL
WINAPI: ReleaseSemaphore    KERNEL32.DLL

: exSEMAPHORE ( init max sa -- h ior )
    >R 0 SWAP ROT R> CreateSemaphoreA DUP ERR ;

: SEMAPHORE ( init max -- h ior ) 0 exSEMAPHORE ;


: SGET GET ;
: SnRELEASE ( n a -- n1)
    @ >R >R 0 SP@ R> R> ReleaseSemaphore DROP  ;
: SRELEASE 1 SWAP SnRELEASE DROP ;
\ : SEM-VALUE 0 SWAP SnRELEASE ;
: SEM-FREE? { a -- ?} 0 a @ WAIT IF DROP FALSE THEN 
    DUP IF a SRELEASE THEN
;


REQUIRE \EOF ~nn/lib/eof.f
\EOF

REQUIRE RANDOM ~nn/lib/ran4.f

VARIABLE sin
VARIABLE sout
VARIABLE sbuf
:NONAME
    BEGIN
        sin SGET
        sbuf GET
\        ." p"
        sout SRELEASE
        ." ."
        sbuf RELEASE
        190 RANDOM PAUSE
    AGAIN
; TASK: task-put

:NONAME
    BEGIN
        sout SGET
        sbuf GET
\        ." g"
        sin SRELEASE
        ." *"
        sbuf RELEASE
        200 RANDOM PAUSE
    AGAIN
; TASK: task-get


: test
    50 50 SEMAPHORE .S THROW sin !
    0 50  SEMAPHORE .S THROW sout !
    0 task-get START DROP
    0 task-put START DROP
;
test
