
\ 28 CONSTANT /MSG  \    
0
4 -- MSG.hwnd
4 -- MSG.uint
4 -- MSG.wparam
4 -- MSG.lparam
4 -- MSG.time
8 -- MSG.pt
CONSTANT /MSG

\  SP-Forth
  WS_OVERLAPPEDWINDOW WS_VSCROLL OR WS_HSCROLL OR
  ES_AUTOVSCROLL OR ES_AUTOHSCROLL OR
  ES_MULTILINE OR ES_WANTRETURN OR
CONSTANT SPF_STDEDIT

  WS_VSCROLL  WS_HSCROLL OR
  ES_AUTOVSCROLL OR ES_AUTOHSCROLL OR
  ES_MULTILINE OR ES_WANTRETURN OR
CONSTANT SPF_RICHEDIT

WINAPI: CreateWindowExA      USER32.DLL
WINAPI: DestroyWindow        USER32.DLL
WINAPI: SetWindowPos         USER32.DLL
WINAPI: SetWindowTextA       USER32.DLL
WINAPI: BringWindowToTop     USER32.DLL
WINAPI: SetActiveWindow      USER32.DLL
WINAPI: SetForegroundWindow  USER32.DLL
WINAPI: GetForegroundWindow  USER32.DLL
WINAPI: ShowWindow           USER32.DLL
WINAPI: CloseWindow          USER32.DLL
WINAPI: SetWindowLongA       USER32.DLL
WINAPI: GetWindowLongA       USER32.DLL
WINAPI: GetMessageA          USER32.DLL
WINAPI: PeekMessageA         USER32.DLL
WINAPI: WaitMessage          USER32.DLL
WINAPI: TranslateMessage     USER32.DLL
WINAPI: DispatchMessageA     USER32.DLL
WINAPI: IsWindow             USER32.DLL
WINAPI: PostMessageA         USER32.DLL
WINAPI: SendMessageA         USER32.DLL
WINAPI: CallWindowProcA      USER32.DLL
WINAPI: GetCursorPos         USER32.DLL
WINAPI: EnableWindow         USER32.DLL
WINAPI: DefWindowProcA       USER32.DLL

WINAPI: InitCommonControlsEx COMCTL32.DLL

VARIABLE DEBUG

\ ----------------------------------------------
\   ,     

VARIABLE CC_INIT \   CommonControls
CREATE   CC_INITS 8 , BASE @ HEX 3FFF , BASE !

: InitControls
  CC_INIT @ IF EXIT THEN
  CC_INITS InitCommonControlsEx DROP
  S" RICHED32.DLL" DROP LoadLibraryA DROP
  S" RICHED20.DLL" DROP LoadLibraryA DROP
  TRUE CC_INIT !
;

\ ----------------------------------------------
\   

: Window ( class-a class-u style parent-hwnd -- hwnd )  \ 0 - 
         \         parent
         \  parent=0,    
  ROT DROP ROT >R SWAP >R >R
  InitControls
  0 0 0 R@ CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  R> R> SWAP IF WS_CHILD OR THEN
  0 R> 0 CreateWindowExA 
  ?DUP 0= IF GetLastError ERROR THEN
;
\ : S" RichEdit" WS_OVERLAPPEDWINDOW 0 Window


: WindowDelete ( hwnd -- )
               \  
  DestroyWindow DROP
;


: WindowPos ( x y hwnd -- )
            \   
  >R SWAP >R >R
  SWP_NOZORDER SWP_NOSIZE OR 0 0 R> R> 0 R> SetWindowPos DROP
;


: WindowSize ( dx dy hwnd -- )
             \   
  >R SWAP >R >R
  SWP_NOZORDER SWP_NOMOVE OR R> R> 0 0 0 R> SetWindowPos DROP
;


: WindowToTop ( hwnd -- )
              \     
              \         
  BringWindowToTop DROP
;


: WindowActivate ( hwnd -- )
                 \  
  SetActiveWindow DROP
;


: WindowToForeground ( hwnd -- )
                     \      :)
                     \     
                     \   Windows 2000  SetActiveWindow+FlashWindowEx
  SetForegroundWindow DROP
;

: WindowShow ( hwnd -- )
             \  
  SW_SHOW SWAP ShowWindow DROP
;


: WindowHide ( hwnd -- )
             \   ( ,   )
  SW_HIDE SWAP ShowWindow DROP
;

: WindowEnable ( hwnd -- )
             \  
  1 SWAP EnableWindow DROP
;


: WindowDisable ( hwnd -- )
             \   (    )
  0 SWAP EnableWindow DROP
;

: WindowMinimize ( hwnd -- )
                 \  
  CloseWindow DROP
;


: WindowRestore ( hwnd -- )
                \   
  SW_RESTORE SWAP ShowWindow DROP
;


: WindowStyle ( ws hwnd -- )
              \   
              \         :(
  GWL_STYLE SWAP SetWindowLongA DROP
;


: WindowExStyle ( ws hwnd -- )
                \    
  GWL_EXSTYLE SWAP SetWindowLongA DROP
;

: MessageLoop ( wnd -- )
              \  ,    
  /MSG ALLOCATE THROW >R
  BEGIN
    DUP IsWindow
    IF
       0 OVER 0 SWAP R@ GetMessageA 0 >
      R@ CELL+ @ WM_CLOSE <> AND
    ELSE FALSE THEN
  WHILE
    DEBUG @ IF R@ 16 DUMP CR THEN
    R@ TranslateMessage DROP
    R@ DispatchMessageA DROP
  REPEAT
  DROP
  R> FREE THROW
;



: WindowSubclass ( xt wnd -- )
  >R
  GWL_WNDPROC R@ SetWindowLongA
  GWL_USERDATA R> SetWindowLongA DROP
\  1 1 R> WindowPos
;
: WindowOrigProc ( ... wnd -- )
  GWL_USERDATA SWAP GetWindowLongA CallWindowProcA
;

(  
: TEST
  || h ||

  S" RichEdit20A" SPF_STDEDIT 0 Window => h
  500000 0 EM_EXLIMITTEXT h PostMessageA DROP

  400 200 h WindowPos    ??
  150 250 h WindowSize   ??
  h WindowShow           ??
  h WindowMinimize       ??
  h WindowRestore        ??
  h MessageLoop          ??
  h WindowDelete
;
)
