\ REQUIRE WIN-TEXT e:/home/src/cron/add.f
REQUIRE QWNDPORC ~nn/lib/qwndproc.f

REQUIRE [NONAME ~nn/lib/noname.f
REQUIRE AppendNode ~nn/lib/list.f
REQUIRE WC-COMPARE ~nn/lib/wcmatch.f
REQUIRE PLACE lib/ext/string.f
REQUIRE GLOBAL ~nn/lib/globalloc.f
REQUIRE ON ~nn/lib/onoff.f
REQUIRE RE-MATCH ~nn/lib/re.f
REQUIRE WC|RE-COMPARE ~nn/lib/wcre.f

USER-VALUE WIN-HWND
USER-VALUE WIN-CHILD-HWND
USER FW-ONE?
: FW-ONE FW-ONE? ON ;

C" GetWindowTextA" FIND NIP 0= [IF] WINAPI: GetWindowTextA USER32.DLL [THEN]
C" GetClassNameA" FIND NIP 0= [IF] WINAPI: GetClassNameA USER32.DLL [THEN]
C" EXACT-MATCH?" FIND NIP 0= [IF] USER-VALUE EXACT-MATCH? [THEN]

: WIN-TEXT ( hwnd -- a u )
    DUP GetWindowTextLengthA ?DUP
    IF   ['] GetWindowTextA SWAP 1+ 
    ELSE ['] GetClassNameA 128 THEN
    DUP ALLOCATE THROW >R
    R@ 2SWAP EXECUTE
    R> SWAP ;

USER <FOUND-WINDOW>
: (FOUND-WINDOW) ( hwnd -- )
    <FOUND-WINDOW> @ ?DUP IF FREE DROP THEN
    ?DUP
    IF WIN-TEXT OVER <FOUND-WINDOW> !
    ELSE S" " THEN
;

: FOUND-WINDOW WIN-HWND (FOUND-WINDOW) ;
: FOUND-CHILD-WINDOW WIN-CHILD-HWND (FOUND-WINDOW) ;

0
1 CELLS  -- fwList
MAX_PATH -- fwMask
1 CELLS  -- fwH
MAX_PATH -- fwTitle
1 CELLS  -- fwXT
1 CELLS  -- fwGetText
1 CELLS  -- fwOne
CONSTANT /FW-BUF

:NONAME { buf hwnd -- ? }
    TRUE
    MAX_PATH buf fwTitle hwnd  buf fwGetText @ EXECUTE
\    ?DUP
\    IF  
        buf fwTitle SWAP \ 2DUP TYPE CR KEY DROP
        buf fwMask COUNT WC|RE-COMPARE ?DUP 0=
        IF buf fwH @ hwnd = THEN
        IF
\            buf fwTitle ASCIIZ> TYPE CR
            hwnd buf fwList GLOBAL AppendNode LOCAL 
            buf fwOne @ IF DROP FALSE THEN
        THEN
\    THEN
; QWNDPROC: FW-ENUM-PROC

USER-VALUE FW-BUF

: FW-BODY
    NodeValue TO WIN-HWND
    FW-BUF fwXT @ CATCH ?DUP IF ." FW-BODY error # " . CR THEN
;

: FW-CHILD-BODY
    NodeValue TO WIN-CHILD-HWND
    FW-BUF fwXT @ CATCH ?DUP IF ." FW-CHILD-BODY error # " . CR THEN
;

: (ENUM-WINDOWS) { xt buf -- }
    xt buf fwGetText !
    buf ['] FW-ENUM-PROC EnumWindows DROP ;

: (ENUM-CHILD-WINDOWS) { xt buf -- }
    xt buf fwGetText !
    buf ['] FW-ENUM-PROC WIN-HWND EnumChildWindows DROP ;    

: (FOR-WINDOWS) { a u xt enumXT bodyXT \ buf -- }
    /FW-BUF ALLOCATE THROW TO buf
    xt buf fwXT !
    a u buf fwMask PLACE
    a u S>NUM buf fwH !
    buf fwList 0!
    FW-ONE? @ buf fwOne !  FW-ONE? OFF
    ['] GetWindowTextA buf enumXT EXECUTE
    buf fwList @ 0=
    IF \ enum window's classes
        ['] GetClassNameA buf enumXT EXECUTE
    THEN
    FW-BUF buf TO FW-BUF
    bodyXT buf fwList DoList
    TO FW-BUF
    buf fwList GLOBAL FreeList LOCAL 
    buf FREE DROP
;

: (FOR-PWINDOWS)
    ['] (ENUM-WINDOWS)
    ['] FW-BODY
    (FOR-WINDOWS) ;

: (FOR-CWINDOWS)
    ['] (ENUM-CHILD-WINDOWS)
    ['] FW-CHILD-BODY
    (FOR-WINDOWS) ;


: FOR-WINDOWS
    POSTPONE [NONAME
; IMMEDIATE

: ;FOR-WINDOWS
    POSTPONE NONAME]
    POSTPONE (FOR-PWINDOWS)
; IMMEDIATE


: FOR-CHILD-WINDOWS
    POSTPONE [NONAME
; IMMEDIATE

: ;FOR-CHILD-WINDOWS
    POSTPONE NONAME]
    POSTPONE (FOR-CWINDOWS)
; IMMEDIATE

REQUIRE \EOF ~nn/lib/eof.f

\EOF

REQUIRE EVAL-SUBST ~nn/lib/subst1.f

: test
  AT-PROCESS-STARTING
  AT-THREAD-STARTING
    S" *home*" FOR-WINDOWS
        FOUND-WINDOW TYPE CR
\          S" *" FOR-CHILD-WINDOWS
\              S"   %WIN-CHILD-HWND% %FOUND-CHILD-WINDOW%  (%FOUND-WINDOW%)" EVAL-SUBST TYPE CR
\          ;FOR-CHILD-WINDOWS
    ;FOR-WINDOWS
;

test
BYE