REQUIRE FOR-WINDOWS ~nn/lib/win/windows/for-win.f

USER win-flag
: WIN-EXIST? ( a u -- ? )
    FW-ONE win-flag OFF
    FOR-WINDOWS win-flag ON ;FOR-WINDOWS
    win-flag @ ;

: WIN-CHILD-EXIST? ( S" substring" hwnd -- ?)
    TO WIN-HWND
    FW-ONE win-flag OFF 
    FOR-CHILD-WINDOWS win-flag ON ;FOR-CHILD-WINDOWS
    win-flag @ ;



USER WIN-OP
USER ALL?
: ALL ALL? ON ;

: WIN-PASS ( a u xt -- )
    WIN-OP !
    ALL? @ 0= IF FW-ONE THEN
    FOR-WINDOWS
        WIN-OP @ EXECUTE
    ;FOR-WINDOWS
    ALL? OFF
;

: WIN-CLOSE ( S" win-pattern" )
    [NONAME
        0 0 WM_CLOSE WIN-HWND  PostMessageA DROP
    NONAME] WIN-PASS ;

USER <win-set-title>
: WIN-SET-TITLE ( S" win-pattern" S" title" -- )
    DROP <win-set-title> !
    [NONAME
        <win-set-title> @ WIN-HWND SetWindowTextA DROP
    NONAME] WIN-PASS
    ;

: WIN-DESTROY ( S" winname" --)
    [NONAME
        WIN-HWND DestroyWindow DROP
    NONAME] WIN-PASS ;

: WIN-TERMINATE ( S" win-pattern" -- )
    [ DEBUG? ] [IF] 2DUP TYPE CR [THEN]
    [NONAME
        [ DEBUG? ] [IF] ." terminate window" CR [THEN]
         0 SP@ WIN-HWND GetWindowThreadProcessId  DROP ( threadID)
         ?DUP
         IF ( pid)
            FALSE PROCESS_ALL_ACCESS OpenProcess ( hProc) 
            ?DUP
            IF 0 OVER TerminateProcess 
               [ DEBUG? ] [IF] ." TerminateProcess:" DUP ERR . CR [THEN]
                DROP
               CloseHandle DROP
            ELSE
               [ DEBUG? ] [IF] ." Can't OpenProcess" CR [THEN]
            THEN
         ELSE
           [ DEBUG? ] [IF] ." Can't GetWindowThreadProcessId" CR [THEN]
         THEN
    NONAME] WIN-PASS ;

USER SW_OP

: SHOW-WIN ( S" win-pattern" SW_ -- )
    SW_OP !
    [NONAME
        SW_OP @ WIN-HWND ShowWindow DROP
    NONAME] WIN-PASS ;

: WIN-MINIMIZE SW_MINIMIZE SHOW-WIN ;
: WIN-MAXIMIZE SW_MAXIMIZE SHOW-WIN ;
: WIN-RESTORE SW_RESTORE SHOW-WIN ;
: WIN-HIDE  SW_HIDE SHOW-WIN ;
: WIN-SHOW  WIN-RESTORE ;


: PUSH-WINDOW ( hwnd -- prev-hwnd)
    DUP SetActiveWindow >R
    DUP SetFocus DROP
    DUP SetForegroundWindow DROP
        BringWindowToTop DROP
    R>
;
: POP-WINDOW ( hwnd -- ) PUSH-WINDOW DROP ;

USER win-p1
USER win-p2
USER win-p3
USER win-p4
USER win-p5

: WIN-CLICK ( S" win-pattern" S" button-pattern" --)
    win-p2 ! win-p1 !
    [NONAME
        win-p1 @ win-p2 @ WIN-HWND WIN-CHILD-EXIST?
        IF
            0 0 0 0 SP@ WIN-CHILD-HWND GetWindowRect DROP \ GetWindowRect(hw,&rect);
            0 0 SP@ GetCursorPos DROP 2>R      \ GetCursorPos(&pnt);
            WIN-HWND PUSH-WINDOW >R
            ( bottom right top left --)
            \ ROT + 2/ >R + 2/ R> SetCursorPos DROP
            2SWAP 2DROP 2 + SWAP 2 + SWAP SetCursorPos DROP
            0 0 BM_CLICK WIN-CHILD-HWND PostMessageA DROP
            R> POP-WINDOW
            2R> SetCursorPos DROP   \ SetCursorPos(pnt.x,pnt.y);
        THEN
    NONAME] WIN-PASS
;

: win-send-msg ( hwnd -- )
    >R  win-p1 @ win-p2 @ win-p3 @ R> SendMessageA DROP ;

: WIN-MSG ( lpar wpar msgid S" win-pattern" --)
    2>R win-p3 ! win-p2 ! win-p1 ! 2R>
    [NONAME
         WIN-HWND win-send-msg
    NONAME] WIN-PASS
;

: WIN-CHILD-MSG ( lpar wpar msgid S" win-pattern" S" button-pattern" --)
    win-p5 ! win-p4 !
    2>R win-p3 ! win-p2 ! win-p1 ! 2R>
    [NONAME
        win-p4 @ win-p5 @ WIN-HWND WIN-CHILD-EXIST?
        IF
            WIN-CHILD-HWND win-send-msg
        THEN
    NONAME] WIN-PASS
;


: WIN-ACTIVATE ( S" winname" --)
    WIN-EXIST? IF  WIN-HWND PUSH-WINDOW DROP  
                   WIN-HWND IsIconic
                   IF SW_RESTORE WIN-HWND ShowWindow DROP THEN
               THEN ;

( 
: test
    S" MSDN*" WIN-EXIST? IF ." MSDN* exist" CR THEN
    S" Active Su*" WIN-HWND WIN-CHILD-EXIST? IF ." Active Su* exist" CR THEN
    S" *"
    FOR-WINDOWS
        FOUND-WINDOW S" * - Far" WC-COMPARE 0=
        IF
             FOUND-WINDOW TYPE CR
             FOUND-WINDOW WIN-CLOSE
        THEN
    ;FOR-WINDOWS
;
)

