REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE { ~nn/lib/locals.f
REQUIRE /SYSTEMTIME ~nn/lib/time.f
REQUIRE /WIN32_FIND_DATA ~nn/lib/find.f

\ HERE 
: uInt  1 CELLS -- ;
: uLong 2 CELLS -- ;

8 CONSTANT Z_DEFLATED

WINAPI: gzopen ZLIB.DLL     \ filename, mode={"rb/wb"|"wb9"}
WINAPI: gzdopen ZLIB.DLL    \ filehandle, mode
WINAPI: gzclose ZLIB.DLL    \ gzFile
WINAPI: gzread  ZLIB.DLL    \ gzFile, buf, len
WINAPI: gzwrite ZLIB.DLL    \ gzFile, buf, len
\ WINAPI: gzprintf ZLIB.DLL   \ gzFile, *format, ...
WINAPI: gzputs ZLIB.DLL     \   int gzputs(gzFile file, const char *s)
\   Writes the given null-terminated string to the compressed file, excluding
\   the terminating null character.
\   gzputs returns the number of characters written, or -1 in case of error.

WINAPI: gzgets ZLIB.DLL     \ char * gzgets(gzFile file, char *buf, int len)
\   Reads bytes from the compressed file until len-1 characters are read, or
\   a newline character is read and transferred to buf, or an end-of-file
\   condition is encountered.  The string is then terminated with a null
\   character.
\   gzgets returns buf, or Z_NULL in case of error.

\ WINAPI: gzputc ZLIB.DLL     \ int gzputc(gzFile file, int c)
\   Writes c, converted to an unsigned char, into the compressed file.
\   gzputc returns the value that was written, or -1 in case of error.

\ WINAPI: gzgetc ZLIB.DLL     \ int gzgetc(gzFile file)
\   Reads one byte from the compressed file. gzgetc returns this byte
\   or -1 in case of end of file or error.

WINAPI: gzflush ZLIB.DLL    \ int gzflush(gzFile file, int flush)
\   Flushes all pending output into the compressed file. The parameter
\   flush is as in the deflate() function. The return value is the zlib
\   error number (see function gzerror below). gzflush returns Z_OK if
\   the flush parameter is Z_FINISH and all output could be flushed.
\   gzflush should be called only when strictly necessary because it can
\   degrade compression.

\ WINAPI: gzseek ZLIB.DLL     \ z_off_t gzseek(gzFile file, z_off_t offset, int whence)
\   Sets the starting position for the next gzread or gzwrite on the
\   given compressed file. The offset represents a number of bytes in the
\   uncompressed data stream. The whence parameter is defined as in lseek(2);
\   the value SEEK_END is not supported.
\   If the file is opened for reading, this function is emulated but can be
\   extremely slow. If the file is opened for writing, only forward seeks are
\   supported; gzseek then compresses a sequence of zeroes up to the new
\   starting position.
\   gzseek returns the resulting offset location as measured in bytes from
\   the beginning of the uncompressed stream, or -1 in case of error, in
\   particular if the file is opened for writing and the new starting position
\   would be before the current position.

\ WINAPI: gztell ZLIB.DLL     \ (gzFile file)
WINAPI: gzeof ZLIB.DLL      \ (gzFile file)
WINAPI: gzerror ZLIB.DLL    \ (gzFile file, int *errnum)


\ ZIP
0                  \ typedef struct tm_unz_s {
uInt tm_sec  \ uInt tm_sec;  /* seconds after the minute - [0,59] */
uInt tm_min  \ uInt tm_min;  /* minutes after the hour - [0,59] */
uInt tm_hour \ uInt tm_hour; /* hours since midnight - [0,23] */
uInt tm_mday \ uInt tm_mday; /* day of the month - [1,31] */
uInt tm_mon  \ uInt tm_mon;  /* months since January - [0,11] */
uInt tm_year \ uInt tm_year; /* years - [1980..2044] */
CONSTANT /tm_zip   \ } tm_unz;

0                       \ typedef struct {
/tm_zip -- tmz_date     \  date in understandable format           */
uLong zip_dosDate      \  if dos_date == 0, tmu_date is used      */
\ /*    uLong       flag;   \ general purpose bit flag        2 bytes */
uLong zip_internal_fa  \  internal file attributes        2 bytes */
uLong zip_external_fa  \  external file attributes        4 bytes */
CONSTANT /zip_fileinfo  \ } zip_fileinfo;

WINAPI: zipOpen ZLIB.DLL \ zipFile zipOpen(const char *pathname, int append);
WINAPI: zipOpenNewFileInZip zlib.dll  \ int zipOpenNewFileInZip(zipFile file,
                                        \ char* filename,
                                        \ zip_fileinfo* zipfi,
                                        \ void* extrafield_local,
                                        \ uInt size_extrafield_local,
                                        \ void* extrafield_global,
                                        \ uInt size_extrafield_global,
                                        \ char* comment, int method, int level)
WINAPI: zipWriteInFileInZip zlib.dll  \ int zipWriteInFileInZip (zipFile file, 
                                        \ voidp buf, unsigned len)
WINAPI: zipCloseFileInZip zlib.dll    \ int zipCloseFileInZip (zipFile file)
WINAPI: zipClose zlib.dll             \ int zipClose(zipFile file, char* global_comment)

\ UNZIP
0           \ typedef struct unz_global_info_s {
uLong unz_number_entry \  total number of entries in the central dir on this disk */
uLong unz_size_comment     \  size of the global comment of the zipfile */
CONSTANT /unz_global_info \ } unz_global_info;

0 \ typedef struct unz_file_info_s {
uLong unz_version              \ version made by                 2 bytes */
uLong unz_version_needed       \ version needed to extract       2 bytes */
uLong unz_flag                 \ general purpose bit flag        2 bytes */
uLong unz_compression_method   \ compression method              2 bytes */
uLong unz_dosDate              \ last mod file date in Dos fmt   4 bytes */
uLong unz_crc                  \ crc-32                          4 bytes */
uLong unz_compressed_size      \ compressed size                 4 bytes */ 
uLong unz_uncompressed_size    \ uncompressed size               4 bytes */ 
uLong unz_size_filename        \ filename length                 2 bytes */
uLong unz_size_file_extra      \ extra field length              2 bytes */
uLong unz_size_file_comment    \ file comment length             2 bytes */

uLong unz_disk_num_start       \ disk number start               2 bytes */
uLong unz_internal_fa          \ internal file attributes        2 bytes */
uLong unz_external_fa          \ external file attributes        4 bytes */

/tm_zip -- unz_tmu_date
CONSTANT /unz_file_info      \ } unz_file_info;

WINAPI: unzStringFileNameCompare zlib.dll 
                \ int unzStringFileNameCompare (const char* fileName1,
                                               \  const char* fileName2,
                                               \ int iCaseSensitivity);
\   If iCaseSenisivity = 1, comparision is case sensitivity (like strcmp)
\   If iCaseSenisivity = 2, comparision is not case sensitivity (like strcmpi
\                                or strcasecmp)
\   If iCaseSenisivity = 0, case sensitivity is defaut of your operating system
\    (like 1 on Unix, 2 on Windows)

WINAPI: unzOpen zlib.dll    \ unzFile unzOpen(const char *path)
WINAPI: unzClose zlib.dll   \ int unzClose(unzFile file)
WINAPI: unzGetGlobalInfo zlib.dll \ int unzGetGlobalInfo(unzFile file, 
                                  \     unz_global_info *pglobal_info);
WINAPI: unzGetGlobalComment zlib.dll \ int unzGetGlobalComment(unzFile file,
                                     \      char *szComment, uLong uSizeBuf)
WINAPI: unzGoToFirstFile zlib.dll   \ int unzGoToFirstFile(unzFile file)
WINAPI: unzGoToNextFile zlib.dll    \ int unzGoToNextFile(unzFile file)
WINAPI: unzLocateFile zlib.dll  \ int unzLocateFile(unzFile file, char *szFileName,
                                \   int iCaseSensitivity)
WINAPI: unzGetCurrentFileInfo zlib.dll  \ int unzGetCurrentFileInfo(unzFile file,
                                        \     unz_file_info *pfile_info,
                                        \     char *szFileName,
                                        \     uLong fileNameBufferSize,
                                        \     void *extraField,
                                        \     uLong extraFieldBufferSize,
                                        \     char *szComment,
                                        \     uLong commentBufferSize)

WINAPI: unzOpenCurrentFile zlib.dll \ int unzOpenCurrentFile(unzFile file)
WINAPI: unzCloseCurrentFile zlib.dll \ int unzCloseCurrentFile(unzFile file)
WINAPI: unzReadCurrentFile zlib.dll \ int unzReadCurrentFile(unzFile file, 
                                    \   voidp buf, unsigned len)
WINAPI: unztell zlib.dll   \ z_off_t unztell(unzFile file)
WINAPI: unzeof zlib.dll    \ int unzeof(unzFile file)
WINAPI: unzGetLocalExtrafield zlib.dll \ int unzGetLocalExtrafield(unzFile file,
                                       \    voidp buf, unsigned len)

: GZERR { gzFile \ errno -- ior }
    AT errno gzFile gzerror DROP
    errno ;
: ?GZERR ( ? gzFile -- )
    SWAP 0= IF GZERR THROW ELSE DROP THEN ;

WINAPI: GetFileInformationByHandle KERNEL32.DLL

USER-CREATE zip_ftm /SYSTEMTIME USER-ALLOT
USER-CREATE zip_finfo /WIN32_FIND_DATA USER-ALLOT
USER-CREATE zip_ltime 2 CELLS USER-ALLOT
USER-CREATE zinfo /zip_fileinfo USER-ALLOT

: fill_zinfo { zi h -- }
    zi /zip_fileinfo ERASE
    zip_finfo h GetFileInformationByHandle ERR THROW
    zip_finfo dwFileAttributes @ zi zip_internal_fa !
\    zip_finfo ftCreationTime 2@ zi zip_external_fa 2!
    zip_ltime zip_finfo ftLastWriteTime FileTimeToLocalFileTime ERR THROW
    zip_ftm zip_ltime FileTimeToSystemTime ERR THROW
    zip_ftm wYear  W@       zi tm_year !
    zip_ftm wMonth W@ 1-    zi tm_mon !
    zip_ftm wDay   W@       zi tm_mday !
    zip_ftm wHour  W@       zi tm_hour !
    zip_ftm wMinute W@      zi tm_min !
    zip_ftm wSecond W@      zi tm_sec !
    zi zip_dosDate 0!
;

: hzip+ { buf bufsize level azip uzip fzip f -- }
    zinfo f fill_zinfo
    level Z_DEFLATED 0 0 0 0 0 zinfo azip fzip zipOpenNewFileInZip 0=
    IF
        BEGIN buf bufsize f READ-FILE THROW ?DUP WHILE
            buf fzip zipWriteInFileInZip DROP
        REPEAT
        fzip zipCloseFileInZip DROP
    THEN
;

: zip+ ( buf bufsize level azip uzip fzip a u -- )
    R/O OPEN-FILE-SHARED THROW >R
    R@ hzip+
    R> CLOSE-FILE DROP
;

: zipdir+ { level azip uzip fzip a u \ az f -- }
    0 FILE_FLAG_BACKUP_SEMANTICS OPEN_EXISTING 0 3 0 a 
    CreateFileA DUP INVALID_HANDLE_VALUE <>
    IF TO f
        zinfo f fill_zinfo
        f CLOSE-FILE DROP
    ELSE DROP THEN
    \ zinfo /zip_fileinfo ERASE
    azip uzip S" /" S+ DROP TO az
    level Z_DEFLATED 0 0 0 0 0 zinfo az fzip zipOpenNewFileInZip 0=
    IF
        fzip zipCloseFileInZip DROP
    THEN
    az FREE DROP
;


REQUIRE \EOF ~nn/lib/eof.f
\EOF
